// This code conforms with the UFC specification version 2018.1.0
// and was automatically generated by FFC version 2019.2.0.dev0.
//
// This code was generated with the option '-l dolfin' and
// contains DOLFIN-specific wrappers that depend on DOLFIN.
//
// This code was generated with the following parameters:
//

//  add_tabulate_tensor_timing:     False
//  convert_exceptions_to_warnings: False
//  cpp_optimize:                   True
//  cpp_optimize_flags:             '-O2'
//  epsilon:                        1e-14
//  error_control:                  False
//  external_include_dirs:          ''
//  external_includes:              ''
//  external_libraries:             ''
//  external_library_dirs:          ''
//  form_postfix:                   True
//  format:                         'dolfin'
//  generate_dummy_tabulate_tensor: False
//  max_signature_length:           0
//  optimize:                       True
//  precision:                      None
//  quadrature_degree:              None
//  quadrature_rule:                None
//  representation:                 'auto'
//  split:                          False

#ifndef __FORMS_H
#define __FORMS_H
#include <algorithm>
#include <cmath>
#include <iostream>
#include <stdexcept>
#include <ufc.h>

class forms_finite_element_0: public ufc::finite_element
{
public:

  forms_finite_element_0() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FiniteElement('Lagrange', triangle, 1)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 3;
  }

  std::size_t value_rank() const final override
  {
    return 0;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    return 1;
  }

  std::size_t value_size() const final override
  {
    return 1;
  }

  std::size_t reference_value_rank() const final override
  {
    return 0;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    return 1;
  }

  std::size_t reference_value_size() const final override
  {
    return 1;
  }

  std::size_t degree() const final override
  {
    return 1;
  }

  const char * family() const final override
  {
    return "Lagrange";
  }

  void evaluate_reference_basis(double * reference_values,
                                std::size_t num_points,
                                const double * X) const final override
  {
    static const double coefficients0[1][3] = { { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    for (std::size_t k = 0; k < num_points * 3; ++k)
        reference_values[k] = 0.0;
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Accumulate products of coefficients and basisvalues
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[3 * ip] += coefficients0[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[3 * ip + 1] += coefficients1[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[3 * ip + 2] += coefficients2[0][r] * basisvalues1[r];
    }
  }

  void evaluate_reference_basis_derivatives(double * reference_values,
                                            std::size_t order,
                                            std::size_t num_points,
                                            const double * X) const final override
  {
    if (order == 0)
    {
        evaluate_reference_basis(reference_values, num_points, X);
        return;
    }
    const std::size_t num_derivatives = std::pow(2, order);
    std::fill_n(reference_values, num_points * 3 * num_derivatives, 0.0);
    if (order > 1)
        return;
    // Tables of derivatives of the polynomial base (transpose).
    alignas(32) static const double dmats0[2][3][3] =
        { { { 0.0, 0.0, 0.0 },
            { 4.8989794855663495, 0.0, 0.0 },
            { 0.0, 0.0, 0.0 } },
          { { 0.0, 0.0, 0.0 },
            { 2.449489742783182, 0.0, 0.0 },
            { 4.242640687119285, 0.0, 0.0 } } };
    static const double coefficients0[1][3] = { { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    const std::size_t reference_offset[3] = {};
    const std::size_t num_components[3] = { 1, 1, 1 };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Loop over all dofs
        for (std::size_t i = 0; i < 3; ++i)
        {
            double derivatives[2] = {};
            switch (i)
            {
            case 0:
                // Compute reference derivatives for dof 0.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients0[0][s] * aux[s];
                }
                break;
            case 1:
                // Compute reference derivatives for dof 1.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients1[0][s] * aux[s];
                }
                break;
            case 2:
                // Compute reference derivatives for dof 2.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients2[0][s] * aux[s];
                }
                break;
            }
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t c = 0; c < num_components[i]; ++c)
                    reference_values[3 * num_derivatives * ip + num_derivatives * i + r + (reference_offset[i] + c)] = derivatives[num_derivatives * c + r];
        }
    }
  }

  void transform_reference_basis_derivatives(double * values,
                                             std::size_t order,
                                             std::size_t num_points,
                                             const double * reference_values,
                                             const double * X,
                                             const double * J,
                                             const double * detJ,
                                             const double * K,
                                             int cell_orientation) const final override
  {
    const std::size_t num_derivatives = std::pow(2, order);
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    std::fill_n(values, num_points * 3 * num_derivatives, 0.0);
    const std::size_t reference_offsets[3] = {};
    const std::size_t physical_offsets[3] = {};
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        double transform[2][2];
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                transform[r][s] = 1.0;
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                for (std::size_t k = 0; k < order; ++k)
                    transform[r][s] *= K[2 * 2 * ip + 2 * combinations[order - 1][s][k] + combinations[order - 1][r][k]];
        for (std::size_t d = 0; d < 3; ++d)
        {
            for (std::size_t s = 0; s < num_derivatives; ++s)
            {
                for (std::size_t i = 0; i < 1; ++i)
                {
                    // Using affine transform to map values back to the physical element.
                    const double mapped_value = reference_values[3 * num_derivatives * ip + num_derivatives * d + s + reference_offsets[d]];
                    // Mapping derivatives back to the physical element
                    for (std::size_t r = 0; r < num_derivatives; ++r)
                        values[3 * num_derivatives * ip + num_derivatives * d + r + (physical_offsets[d] + i)] += transform[r][s] * mapped_value;
                }
            }
        }
    }
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    double X[2] = {};
    double J[4];
    double detJ;
    double K[4];
    if (cm)
    {
        cm->compute_reference_geometry(X, J, &detJ, K, 1, x, coordinate_dofs, cell_orientation);
    }
    else
    {
        compute_jacobian_triangle_2d(J, coordinate_dofs);
        compute_jacobian_inverse_triangle_2d(K, detJ, J);
        // Compute constants
        const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
        const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
        // Get coordinates and map to the reference (FIAT) element
        double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
        // Map to FFC reference coordinate
        for (std::size_t k = 0; k < 2; ++k)
            X[k] = (Y[k] + 1.0) / 2.0;
    }
    // Evaluate basis on reference element
    double ref_values[3];
    evaluate_reference_basis(ref_values, 1, X);
    // Push forward
    double physical_values[3];
    transform_reference_basis_derivatives(physical_values, 0, 1, ref_values, X, J, &detJ, K, cell_orientation);
    for (std::size_t k = 0; k < 1; ++k)
        values[k] = physical_values[i + k];
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation,
                          const ufc::coordinate_mapping * cm=nullptr
                          ) const final override
  {
    // Helper variable to hold value of a single dof.
    double dof_values = 0.0;
    // Loop dofs and call evaluate_basis
    for (std::size_t r = 0; r < 3; ++r)
    {
        evaluate_basis(r, &dof_values, x, coordinate_dofs, cell_orientation);
        values[r] = dof_values;
    }
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::coordinate_mapping * cm=nullptr
                                  ) const final override
  {
    std::size_t num_derivatives = std::pow(2, n);
    std::fill_n(values, num_derivatives, 0.0);
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
        return;
    }
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    // Get coordinates and map to the reference (FIAT) element
    double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    // Declare transformation matrix
    double transform[2][2] =
        { { 1.0, 1.0 },
          { 1.0, 1.0 } };
    // Construct transformation matrix
    for (std::size_t row = 0; row < num_derivatives; ++row)
        for (std::size_t col = 0; col < num_derivatives; ++col)
            for (std::size_t k = 0; k < n; ++k)
                transform[row][col] *= K[2 * combinations[n - 1][col][k] + combinations[n - 1][row][k]];
    switch (i)
    {
    case 0:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 1:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 2:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, 0.0, 0.3333333333333333 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    }
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation,
                                      const ufc::coordinate_mapping * cm=nullptr
                                      ) const final override
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
        return;
    }
    unsigned int num_derivatives = std::pow(2, n);
    // Set values equal to zero.
    std::fill_n(values, num_derivatives * 3, 0.0);
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {};
    // Loop dofs and call evaluate_basis_derivatives.
    for (std::size_t r = 0; r < 3; ++r)
    {
        evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < num_derivatives; ++s)
            values[num_derivatives * r + s] = dof_values[s];
    }
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    // Declare variables for result of evaluation
    double vals[1];
    // Declare variable for physical coordinates
    double y[2];
    switch (i)
    {
    case 0:
        {
            y[0] = coordinate_dofs[0];
            y[1] = coordinate_dofs[1];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 1:
        {
            y[0] = coordinate_dofs[2];
            y[1] = coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 2:
        {
            y[0] = coordinate_dofs[4];
            y[1] = coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    }
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c,
                             const ufc::coordinate_mapping * cm=nullptr
                             ) const final override
  {
    // Declare variables for result of evaluation
    double vals[1];
    // Declare variable for physical coordinates
    double y[2];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[0] = vals[0];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[1] = vals[0];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = vals[0];
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::coordinate_mapping * cm=nullptr
                                 ) const final override
  {
    // Evaluate function and change variables
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[1];
    vertex_values[2] = dof_values[2];
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs,
                                const ufc::coordinate_mapping * cm=nullptr
                                ) const final override
  {
    dof_coordinates[0] = coordinate_dofs[0];
    dof_coordinates[1] = coordinate_dofs[1];
    dof_coordinates[2] = coordinate_dofs[2];
    dof_coordinates[2 + 1] = coordinate_dofs[3];
    dof_coordinates[2 * 2] = coordinate_dofs[4];
    dof_coordinates[2 * 2 + 1] = coordinate_dofs[5];
  }

  void tabulate_reference_dof_coordinates(double * reference_dof_coordinates) const final override
  {
    static const double dof_X[6] = { 0.0, 0.0, 1.0, 0.0, 0.0, 1.0 };
    std::copy_n(dof_X, 6, reference_dof_coordinates);
  }

  std::size_t num_sub_elements() const final override
  {
    return 0;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_0();
  }

};


class forms_finite_element_1: public ufc::finite_element
{
public:

  forms_finite_element_1() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 6;
  }

  std::size_t value_rank() const final override
  {
    return 1;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t value_size() const final override
  {
    return 2;
  }

  std::size_t reference_value_rank() const final override
  {
    return 1;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t reference_value_size() const final override
  {
    return 2;
  }

  std::size_t degree() const final override
  {
    return 1;
  }

  const char * family() const final override
  {
    return "Lagrange";
  }

  void evaluate_reference_basis(double * reference_values,
                                std::size_t num_points,
                                const double * X) const final override
  {
    static const double coefficients0[1][3] = { { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    for (std::size_t k = 0; k < num_points * 6 * 2; ++k)
        reference_values[k] = 0.0;
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Accumulate products of coefficients and basisvalues
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip] += coefficients0[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2] += coefficients1[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 2] += coefficients2[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 3 + 1] += coefficients0[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 4 + 1] += coefficients1[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 5 + 1] += coefficients2[0][r] * basisvalues1[r];
    }
  }

  void evaluate_reference_basis_derivatives(double * reference_values,
                                            std::size_t order,
                                            std::size_t num_points,
                                            const double * X) const final override
  {
    if (order == 0)
    {
        evaluate_reference_basis(reference_values, num_points, X);
        return;
    }
    const std::size_t num_derivatives = std::pow(2, order);
    std::fill_n(reference_values, num_points * 6 * num_derivatives * 2, 0.0);
    if (order > 1)
        return;
    // Tables of derivatives of the polynomial base (transpose).
    alignas(32) static const double dmats0[2][3][3] =
        { { { 0.0, 0.0, 0.0 },
            { 4.8989794855663495, 0.0, 0.0 },
            { 0.0, 0.0, 0.0 } },
          { { 0.0, 0.0, 0.0 },
            { 2.449489742783182, 0.0, 0.0 },
            { 4.242640687119285, 0.0, 0.0 } } };
    static const double coefficients0[1][3] = { { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    const std::size_t reference_offset[6] = { 0, 0, 0, 1, 1, 1 };
    const std::size_t num_components[6] = { 1, 1, 1, 1, 1, 1 };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Loop over all dofs
        for (std::size_t i = 0; i < 6; ++i)
        {
            double derivatives[2] = {};
            switch (i)
            {
            case 0:
                // Compute reference derivatives for dof 0.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients0[0][s] * aux[s];
                }
                break;
            case 1:
                // Compute reference derivatives for dof 1.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients1[0][s] * aux[s];
                }
                break;
            case 2:
                // Compute reference derivatives for dof 2.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients2[0][s] * aux[s];
                }
                break;
            case 3:
                // Compute reference derivatives for dof 3.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients0[0][s] * aux[s];
                }
                break;
            case 4:
                // Compute reference derivatives for dof 4.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients1[0][s] * aux[s];
                }
                break;
            case 5:
                // Compute reference derivatives for dof 5.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients2[0][s] * aux[s];
                }
                break;
            }
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t c = 0; c < num_components[i]; ++c)
                    reference_values[6 * (num_derivatives * 2) * ip + num_derivatives * 2 * i + 2 * r + (reference_offset[i] + c)] = derivatives[num_derivatives * c + r];
        }
    }
  }

  void transform_reference_basis_derivatives(double * values,
                                             std::size_t order,
                                             std::size_t num_points,
                                             const double * reference_values,
                                             const double * X,
                                             const double * J,
                                             const double * detJ,
                                             const double * K,
                                             int cell_orientation) const final override
  {
    const std::size_t num_derivatives = std::pow(2, order);
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    std::fill_n(values, num_points * 6 * num_derivatives * 2, 0.0);
    const std::size_t reference_offsets[6] = { 0, 0, 0, 1, 1, 1 };
    const std::size_t physical_offsets[6] = { 0, 0, 0, 1, 1, 1 };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        double transform[2][2];
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                transform[r][s] = 1.0;
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                for (std::size_t k = 0; k < order; ++k)
                    transform[r][s] *= K[2 * 2 * ip + 2 * combinations[order - 1][s][k] + combinations[order - 1][r][k]];
        for (std::size_t d = 0; d < 6; ++d)
        {
            for (std::size_t s = 0; s < num_derivatives; ++s)
            {
                for (std::size_t i = 0; i < 1; ++i)
                {
                    // Using affine transform to map values back to the physical element.
                    const double mapped_value = reference_values[6 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * s + reference_offsets[d]];
                    // Mapping derivatives back to the physical element
                    for (std::size_t r = 0; r < num_derivatives; ++r)
                        values[6 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * r + (physical_offsets[d] + i)] += transform[r][s] * mapped_value;
                }
            }
        }
    }
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    double X[2] = {};
    double J[4];
    double detJ;
    double K[4];
    if (cm)
    {
        cm->compute_reference_geometry(X, J, &detJ, K, 1, x, coordinate_dofs, cell_orientation);
    }
    else
    {
        compute_jacobian_triangle_2d(J, coordinate_dofs);
        compute_jacobian_inverse_triangle_2d(K, detJ, J);
        // Compute constants
        const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
        const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
        // Get coordinates and map to the reference (FIAT) element
        double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
        // Map to FFC reference coordinate
        for (std::size_t k = 0; k < 2; ++k)
            X[k] = (Y[k] + 1.0) / 2.0;
    }
    // Evaluate basis on reference element
    double ref_values[12];
    evaluate_reference_basis(ref_values, 1, X);
    // Push forward
    double physical_values[12];
    transform_reference_basis_derivatives(physical_values, 0, 1, ref_values, X, J, &detJ, K, cell_orientation);
    for (std::size_t k = 0; k < 2; ++k)
        values[k] = physical_values[2 * i + k];
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation,
                          const ufc::coordinate_mapping * cm=nullptr
                          ) const final override
  {
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {};
    // Loop dofs and call evaluate_basis
    for (std::size_t r = 0; r < 6; ++r)
    {
        evaluate_basis(r, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2; ++s)
            values[r * 2 + s] = dof_values[s];
    }
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::coordinate_mapping * cm=nullptr
                                  ) const final override
  {
    std::size_t num_derivatives = std::pow(2, n);
    std::fill_n(values, 2 * num_derivatives, 0.0);
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
        return;
    }
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    // Get coordinates and map to the reference (FIAT) element
    double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    // Declare transformation matrix
    double transform[2][2] =
        { { 1.0, 1.0 },
          { 1.0, 1.0 } };
    // Construct transformation matrix
    for (std::size_t row = 0; row < num_derivatives; ++row)
        for (std::size_t col = 0; col < num_derivatives; ++col)
            for (std::size_t k = 0; k < n; ++k)
                transform[row][col] *= K[2 * combinations[n - 1][col][k] + combinations[n - 1][row][k]];
    switch (i)
    {
    case 0:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 1:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 2:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, 0.0, 0.3333333333333333 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 3:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[num_derivatives + r] += transform[r][s] * derivatives[s];
        }
        break;
    case 4:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[num_derivatives + r] += transform[r][s] * derivatives[s];
        }
        break;
    case 5:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, 0.0, 0.3333333333333333 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[num_derivatives + r] += transform[r][s] * derivatives[s];
        }
        break;
    }
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation,
                                      const ufc::coordinate_mapping * cm=nullptr
                                      ) const final override
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
        return;
    }
    unsigned int num_derivatives = std::pow(2, n);
    // Set values equal to zero.
    std::fill_n(values, 2 * num_derivatives * 6, 0.0);
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Helper variable to hold values of a single dof.
    double dof_values[4] = {};
    // Loop dofs and call evaluate_basis_derivatives.
    for (std::size_t r = 0; r < 6; ++r)
    {
        evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2 * num_derivatives; ++s)
            values[2 * num_derivatives * r + s] = dof_values[s];
    }
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    switch (i)
    {
    case 0:
        {
            y[0] = coordinate_dofs[0];
            y[1] = coordinate_dofs[1];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 1:
        {
            y[0] = coordinate_dofs[2];
            y[1] = coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 2:
        {
            y[0] = coordinate_dofs[4];
            y[1] = coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 3:
        {
            y[0] = coordinate_dofs[0];
            y[1] = coordinate_dofs[1];
            f.evaluate(vals, y, c);
            return vals[1];
        }
        break;
    case 4:
        {
            y[0] = coordinate_dofs[2];
            y[1] = coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[1];
        }
        break;
    case 5:
        {
            y[0] = coordinate_dofs[4];
            y[1] = coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[1];
        }
        break;
    }
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c,
                             const ufc::coordinate_mapping * cm=nullptr
                             ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[0] = vals[0];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[1] = vals[0];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = vals[0];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[3] = vals[1];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[4] = vals[1];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[5] = vals[1];
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::coordinate_mapping * cm=nullptr
                                 ) const final override
  {
    // Evaluate function and change variables
    vertex_values[0] = dof_values[0];
    vertex_values[2] = dof_values[1];
    vertex_values[4] = dof_values[2];
    // Evaluate function and change variables
    vertex_values[1] = dof_values[3];
    vertex_values[3] = dof_values[4];
    vertex_values[5] = dof_values[5];
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs,
                                const ufc::coordinate_mapping * cm=nullptr
                                ) const final override
  {
    dof_coordinates[0] = coordinate_dofs[0];
    dof_coordinates[1] = coordinate_dofs[1];
    dof_coordinates[2] = coordinate_dofs[2];
    dof_coordinates[2 + 1] = coordinate_dofs[3];
    dof_coordinates[2 * 2] = coordinate_dofs[4];
    dof_coordinates[2 * 2 + 1] = coordinate_dofs[5];
    dof_coordinates[2 * 3] = coordinate_dofs[0];
    dof_coordinates[2 * 3 + 1] = coordinate_dofs[1];
    dof_coordinates[2 * 4] = coordinate_dofs[2];
    dof_coordinates[2 * 4 + 1] = coordinate_dofs[3];
    dof_coordinates[2 * 5] = coordinate_dofs[4];
    dof_coordinates[2 * 5 + 1] = coordinate_dofs[5];
  }

  void tabulate_reference_dof_coordinates(double * reference_dof_coordinates) const final override
  {
    static const double dof_X[12] = { 0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 1.0 };
    std::copy_n(dof_X, 12, reference_dof_coordinates);
  }

  std::size_t num_sub_elements() const final override
  {
    return 2;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_finite_element_0();
    case 1:
        return new forms_finite_element_0();
    default:
        return nullptr;
    }
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_1();
  }

};


class forms_finite_element_2: public ufc::finite_element
{
public:

  forms_finite_element_2() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_2() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FiniteElement('Nedelec 1st kind H(curl)', triangle, 3)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 15;
  }

  std::size_t value_rank() const final override
  {
    return 1;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t value_size() const final override
  {
    return 2;
  }

  std::size_t reference_value_rank() const final override
  {
    return 1;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t reference_value_size() const final override
  {
    return 2;
  }

  std::size_t degree() const final override
  {
    return 3;
  }

  const char * family() const final override
  {
    return "Nedelec 1st kind H(curl)";
  }

  void evaluate_reference_basis(double * reference_values,
                                std::size_t num_points,
                                const double * X) const final override
  {
    static const double coefficients0[2][10] =
        { { 0.0, 0.0, 0.0, -0.16953317256112307, 0.08417937871268429, -0.11664236870396073, 0.0, -0.1468200342221035, 0.07290148043997553, -0.10101525445522078 },
          { 0.0, 0.0, 0.0, 0.3216783274236693, -0.13468700594029484, 0.09720197391996728, 0.26057971086461407, -0.12987926104263006, 0.09768798378956725, -0.06313453403451312 } };
    static const double coefficients1[2][10] =
        { { 0.0, 0.0, 0.0, 0.07824607964359528, -0.1683587574253686, 0.3499271061118826, 0.0, 0.06776309271789388, -0.14580296087995126, 0.30304576336566286 },
          { 0.0, 0.0, 0.0, -0.1651861681364791, 0.23570226039551592, -0.2721655269759085, -0.12026755886059112, 0.1468200342221037, -0.22453655975512465, 0.17677669529663712 } };
    static const double coefficients2[2][10] =
        { { 0.0, 0.0, 0.0, -0.039123039821797864, -0.08417937871268387, -0.3499271061118829, 0.0, -0.033881546358947065, -0.07290148043997526, -0.3030457633656632 },
          { 0.0, 0.0, 0.0, 0.06085806194501876, 0.0, 0.2138443426239286, 0.06013377943029531, 0.03952847075210475, 0.11226827987756237, -0.1388959748759294 } };
    static const double coefficients3[2][10] =
        { { 0.0, 0.0, 0.0, 0.1695331725611228, 0.08417937871268408, 0.11664236870396065, 0.0, 0.14682003422210343, 0.0729014804399755, 0.10101525445522103 },
          { 0.0, 0.0, 0.0, 0.4912114999847918, 0.21886638465297908, 0.21384434262392818, -0.26057971086461373, 0.01694077317947336, -0.024786503349591805, 0.037880720420708 } };
    static const double coefficients4[2][10] =
        { { 0.0, 0.0, 0.0, -0.07824607964359535, -0.16835875742536788, -0.3499271061118827, 0.0, -0.06776309271789412, -0.14580296087995076, -0.3030457633656633 },
          { 0.0, 0.0, 0.0, -0.24343224778007416, -0.4040610178208842, -0.6220926330877907, 0.12026755886059087, 0.07905694150420953, 0.07873359887517378, -0.12626906806902685 } };
    static const double coefficients5[2][10] =
        { { 0.0, 0.0, 0.0, 0.0391230398217977, -0.08417937871268437, 0.34992710611188266, 0.0, 0.03388154635894702, -0.07290148043997563, 0.3030457633656632 },
          { 0.0, 0.0, 0.0, 0.09998110176681592, -0.08417937871268426, 0.5637714487358105, -0.06013377943029553, 0.07341001711105186, -0.18516976031753793, 0.16414978848973463 } };
    static const double coefficients6[2][10] =
        { { 0.0, 0.0, 0.0, 0.38253638936868695, 0.3030457633656637, 0.31104631654389564, 0.0, -0.09035079029052531, -0.14580296087995076, -0.20203050891044225 },
          { 0.0, 0.0, 0.0, 0.16953317256112252, 0.08417937871268436, 0.1166423687039613, 0.16035674514745427, 0.06776309271789402, 0.03207665139358942, -0.07576144084141614 } };
    static const double coefficients7[2][10] =
        { { 0.0, 0.0, 0.0, -0.7650727787373746, 0.0, -0.15552315827194815, 0.0, 0.18070158058105026, 0.0, 0.10101525445522086 },
          { 0.0, 0.0, 0.0, -0.3825363893686869, 0.0673435029701474, -0.07776157913597405, -0.320713490294909, 0.09035079029052528, -0.06415330278717868, 0.05050762722761055 } };
    static const double coefficients8[2][10] =
        { { 0.0, 0.0, 0.0, 0.38253638936868734, -0.30304576336566347, 0.3110463165438961, 0.0, -0.09035079029052503, 0.14580296087995126, -0.20203050891044194 },
          { 0.0, 0.0, 0.0, 0.2130032168075649, -0.2188663846529792, 0.1944039478399349, 0.16035674514745463, -0.1581138830084193, 0.17787961227354043, -0.1262690680690265 } };
    static const double coefficients9[2][10] =
        { { 3.999999999999999, 0.0, 0.0, -0.36885555678165866, -0.4761904761904767, -1.6495721976846447, 0.0, -0.3194382824999701, -0.41239304942116095, 0.5714285714285707 },
          { 0.0, 0.0, 0.0, 0.6147592613027625, 0.4761904761904761, -0.5498573992282143, 0.5669467095138403, 0.15971914124998543, -0.4536323543632769, 0.35714285714285765 } };
    static const double coefficients10[2][10] =
        { { 0.0, 3.999999999999998, 0.0, -0.6776309271789392, 1.8079567149113938, 0.0, 0.0, -0.5868455973269648, -1.2626906806902618, 0.0 },
          { 0.0, 0.0, 0.0, 1.0540925533894563, 1.1664236870396083, -0.3367175148507352, 1.0415476122441192, 0.6846531968814589, -0.5808377131175202, 0.2187044413199259 } };
    static const double coefficients11[2][10] =
        { { 0.0, 0.0, 3.9999999999999996, 0.1304101327393234, -0.8417937871268395, 0.9331389496316848, 0.0, 0.11293848786315575, -0.7290148043997535, -2.020305089104422 },
          { 0.0, 0.0, 0.0, -0.34776035397153254, 0.33671751485073853, 1.360827634879546, -0.2004459314343202, 0.6211616832473611, 0.5977921396077999, -0.8838834764831877 } };
    static const double coefficients12[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 0.9523809523809513, 0.0, 0.0, 0.0, 0.8247860988423221, 0.0 },
          { 4.000000000000002, 0.0, 0.0, -1.5983740793871866, 0.47619047619047594, -0.5498573992282156, 0.0, -0.6388765649999416, 0.41239304942116095, -0.14285714285714243 } };
    static const double coefficients13[2][10] =
        { { 0.0, 0.0, 0.0, 1.3552618543578767, 0.0, 0.0, 0.0, 1.1736911946539275, 0.0, 0.0 },
          { 0.0, 3.999999999999997, 0.0, 0.6776309271789389, -0.5248906591678227, 0.0, -2.0830952244882406, 0.5868455973269635, -0.10101525445522164, 0.0 } };
    static const double coefficients14[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 1.6835875742536832, 0.0, 0.0, 0.0, 1.4580296087995102, 0.0 },
          { 0.0, 0.0, 3.9999999999999996, 0.8259308406823948, 0.8417937871268429, -1.7885163201274026, 0.0, -1.1293848786315666, 0.7290148043997547, -0.25253813613805154 } };
    for (std::size_t k = 0; k < num_points * 15 * 2; ++k)
        reference_values[k] = 0.0;
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues3[10] = {};
        basisvalues3[0] = 1.0;
        const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues3[1] = tmp1_3;
        const double tmp2_3 = (1.0 - Y[1]) / 2.0;
        const double tmp3_3 = tmp2_3 * tmp2_3;
        basisvalues3[3] = 1.5 * tmp1_3 * basisvalues3[1] - 0.5 * tmp3_3 * basisvalues3[0];
        basisvalues3[6] = 1.6666666666666667 * tmp1_3 * basisvalues3[3] - 0.6666666666666666 * tmp3_3 * basisvalues3[1];
        basisvalues3[2] = (0.5 + 1.5 * Y[1]) * basisvalues3[0];
        basisvalues3[4] = (1.5 + 2.5 * Y[1]) * basisvalues3[1];
        basisvalues3[7] = (2.5 + 3.5 * Y[1]) * basisvalues3[3];
        basisvalues3[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues3[2] - 0.5555555555555556 * basisvalues3[0];
        basisvalues3[9] = (0.05 + 1.75 * Y[1]) * basisvalues3[5] - 0.7 * basisvalues3[2];
        basisvalues3[8] = (0.54 + 2.1 * Y[1]) * basisvalues3[4] - 0.56 * basisvalues3[1];
        basisvalues3[0] *= std::sqrt(0.5);
        basisvalues3[2] *= std::sqrt(1.0);
        basisvalues3[5] *= std::sqrt(1.5);
        basisvalues3[9] *= std::sqrt(2.0);
        basisvalues3[1] *= std::sqrt(3.0);
        basisvalues3[4] *= std::sqrt(4.5);
        basisvalues3[8] *= std::sqrt(6.0);
        basisvalues3[3] *= std::sqrt(7.5);
        basisvalues3[7] *= std::sqrt(10.0);
        basisvalues3[6] *= std::sqrt(14.0);
        // Accumulate products of coefficients and basisvalues
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + c] += coefficients0[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 + c] += coefficients1[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 2 + c] += coefficients2[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 3 + c] += coefficients3[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 4 + c] += coefficients4[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 5 + c] += coefficients5[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 6 + c] += coefficients6[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 7 + c] += coefficients7[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 8 + c] += coefficients8[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 9 + c] += coefficients9[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 10 + c] += coefficients10[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 11 + c] += coefficients11[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 12 + c] += coefficients12[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 13 + c] += coefficients13[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 14 + c] += coefficients14[c][r] * basisvalues3[r];
    }
  }

  void evaluate_reference_basis_derivatives(double * reference_values,
                                            std::size_t order,
                                            std::size_t num_points,
                                            const double * X) const final override
  {
    if (order == 0)
    {
        evaluate_reference_basis(reference_values, num_points, X);
        return;
    }
    const std::size_t num_derivatives = std::pow(2, order);
    std::fill_n(reference_values, num_points * 15 * num_derivatives * 2, 0.0);
    if (order > 3)
        return;
    // Tables of derivatives of the polynomial base (transpose).
    alignas(32) static const double dmats0[2][10][10] =
        { { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 5.291502622129191, 0.0, -2.9933259094191618, 13.66260102127946, 0.0, 0.6110100926607813, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 4.381780460041337, 0.0, 0.0, 12.521980673998826, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 3.4641016151377553, 0.0, 7.83836717690618, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } },
          { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 2.581988897471623, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 1.9999999999999165, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 2.645751311064574, 5.184592558726257, -1.4966629547095676, 6.8313005106397275, -1.0583005244258339, 0.30550504633038966, 0.0, 0.0, 0.0, 0.0 },
            { 2.2360679774998236, 2.190890230020675, 2.5298221281346818, 8.082903768654774, 6.2609903369994075, -1.8073922282301216, 0.0, 0.0, 0.0, 0.0 },
            { 1.7320508075688763, -5.091168824543143, 3.9191835884531003, 0.0, 9.699484522385694, 4.200000000000011, 0.0, 0.0, 0.0, 0.0 },
            { 5.000000000000024, 0.0, -2.8284271247462303, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } } };
    static const double coefficients0[2][10] =
        { { 0.0, 0.0, 0.0, -0.16953317256112307, 0.08417937871268429, -0.11664236870396073, 0.0, -0.1468200342221035, 0.07290148043997553, -0.10101525445522078 },
          { 0.0, 0.0, 0.0, 0.3216783274236693, -0.13468700594029484, 0.09720197391996728, 0.26057971086461407, -0.12987926104263006, 0.09768798378956725, -0.06313453403451312 } };
    static const double coefficients1[2][10] =
        { { 0.0, 0.0, 0.0, 0.07824607964359528, -0.1683587574253686, 0.3499271061118826, 0.0, 0.06776309271789388, -0.14580296087995126, 0.30304576336566286 },
          { 0.0, 0.0, 0.0, -0.1651861681364791, 0.23570226039551592, -0.2721655269759085, -0.12026755886059112, 0.1468200342221037, -0.22453655975512465, 0.17677669529663712 } };
    static const double coefficients2[2][10] =
        { { 0.0, 0.0, 0.0, -0.039123039821797864, -0.08417937871268387, -0.3499271061118829, 0.0, -0.033881546358947065, -0.07290148043997526, -0.3030457633656632 },
          { 0.0, 0.0, 0.0, 0.06085806194501876, 0.0, 0.2138443426239286, 0.06013377943029531, 0.03952847075210475, 0.11226827987756237, -0.1388959748759294 } };
    static const double coefficients3[2][10] =
        { { 0.0, 0.0, 0.0, 0.1695331725611228, 0.08417937871268408, 0.11664236870396065, 0.0, 0.14682003422210343, 0.0729014804399755, 0.10101525445522103 },
          { 0.0, 0.0, 0.0, 0.4912114999847918, 0.21886638465297908, 0.21384434262392818, -0.26057971086461373, 0.01694077317947336, -0.024786503349591805, 0.037880720420708 } };
    static const double coefficients4[2][10] =
        { { 0.0, 0.0, 0.0, -0.07824607964359535, -0.16835875742536788, -0.3499271061118827, 0.0, -0.06776309271789412, -0.14580296087995076, -0.3030457633656633 },
          { 0.0, 0.0, 0.0, -0.24343224778007416, -0.4040610178208842, -0.6220926330877907, 0.12026755886059087, 0.07905694150420953, 0.07873359887517378, -0.12626906806902685 } };
    static const double coefficients5[2][10] =
        { { 0.0, 0.0, 0.0, 0.0391230398217977, -0.08417937871268437, 0.34992710611188266, 0.0, 0.03388154635894702, -0.07290148043997563, 0.3030457633656632 },
          { 0.0, 0.0, 0.0, 0.09998110176681592, -0.08417937871268426, 0.5637714487358105, -0.06013377943029553, 0.07341001711105186, -0.18516976031753793, 0.16414978848973463 } };
    static const double coefficients6[2][10] =
        { { 0.0, 0.0, 0.0, 0.38253638936868695, 0.3030457633656637, 0.31104631654389564, 0.0, -0.09035079029052531, -0.14580296087995076, -0.20203050891044225 },
          { 0.0, 0.0, 0.0, 0.16953317256112252, 0.08417937871268436, 0.1166423687039613, 0.16035674514745427, 0.06776309271789402, 0.03207665139358942, -0.07576144084141614 } };
    static const double coefficients7[2][10] =
        { { 0.0, 0.0, 0.0, -0.7650727787373746, 0.0, -0.15552315827194815, 0.0, 0.18070158058105026, 0.0, 0.10101525445522086 },
          { 0.0, 0.0, 0.0, -0.3825363893686869, 0.0673435029701474, -0.07776157913597405, -0.320713490294909, 0.09035079029052528, -0.06415330278717868, 0.05050762722761055 } };
    static const double coefficients8[2][10] =
        { { 0.0, 0.0, 0.0, 0.38253638936868734, -0.30304576336566347, 0.3110463165438961, 0.0, -0.09035079029052503, 0.14580296087995126, -0.20203050891044194 },
          { 0.0, 0.0, 0.0, 0.2130032168075649, -0.2188663846529792, 0.1944039478399349, 0.16035674514745463, -0.1581138830084193, 0.17787961227354043, -0.1262690680690265 } };
    static const double coefficients9[2][10] =
        { { 3.999999999999999, 0.0, 0.0, -0.36885555678165866, -0.4761904761904767, -1.6495721976846447, 0.0, -0.3194382824999701, -0.41239304942116095, 0.5714285714285707 },
          { 0.0, 0.0, 0.0, 0.6147592613027625, 0.4761904761904761, -0.5498573992282143, 0.5669467095138403, 0.15971914124998543, -0.4536323543632769, 0.35714285714285765 } };
    static const double coefficients10[2][10] =
        { { 0.0, 3.999999999999998, 0.0, -0.6776309271789392, 1.8079567149113938, 0.0, 0.0, -0.5868455973269648, -1.2626906806902618, 0.0 },
          { 0.0, 0.0, 0.0, 1.0540925533894563, 1.1664236870396083, -0.3367175148507352, 1.0415476122441192, 0.6846531968814589, -0.5808377131175202, 0.2187044413199259 } };
    static const double coefficients11[2][10] =
        { { 0.0, 0.0, 3.9999999999999996, 0.1304101327393234, -0.8417937871268395, 0.9331389496316848, 0.0, 0.11293848786315575, -0.7290148043997535, -2.020305089104422 },
          { 0.0, 0.0, 0.0, -0.34776035397153254, 0.33671751485073853, 1.360827634879546, -0.2004459314343202, 0.6211616832473611, 0.5977921396077999, -0.8838834764831877 } };
    static const double coefficients12[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 0.9523809523809513, 0.0, 0.0, 0.0, 0.8247860988423221, 0.0 },
          { 4.000000000000002, 0.0, 0.0, -1.5983740793871866, 0.47619047619047594, -0.5498573992282156, 0.0, -0.6388765649999416, 0.41239304942116095, -0.14285714285714243 } };
    static const double coefficients13[2][10] =
        { { 0.0, 0.0, 0.0, 1.3552618543578767, 0.0, 0.0, 0.0, 1.1736911946539275, 0.0, 0.0 },
          { 0.0, 3.999999999999997, 0.0, 0.6776309271789389, -0.5248906591678227, 0.0, -2.0830952244882406, 0.5868455973269635, -0.10101525445522164, 0.0 } };
    static const double coefficients14[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 1.6835875742536832, 0.0, 0.0, 0.0, 1.4580296087995102, 0.0 },
          { 0.0, 0.0, 3.9999999999999996, 0.8259308406823948, 0.8417937871268429, -1.7885163201274026, 0.0, -1.1293848786315666, 0.7290148043997547, -0.25253813613805154 } };
    const std::size_t reference_offset[15] = {};
    const std::size_t num_components[15] = { 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2 };
    // Precomputed combinations
    const std::size_t combinations[3][8][3] =
        { { { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 } },
          { { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 },
            { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 } },
          { { 0, 0, 0 },
            { 0, 0, 1 },
            { 0, 1, 0 },
            { 0, 1, 1 },
            { 1, 0, 0 },
            { 1, 0, 1 },
            { 1, 1, 0 },
            { 1, 1, 1 } } };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues3[10] = {};
        basisvalues3[0] = 1.0;
        const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues3[1] = tmp1_3;
        const double tmp2_3 = (1.0 - Y[1]) / 2.0;
        const double tmp3_3 = tmp2_3 * tmp2_3;
        basisvalues3[3] = 1.5 * tmp1_3 * basisvalues3[1] - 0.5 * tmp3_3 * basisvalues3[0];
        basisvalues3[6] = 1.6666666666666667 * tmp1_3 * basisvalues3[3] - 0.6666666666666666 * tmp3_3 * basisvalues3[1];
        basisvalues3[2] = (0.5 + 1.5 * Y[1]) * basisvalues3[0];
        basisvalues3[4] = (1.5 + 2.5 * Y[1]) * basisvalues3[1];
        basisvalues3[7] = (2.5 + 3.5 * Y[1]) * basisvalues3[3];
        basisvalues3[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues3[2] - 0.5555555555555556 * basisvalues3[0];
        basisvalues3[9] = (0.05 + 1.75 * Y[1]) * basisvalues3[5] - 0.7 * basisvalues3[2];
        basisvalues3[8] = (0.54 + 2.1 * Y[1]) * basisvalues3[4] - 0.56 * basisvalues3[1];
        basisvalues3[0] *= std::sqrt(0.5);
        basisvalues3[2] *= std::sqrt(1.0);
        basisvalues3[5] *= std::sqrt(1.5);
        basisvalues3[9] *= std::sqrt(2.0);
        basisvalues3[1] *= std::sqrt(3.0);
        basisvalues3[4] *= std::sqrt(4.5);
        basisvalues3[8] *= std::sqrt(6.0);
        basisvalues3[3] *= std::sqrt(7.5);
        basisvalues3[7] *= std::sqrt(10.0);
        basisvalues3[6] *= std::sqrt(14.0);
        // Loop over all dofs
        for (std::size_t i = 0; i < 15; ++i)
        {
            double derivatives[16] = {};
            switch (i)
            {
            case 0:
                // Compute reference derivatives for dof 0.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients0[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients0[1][s] * aux[s];
                    }
                }
                break;
            case 1:
                // Compute reference derivatives for dof 1.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients1[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients1[1][s] * aux[s];
                    }
                }
                break;
            case 2:
                // Compute reference derivatives for dof 2.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients2[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients2[1][s] * aux[s];
                    }
                }
                break;
            case 3:
                // Compute reference derivatives for dof 3.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients3[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients3[1][s] * aux[s];
                    }
                }
                break;
            case 4:
                // Compute reference derivatives for dof 4.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients4[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients4[1][s] * aux[s];
                    }
                }
                break;
            case 5:
                // Compute reference derivatives for dof 5.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients5[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients5[1][s] * aux[s];
                    }
                }
                break;
            case 6:
                // Compute reference derivatives for dof 6.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients6[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients6[1][s] * aux[s];
                    }
                }
                break;
            case 7:
                // Compute reference derivatives for dof 7.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients7[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients7[1][s] * aux[s];
                    }
                }
                break;
            case 8:
                // Compute reference derivatives for dof 8.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients8[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients8[1][s] * aux[s];
                    }
                }
                break;
            case 9:
                // Compute reference derivatives for dof 9.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients9[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients9[1][s] * aux[s];
                    }
                }
                break;
            case 10:
                // Compute reference derivatives for dof 10.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients10[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients10[1][s] * aux[s];
                    }
                }
                break;
            case 11:
                // Compute reference derivatives for dof 11.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients11[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients11[1][s] * aux[s];
                    }
                }
                break;
            case 12:
                // Compute reference derivatives for dof 12.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients12[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients12[1][s] * aux[s];
                    }
                }
                break;
            case 13:
                // Compute reference derivatives for dof 13.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients13[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients13[1][s] * aux[s];
                    }
                }
                break;
            case 14:
                // Compute reference derivatives for dof 14.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients14[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients14[1][s] * aux[s];
                    }
                }
                break;
            }
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t c = 0; c < num_components[i]; ++c)
                    reference_values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * i + 2 * r + (reference_offset[i] + c)] = derivatives[num_derivatives * c + r];
        }
    }
  }

  void transform_reference_basis_derivatives(double * values,
                                             std::size_t order,
                                             std::size_t num_points,
                                             const double * reference_values,
                                             const double * X,
                                             const double * J,
                                             const double * detJ,
                                             const double * K,
                                             int cell_orientation) const final override
  {
    const std::size_t num_derivatives = std::pow(2, order);
    // Precomputed combinations
    const std::size_t combinations[3][8][3] =
        { { { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 } },
          { { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 },
            { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 } },
          { { 0, 0, 0 },
            { 0, 0, 1 },
            { 0, 1, 0 },
            { 0, 1, 1 },
            { 1, 0, 0 },
            { 1, 0, 1 },
            { 1, 1, 0 },
            { 1, 1, 1 } } };
    std::fill_n(values, num_points * 15 * num_derivatives * 2, 0.0);
    const std::size_t reference_offsets[15] = {};
    const std::size_t physical_offsets[15] = {};
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        double transform[8][8];
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                transform[r][s] = 1.0;
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                for (std::size_t k = 0; k < order; ++k)
                    transform[r][s] *= K[2 * 2 * ip + 2 * combinations[order - 1][s][k] + combinations[order - 1][r][k]];
        for (std::size_t d = 0; d < 15; ++d)
        {
            for (std::size_t s = 0; s < num_derivatives; ++s)
            {
                for (std::size_t i = 0; i < 2; ++i)
                {
                    // Using covariant Piola transform to map values back to the physical element.
                    const double mapped_value = K[2 * 2 * ip + i] * reference_values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * s + reference_offsets[d]] + K[2 * 2 * ip + 2 + i] * reference_values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * s + (reference_offsets[d] + 1)];
                    // Mapping derivatives back to the physical element
                    for (std::size_t r = 0; r < num_derivatives; ++r)
                        values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * r + (physical_offsets[d] + i)] += transform[r][s] * mapped_value;
                }
            }
        }
    }
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    double X[2] = {};
    double J[4];
    double detJ;
    double K[4];
    if (cm)
    {
        cm->compute_reference_geometry(X, J, &detJ, K, 1, x, coordinate_dofs, cell_orientation);
    }
    else
    {
        compute_jacobian_triangle_2d(J, coordinate_dofs);
        compute_jacobian_inverse_triangle_2d(K, detJ, J);
        // Compute constants
        const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
        const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
        // Get coordinates and map to the reference (FIAT) element
        double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
        // Map to FFC reference coordinate
        for (std::size_t k = 0; k < 2; ++k)
            X[k] = (Y[k] + 1.0) / 2.0;
    }
    // Evaluate basis on reference element
    double ref_values[30];
    evaluate_reference_basis(ref_values, 1, X);
    // Push forward
    double physical_values[30];
    transform_reference_basis_derivatives(physical_values, 0, 1, ref_values, X, J, &detJ, K, cell_orientation);
    for (std::size_t k = 0; k < 2; ++k)
        values[k] = physical_values[2 * i + k];
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation,
                          const ufc::coordinate_mapping * cm=nullptr
                          ) const final override
  {
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {};
    // Loop dofs and call evaluate_basis
    for (std::size_t r = 0; r < 15; ++r)
    {
        evaluate_basis(r, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2; ++s)
            values[r * 2 + s] = dof_values[s];
    }
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::coordinate_mapping * cm=nullptr
                                  ) const final override
  {
    std::size_t num_derivatives = std::pow(2, n);
    std::fill_n(values, 2 * num_derivatives, 0.0);
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
        return;
    }
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 3)
        return;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    // Get coordinates and map to the reference (FIAT) element
    double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
    // Precomputed combinations
    const std::size_t combinations[3][8][3] =
        { { { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 } },
          { { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 },
            { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 } },
          { { 0, 0, 0 },
            { 0, 0, 1 },
            { 0, 1, 0 },
            { 0, 1, 1 },
            { 1, 0, 0 },
            { 1, 0, 1 },
            { 1, 1, 0 },
            { 1, 1, 1 } } };
    // Declare transformation matrix
    double transform[8][8] =
        { { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 } };
    // Construct transformation matrix
    for (std::size_t row = 0; row < num_derivatives; ++row)
        for (std::size_t col = 0; col < num_derivatives; ++col)
            for (std::size_t k = 0; k < n; ++k)
                transform[row][col] *= K[2 * combinations[n - 1][col][k] + combinations[n - 1][row][k]];
    switch (i)
    {
    case 0:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.16953317256112307, 0.08417937871268429, -0.11664236870396073, 0.0, -0.1468200342221035, 0.07290148043997553, -0.10101525445522078 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.3216783274236693, -0.13468700594029484, 0.09720197391996728, 0.26057971086461407, -0.12987926104263006, 0.09768798378956725, -0.06313453403451312 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129191, -4.188732118452481e-14, -2.9933259094191618, 13.66260102127946, 0.0, 0.6110100926607813, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041337, 0.0, 0.0, 12.521980673998826, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377553, 0.0, 7.83836717690618, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999165, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064574, 5.184592558726257, -1.4966629547095676, 6.8313005106397275, -1.0583005244258339, 0.30550504633038966, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998236, 2.190890230020675, 2.5298221281346818, 8.082903768654774, 6.2609903369994075, -1.8073922282301216, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688763, -5.091168824543143, 3.9191835884531003, 0.0, 9.699484522385694, 4.200000000000011, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000024, 0.0, -2.8284271247462303, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 1:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.07824607964359528, -0.1683587574253686, 0.3499271061118826, 0.0, 0.06776309271789388, -0.14580296087995126, 0.30304576336566286 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.1651861681364791, 0.23570226039551592, -0.2721655269759085, -0.12026755886059112, 0.1468200342221037, -0.22453655975512465, 0.17677669529663712 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129191, -4.188732118452481e-14, -2.9933259094191618, 13.66260102127946, 0.0, 0.6110100926607813, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041337, 0.0, 0.0, 12.521980673998826, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377553, 0.0, 7.83836717690618, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999165, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064574, 5.184592558726257, -1.4966629547095676, 6.8313005106397275, -1.0583005244258339, 0.30550504633038966, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998236, 2.190890230020675, 2.5298221281346818, 8.082903768654774, 6.2609903369994075, -1.8073922282301216, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688763, -5.091168824543143, 3.9191835884531003, 0.0, 9.699484522385694, 4.200000000000011, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000024, 0.0, -2.8284271247462303, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 2:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.039123039821797864, -0.08417937871268387, -0.3499271061118829, 0.0, -0.033881546358947065, -0.07290148043997526, -0.3030457633656632 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.06085806194501876, 0.0, 0.2138443426239286, 0.06013377943029531, 0.03952847075210475, 0.11226827987756237, -0.1388959748759294 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129191, -4.188732118452481e-14, -2.9933259094191618, 13.66260102127946, 0.0, 0.6110100926607813, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041337, 0.0, 0.0, 12.521980673998826, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377553, 0.0, 7.83836717690618, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999165, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064574, 5.184592558726257, -1.4966629547095676, 6.8313005106397275, -1.0583005244258339, 0.30550504633038966, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998236, 2.190890230020675, 2.5298221281346818, 8.082903768654774, 6.2609903369994075, -1.8073922282301216, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688763, -5.091168824543143, 3.9191835884531003, 0.0, 9.699484522385694, 4.200000000000011, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000024, 0.0, -2.8284271247462303, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 3:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.1695331725611228, 0.08417937871268408, 0.11664236870396065, 0.0, 0.14682003422210343, 0.0729014804399755, 0.10101525445522103 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.4912114999847918, 0.21886638465297908, 0.21384434262392818, -0.26057971086461373, 0.01694077317947336, -0.024786503349591805, 0.037880720420708 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129191, -4.188732118452481e-14, -2.9933259094191618, 13.66260102127946, 0.0, 0.6110100926607813, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041337, 0.0, 0.0, 12.521980673998826, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377553, 0.0, 7.83836717690618, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999165, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064574, 5.184592558726257, -1.4966629547095676, 6.8313005106397275, -1.0583005244258339, 0.30550504633038966, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998236, 2.190890230020675, 2.5298221281346818, 8.082903768654774, 6.2609903369994075, -1.8073922282301216, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688763, -5.091168824543143, 3.9191835884531003, 0.0, 9.699484522385694, 4.200000000000011, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000024, 0.0, -2.8284271247462303, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 4:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.07824607964359535, -0.16835875742536788, -0.3499271061118827, 0.0, -0.06776309271789412, -0.14580296087995076, -0.3030457633656633 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.24343224778007416, -0.4040610178208842, -0.6220926330877907, 0.12026755886059087, 0.07905694150420953, 0.07873359887517378, -0.12626906806902685 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129191, -4.188732118452481e-14, -2.9933259094191618, 13.66260102127946, 0.0, 0.6110100926607813, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041337, 0.0, 0.0, 12.521980673998826, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377553, 0.0, 7.83836717690618, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999165, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064574, 5.184592558726257, -1.4966629547095676, 6.8313005106397275, -1.0583005244258339, 0.30550504633038966, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998236, 2.190890230020675, 2.5298221281346818, 8.082903768654774, 6.2609903369994075, -1.8073922282301216, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688763, -5.091168824543143, 3.9191835884531003, 0.0, 9.699484522385694, 4.200000000000011, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000024, 0.0, -2.8284271247462303, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 5:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.0391230398217977, -0.08417937871268437, 0.34992710611188266, 0.0, 0.03388154635894702, -0.07290148043997563, 0.3030457633656632 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.09998110176681592, -0.08417937871268426, 0.5637714487358105, -0.06013377943029553, 0.07341001711105186, -0.18516976031753793, 0.16414978848973463 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129191, -4.188732118452481e-14, -2.9933259094191618, 13.66260102127946, 0.0, 0.6110100926607813, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041337, 0.0, 0.0, 12.521980673998826, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377553, 0.0, 7.83836717690618, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999165, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064574, 5.184592558726257, -1.4966629547095676, 6.8313005106397275, -1.0583005244258339, 0.30550504633038966, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998236, 2.190890230020675, 2.5298221281346818, 8.082903768654774, 6.2609903369994075, -1.8073922282301216, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688763, -5.091168824543143, 3.9191835884531003, 0.0, 9.699484522385694, 4.200000000000011, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000024, 0.0, -2.8284271247462303, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 6:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.38253638936868695, 0.3030457633656637, 0.31104631654389564, 0.0, -0.09035079029052531, -0.14580296087995076, -0.20203050891044225 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.16953317256112252, 0.08417937871268436, 0.1166423687039613, 0.16035674514745427, 0.06776309271789402, 0.03207665139358942, -0.07576144084141614 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129191, -4.188732118452481e-14, -2.9933259094191618, 13.66260102127946, 0.0, 0.6110100926607813, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041337, 0.0, 0.0, 12.521980673998826, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377553, 0.0, 7.83836717690618, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999165, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064574, 5.184592558726257, -1.4966629547095676, 6.8313005106397275, -1.0583005244258339, 0.30550504633038966, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998236, 2.190890230020675, 2.5298221281346818, 8.082903768654774, 6.2609903369994075, -1.8073922282301216, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688763, -5.091168824543143, 3.9191835884531003, 0.0, 9.699484522385694, 4.200000000000011, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000024, 0.0, -2.8284271247462303, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 7:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.7650727787373746, 0.0, -0.15552315827194815, 0.0, 0.18070158058105026, 0.0, 0.10101525445522086 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.3825363893686869, 0.0673435029701474, -0.07776157913597405, -0.320713490294909, 0.09035079029052528, -0.06415330278717868, 0.05050762722761055 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129191, -4.188732118452481e-14, -2.9933259094191618, 13.66260102127946, 0.0, 0.6110100926607813, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041337, 0.0, 0.0, 12.521980673998826, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377553, 0.0, 7.83836717690618, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999165, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064574, 5.184592558726257, -1.4966629547095676, 6.8313005106397275, -1.0583005244258339, 0.30550504633038966, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998236, 2.190890230020675, 2.5298221281346818, 8.082903768654774, 6.2609903369994075, -1.8073922282301216, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688763, -5.091168824543143, 3.9191835884531003, 0.0, 9.699484522385694, 4.200000000000011, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000024, 0.0, -2.8284271247462303, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 8:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.38253638936868734, -0.30304576336566347, 0.3110463165438961, 0.0, -0.09035079029052503, 0.14580296087995126, -0.20203050891044194 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.2130032168075649, -0.2188663846529792, 0.1944039478399349, 0.16035674514745463, -0.1581138830084193, 0.17787961227354043, -0.1262690680690265 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129191, -4.188732118452481e-14, -2.9933259094191618, 13.66260102127946, 0.0, 0.6110100926607813, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041337, 0.0, 0.0, 12.521980673998826, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377553, 0.0, 7.83836717690618, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999165, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064574, 5.184592558726257, -1.4966629547095676, 6.8313005106397275, -1.0583005244258339, 0.30550504633038966, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998236, 2.190890230020675, 2.5298221281346818, 8.082903768654774, 6.2609903369994075, -1.8073922282301216, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688763, -5.091168824543143, 3.9191835884531003, 0.0, 9.699484522385694, 4.200000000000011, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000024, 0.0, -2.8284271247462303, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 9:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 3.999999999999999, 0.0, 0.0, -0.36885555678165866, -0.4761904761904767, -1.6495721976846447, 0.0, -0.3194382824999701, -0.41239304942116095, 0.5714285714285707 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.6147592613027625, 0.4761904761904761, -0.5498573992282143, 0.5669467095138403, 0.15971914124998543, -0.4536323543632769, 0.35714285714285765 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129191, -4.188732118452481e-14, -2.9933259094191618, 13.66260102127946, 0.0, 0.6110100926607813, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041337, 0.0, 0.0, 12.521980673998826, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377553, 0.0, 7.83836717690618, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999165, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064574, 5.184592558726257, -1.4966629547095676, 6.8313005106397275, -1.0583005244258339, 0.30550504633038966, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998236, 2.190890230020675, 2.5298221281346818, 8.082903768654774, 6.2609903369994075, -1.8073922282301216, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688763, -5.091168824543143, 3.9191835884531003, 0.0, 9.699484522385694, 4.200000000000011, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000024, 0.0, -2.8284271247462303, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 10:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 3.999999999999998, 0.0, -0.6776309271789392, 1.8079567149113938, 0.0, 0.0, -0.5868455973269648, -1.2626906806902618, 0.0 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 1.0540925533894563, 1.1664236870396083, -0.3367175148507352, 1.0415476122441192, 0.6846531968814589, -0.5808377131175202, 0.2187044413199259 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129191, -4.188732118452481e-14, -2.9933259094191618, 13.66260102127946, 0.0, 0.6110100926607813, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041337, 0.0, 0.0, 12.521980673998826, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377553, 0.0, 7.83836717690618, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999165, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064574, 5.184592558726257, -1.4966629547095676, 6.8313005106397275, -1.0583005244258339, 0.30550504633038966, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998236, 2.190890230020675, 2.5298221281346818, 8.082903768654774, 6.2609903369994075, -1.8073922282301216, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688763, -5.091168824543143, 3.9191835884531003, 0.0, 9.699484522385694, 4.200000000000011, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000024, 0.0, -2.8284271247462303, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 11:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 3.9999999999999996, 0.1304101327393234, -0.8417937871268395, 0.9331389496316848, 0.0, 0.11293848786315575, -0.7290148043997535, -2.020305089104422 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.34776035397153254, 0.33671751485073853, 1.360827634879546, -0.2004459314343202, 0.6211616832473611, 0.5977921396077999, -0.8838834764831877 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129191, -4.188732118452481e-14, -2.9933259094191618, 13.66260102127946, 0.0, 0.6110100926607813, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041337, 0.0, 0.0, 12.521980673998826, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377553, 0.0, 7.83836717690618, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999165, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064574, 5.184592558726257, -1.4966629547095676, 6.8313005106397275, -1.0583005244258339, 0.30550504633038966, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998236, 2.190890230020675, 2.5298221281346818, 8.082903768654774, 6.2609903369994075, -1.8073922282301216, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688763, -5.091168824543143, 3.9191835884531003, 0.0, 9.699484522385694, 4.200000000000011, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000024, 0.0, -2.8284271247462303, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 12:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.0, 0.9523809523809513, 0.0, 0.0, 0.0, 0.8247860988423221, 0.0 };
            static const double coefficients1[10] = { 4.000000000000002, 0.0, 0.0, -1.5983740793871866, 0.47619047619047594, -0.5498573992282156, 0.0, -0.6388765649999416, 0.41239304942116095, -0.14285714285714243 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129191, -4.188732118452481e-14, -2.9933259094191618, 13.66260102127946, 0.0, 0.6110100926607813, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041337, 0.0, 0.0, 12.521980673998826, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377553, 0.0, 7.83836717690618, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999165, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064574, 5.184592558726257, -1.4966629547095676, 6.8313005106397275, -1.0583005244258339, 0.30550504633038966, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998236, 2.190890230020675, 2.5298221281346818, 8.082903768654774, 6.2609903369994075, -1.8073922282301216, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688763, -5.091168824543143, 3.9191835884531003, 0.0, 9.699484522385694, 4.200000000000011, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000024, 0.0, -2.8284271247462303, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 13:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 1.3552618543578767, 0.0, 0.0, 0.0, 1.1736911946539275, 0.0, 0.0 };
            static const double coefficients1[10] = { 0.0, 3.999999999999997, 0.0, 0.6776309271789389, -0.5248906591678227, 0.0, -2.0830952244882406, 0.5868455973269635, -0.10101525445522164, 0.0 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129191, -4.188732118452481e-14, -2.9933259094191618, 13.66260102127946, 0.0, 0.6110100926607813, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041337, 0.0, 0.0, 12.521980673998826, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377553, 0.0, 7.83836717690618, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999165, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064574, 5.184592558726257, -1.4966629547095676, 6.8313005106397275, -1.0583005244258339, 0.30550504633038966, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998236, 2.190890230020675, 2.5298221281346818, 8.082903768654774, 6.2609903369994075, -1.8073922282301216, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688763, -5.091168824543143, 3.9191835884531003, 0.0, 9.699484522385694, 4.200000000000011, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000024, 0.0, -2.8284271247462303, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 14:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.0, 1.6835875742536832, 0.0, 0.0, 0.0, 1.4580296087995102, 0.0 };
            static const double coefficients1[10] = { 0.0, 0.0, 3.9999999999999996, 0.8259308406823948, 0.8417937871268429, -1.7885163201274026, 0.0, -1.1293848786315666, 0.7290148043997547, -0.25253813613805154 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129191, -4.188732118452481e-14, -2.9933259094191618, 13.66260102127946, 0.0, 0.6110100926607813, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041337, 0.0, 0.0, 12.521980673998826, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377553, 0.0, 7.83836717690618, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119286, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471623, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999165, 6.12372435695794, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.309401076758493, 0.0, 8.164965809277271, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064574, 5.184592558726257, -1.4966629547095676, 6.8313005106397275, -1.0583005244258339, 0.30550504633038966, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998236, 2.190890230020675, 2.5298221281346818, 8.082903768654774, 6.2609903369994075, -1.8073922282301216, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688763, -5.091168824543143, 3.9191835884531003, 0.0, 9.699484522385694, 4.200000000000011, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000024, 0.0, -2.8284271247462303, 0.0, 0.0, 12.124355652982162, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    }
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation,
                                      const ufc::coordinate_mapping * cm=nullptr
                                      ) const final override
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
        return;
    }
    unsigned int num_derivatives = std::pow(2, n);
    // Set values equal to zero.
    std::fill_n(values, 2 * num_derivatives * 15, 0.0);
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 3)
        return;
    // Helper variable to hold values of a single dof.
    double dof_values[16] = {};
    // Loop dofs and call evaluate_basis_derivatives.
    for (std::size_t r = 0; r < 15; ++r)
    {
        evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2 * num_derivatives; ++s)
            values[2 * num_derivatives * r + s] = dof_values[s];
    }
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    double result;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    switch (i)
    {
    case 0:
        {
            y[0] = 0.75 * coordinate_dofs[2] + 0.25 * coordinate_dofs[4];
            y[1] = 0.75 * coordinate_dofs[3] + 0.25 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
        }
        break;
    case 1:
        {
            y[0] = 0.5 * coordinate_dofs[2] + 0.5 * coordinate_dofs[4];
            y[1] = 0.5 * coordinate_dofs[3] + 0.5 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
        }
        break;
    case 2:
        {
            y[0] = 0.25 * coordinate_dofs[2] + 0.75 * coordinate_dofs[4];
            y[1] = 0.25 * coordinate_dofs[3] + 0.75 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
        }
        break;
    case 3:
        {
            y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[4];
            y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0] * J[1] + vals[1] * J[2 + 1];
        }
        break;
    case 4:
        {
            y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[4];
            y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0] * J[1] + vals[1] * J[2 + 1];
        }
        break;
    case 5:
        {
            y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[4];
            y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0] * J[1] + vals[1] * J[2 + 1];
        }
        break;
    case 6:
        {
            y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[2];
            y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0] * J[0] + vals[1] * J[2];
        }
        break;
    case 7:
        {
            y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[2];
            y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0] * J[0] + vals[1] * J[2];
        }
        break;
    case 8:
        {
            y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[2];
            y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0] * J[0] + vals[1] * J[2];
        }
        break;
    case 9:
        {
            result = 0.0;
            double X_9[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_9[36][1] = {};
            double W_9[36][1] =
                { { 0.004380007035333952 },
                  { 0.00821012828325171 },
                  { 0.008528136573677752 },
                  { 0.0059761382734593235 },
                  { 0.002662467899383865 },
                  { 0.0005292995210569465 },
                  { 0.009223072580491742 },
                  { 0.017288239137681006 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.011962482987098903 },
                  { 0.022423142044750127 },
                  { 0.023291672330955 },
                  { 0.016321766574367406 },
                  { 0.0072716154775874856 },
                  { 0.001445599622248223 },
                  { 0.011962482987098896 },
                  { 0.022423142044750117 },
                  { 0.023291672330954985 },
                  { 0.016321766574367395 },
                  { 0.007271615477587481 },
                  { 0.0014455996222482222 },
                  { 0.009223072580491742 },
                  { 0.01728823913768101 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.004380007035333964 },
                  { 0.008210128283251733 },
                  { 0.008528136573677774 },
                  { 0.005976138273459339 },
                  { 0.0026624678993838725 },
                  { 0.000529299521056948 } };
            double copy_9[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_9[r][0] - X_9[r][1];
                const double w1 = X_9[r][0];
                const double w2 = X_9[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_9[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_9[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_9[D_9[r][s]] * W_9[r][s];
            }
            return result;
        }
        break;
    case 10:
        {
            result = 0.0;
            double X_10[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_10[36][1] = {};
            double W_10[36][1] =
                { { -0.009710973194534896 },
                  { -0.015975694174423887 },
                  { -0.012914808498775162 },
                  { -0.006024109540551331 },
                  { -0.0014033523604530267 },
                  { -8.831972792250468e-5 },
                  { -0.01449999797697064 },
                  { -0.023854203751711895 },
                  { -0.019283823912786737 },
                  { -0.00899493535830189 },
                  { -0.00209542400951097 },
                  { -0.00013187513244538945 },
                  { -0.006787033586233021 },
                  { -0.011165469284399073 },
                  { -0.009026205436370045 },
                  { -0.0042102715103650165 },
                  { -0.0009808079389071213 },
                  { -6.172697089456968e-5 },
                  { 0.006787033586233017 },
                  { 0.011165469284399062 },
                  { 0.00902620543637004 },
                  { 0.004210271510365018 },
                  { 0.0009808079389071207 },
                  { 6.172697089456923e-5 },
                  { 0.014499997976970646 },
                  { 0.023854203751711905 },
                  { 0.01928382391278674 },
                  { 0.008994935358301898 },
                  { 0.00209542400951097 },
                  { 0.00013187513244538915 },
                  { 0.00971097319453492 },
                  { 0.015975694174423925 },
                  { 0.012914808498775193 },
                  { 0.006024109540551347 },
                  { 0.0014033523604530306 },
                  { 8.831972792250464e-5 } };
            double copy_10[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_10[r][0] - X_10[r][1];
                const double w1 = X_10[r][0];
                const double w2 = X_10[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_10[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_10[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_10[D_10[r][s]] * W_10[r][s];
            }
            return result;
        }
        break;
    case 11:
        {
            result = 0.0;
            double X_11[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_11[36][1] = {};
            double W_11[36][1] =
                { { -0.00564948416560004 },
                  { -0.006452908537728117 },
                  { 0.0001321127369674421 },
                  { 0.005713361221947881 },
                  { 0.00492388644483935 },
                  { 0.0013330322995734722 },
                  { -0.011896237170700168 },
                  { -0.013588024703755641 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.015429623211032667 },
                  { -0.017623900595856532 },
                  { 0.0003608205091003015 },
                  { 0.015604081423921987 },
                  { 0.013447902560801864 },
                  { 0.0036407193130650224 },
                  { -0.015429623211032657 },
                  { -0.017623900595856525 },
                  { 0.00036082050910030123 },
                  { 0.015604081423921978 },
                  { 0.013447902560801856 },
                  { 0.0036407193130650202 },
                  { -0.011896237170700168 },
                  { -0.013588024703755645 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.005649484165600055 },
                  { -0.006452908537728134 },
                  { 0.00013211273696744246 },
                  { 0.005713361221947897 },
                  { 0.004923886444839364 },
                  { 0.0013330322995734759 } };
            double copy_11[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_11[r][0] - X_11[r][1];
                const double w1 = X_11[r][0];
                const double w2 = X_11[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_11[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_11[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_11[D_11[r][s]] * W_11[r][s];
            }
            return result;
        }
        break;
    case 12:
        {
            result = 0.0;
            double X_12[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_12[36][1] =
                { { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 } };
            double W_12[36][1] =
                { { 0.004380007035333952 },
                  { 0.00821012828325171 },
                  { 0.008528136573677752 },
                  { 0.0059761382734593235 },
                  { 0.002662467899383865 },
                  { 0.0005292995210569465 },
                  { 0.009223072580491742 },
                  { 0.017288239137681006 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.011962482987098903 },
                  { 0.022423142044750127 },
                  { 0.023291672330955 },
                  { 0.016321766574367406 },
                  { 0.0072716154775874856 },
                  { 0.001445599622248223 },
                  { 0.011962482987098896 },
                  { 0.022423142044750117 },
                  { 0.023291672330954985 },
                  { 0.016321766574367395 },
                  { 0.007271615477587481 },
                  { 0.0014455996222482222 },
                  { 0.009223072580491742 },
                  { 0.01728823913768101 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.004380007035333964 },
                  { 0.008210128283251733 },
                  { 0.008528136573677774 },
                  { 0.005976138273459339 },
                  { 0.0026624678993838725 },
                  { 0.000529299521056948 } };
            double copy_12[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_12[r][0] - X_12[r][1];
                const double w1 = X_12[r][0];
                const double w2 = X_12[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_12[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_12[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_12[D_12[r][s]] * W_12[r][s];
            }
            return result;
        }
        break;
    case 13:
        {
            result = 0.0;
            double X_13[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_13[36][1] =
                { { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 } };
            double W_13[36][1] =
                { { -0.009710973194534896 },
                  { -0.015975694174423887 },
                  { -0.012914808498775162 },
                  { -0.006024109540551331 },
                  { -0.0014033523604530267 },
                  { -8.831972792250468e-5 },
                  { -0.01449999797697064 },
                  { -0.023854203751711895 },
                  { -0.019283823912786737 },
                  { -0.00899493535830189 },
                  { -0.00209542400951097 },
                  { -0.00013187513244538945 },
                  { -0.006787033586233021 },
                  { -0.011165469284399073 },
                  { -0.009026205436370045 },
                  { -0.0042102715103650165 },
                  { -0.0009808079389071213 },
                  { -6.172697089456968e-5 },
                  { 0.006787033586233017 },
                  { 0.011165469284399062 },
                  { 0.00902620543637004 },
                  { 0.004210271510365018 },
                  { 0.0009808079389071207 },
                  { 6.172697089456923e-5 },
                  { 0.014499997976970646 },
                  { 0.023854203751711905 },
                  { 0.01928382391278674 },
                  { 0.008994935358301898 },
                  { 0.00209542400951097 },
                  { 0.00013187513244538915 },
                  { 0.00971097319453492 },
                  { 0.015975694174423925 },
                  { 0.012914808498775193 },
                  { 0.006024109540551347 },
                  { 0.0014033523604530306 },
                  { 8.831972792250464e-5 } };
            double copy_13[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_13[r][0] - X_13[r][1];
                const double w1 = X_13[r][0];
                const double w2 = X_13[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_13[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_13[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_13[D_13[r][s]] * W_13[r][s];
            }
            return result;
        }
        break;
    case 14:
        {
            result = 0.0;
            double X_14[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_14[36][1] =
                { { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 } };
            double W_14[36][1] =
                { { -0.00564948416560004 },
                  { -0.006452908537728117 },
                  { 0.0001321127369674421 },
                  { 0.005713361221947881 },
                  { 0.00492388644483935 },
                  { 0.0013330322995734722 },
                  { -0.011896237170700168 },
                  { -0.013588024703755641 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.015429623211032667 },
                  { -0.017623900595856532 },
                  { 0.0003608205091003015 },
                  { 0.015604081423921987 },
                  { 0.013447902560801864 },
                  { 0.0036407193130650224 },
                  { -0.015429623211032657 },
                  { -0.017623900595856525 },
                  { 0.00036082050910030123 },
                  { 0.015604081423921978 },
                  { 0.013447902560801856 },
                  { 0.0036407193130650202 },
                  { -0.011896237170700168 },
                  { -0.013588024703755645 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.005649484165600055 },
                  { -0.006452908537728134 },
                  { 0.00013211273696744246 },
                  { 0.005713361221947897 },
                  { 0.004923886444839364 },
                  { 0.0013330322995734759 } };
            double copy_14[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_14[r][0] - X_14[r][1];
                const double w1 = X_14[r][0];
                const double w2 = X_14[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_14[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_14[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_14[D_14[r][s]] * W_14[r][s];
            }
            return result;
        }
        break;
    }
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c,
                             const ufc::coordinate_mapping * cm=nullptr
                             ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    double result;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    y[0] = 0.75 * coordinate_dofs[2] + 0.25 * coordinate_dofs[4];
    y[1] = 0.75 * coordinate_dofs[3] + 0.25 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[0] = -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
    y[0] = 0.5 * coordinate_dofs[2] + 0.5 * coordinate_dofs[4];
    y[1] = 0.5 * coordinate_dofs[3] + 0.5 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[1] = -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
    y[0] = 0.25 * coordinate_dofs[2] + 0.75 * coordinate_dofs[4];
    y[1] = 0.25 * coordinate_dofs[3] + 0.75 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
    y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[4];
    y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[3] = vals[0] * J[1] + vals[1] * J[2 + 1];
    y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[4];
    y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[4] = vals[0] * J[1] + vals[1] * J[2 + 1];
    y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[4];
    y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[5] = vals[0] * J[1] + vals[1] * J[2 + 1];
    y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[2];
    y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[6] = vals[0] * J[0] + vals[1] * J[2];
    y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[2];
    y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[7] = vals[0] * J[0] + vals[1] * J[2];
    y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[2];
    y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[8] = vals[0] * J[0] + vals[1] * J[2];
    result = 0.0;
    double X_9[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_9[36][1] = {};
    double W_9[36][1] =
        { { 0.004380007035333952 },
          { 0.00821012828325171 },
          { 0.008528136573677752 },
          { 0.0059761382734593235 },
          { 0.002662467899383865 },
          { 0.0005292995210569465 },
          { 0.009223072580491742 },
          { 0.017288239137681006 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.011962482987098903 },
          { 0.022423142044750127 },
          { 0.023291672330955 },
          { 0.016321766574367406 },
          { 0.0072716154775874856 },
          { 0.001445599622248223 },
          { 0.011962482987098896 },
          { 0.022423142044750117 },
          { 0.023291672330954985 },
          { 0.016321766574367395 },
          { 0.007271615477587481 },
          { 0.0014455996222482222 },
          { 0.009223072580491742 },
          { 0.01728823913768101 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.004380007035333964 },
          { 0.008210128283251733 },
          { 0.008528136573677774 },
          { 0.005976138273459339 },
          { 0.0026624678993838725 },
          { 0.000529299521056948 } };
    double copy_9[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_9[r][0] - X_9[r][1];
        const double w1 = X_9[r][0];
        const double w2 = X_9[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_9[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_9[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_9[D_9[r][s]] * W_9[r][s];
    }
    values[9] = result;
    result = 0.0;
    double X_10[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_10[36][1] = {};
    double W_10[36][1] =
        { { -0.009710973194534896 },
          { -0.015975694174423887 },
          { -0.012914808498775162 },
          { -0.006024109540551331 },
          { -0.0014033523604530267 },
          { -8.831972792250468e-5 },
          { -0.01449999797697064 },
          { -0.023854203751711895 },
          { -0.019283823912786737 },
          { -0.00899493535830189 },
          { -0.00209542400951097 },
          { -0.00013187513244538945 },
          { -0.006787033586233021 },
          { -0.011165469284399073 },
          { -0.009026205436370045 },
          { -0.0042102715103650165 },
          { -0.0009808079389071213 },
          { -6.172697089456968e-5 },
          { 0.006787033586233017 },
          { 0.011165469284399062 },
          { 0.00902620543637004 },
          { 0.004210271510365018 },
          { 0.0009808079389071207 },
          { 6.172697089456923e-5 },
          { 0.014499997976970646 },
          { 0.023854203751711905 },
          { 0.01928382391278674 },
          { 0.008994935358301898 },
          { 0.00209542400951097 },
          { 0.00013187513244538915 },
          { 0.00971097319453492 },
          { 0.015975694174423925 },
          { 0.012914808498775193 },
          { 0.006024109540551347 },
          { 0.0014033523604530306 },
          { 8.831972792250464e-5 } };
    double copy_10[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_10[r][0] - X_10[r][1];
        const double w1 = X_10[r][0];
        const double w2 = X_10[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_10[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_10[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_10[D_10[r][s]] * W_10[r][s];
    }
    values[10] = result;
    result = 0.0;
    double X_11[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_11[36][1] = {};
    double W_11[36][1] =
        { { -0.00564948416560004 },
          { -0.006452908537728117 },
          { 0.0001321127369674421 },
          { 0.005713361221947881 },
          { 0.00492388644483935 },
          { 0.0013330322995734722 },
          { -0.011896237170700168 },
          { -0.013588024703755641 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.015429623211032667 },
          { -0.017623900595856532 },
          { 0.0003608205091003015 },
          { 0.015604081423921987 },
          { 0.013447902560801864 },
          { 0.0036407193130650224 },
          { -0.015429623211032657 },
          { -0.017623900595856525 },
          { 0.00036082050910030123 },
          { 0.015604081423921978 },
          { 0.013447902560801856 },
          { 0.0036407193130650202 },
          { -0.011896237170700168 },
          { -0.013588024703755645 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.005649484165600055 },
          { -0.006452908537728134 },
          { 0.00013211273696744246 },
          { 0.005713361221947897 },
          { 0.004923886444839364 },
          { 0.0013330322995734759 } };
    double copy_11[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_11[r][0] - X_11[r][1];
        const double w1 = X_11[r][0];
        const double w2 = X_11[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_11[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_11[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_11[D_11[r][s]] * W_11[r][s];
    }
    values[11] = result;
    result = 0.0;
    double X_12[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_12[36][1] =
        { { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 } };
    double W_12[36][1] =
        { { 0.004380007035333952 },
          { 0.00821012828325171 },
          { 0.008528136573677752 },
          { 0.0059761382734593235 },
          { 0.002662467899383865 },
          { 0.0005292995210569465 },
          { 0.009223072580491742 },
          { 0.017288239137681006 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.011962482987098903 },
          { 0.022423142044750127 },
          { 0.023291672330955 },
          { 0.016321766574367406 },
          { 0.0072716154775874856 },
          { 0.001445599622248223 },
          { 0.011962482987098896 },
          { 0.022423142044750117 },
          { 0.023291672330954985 },
          { 0.016321766574367395 },
          { 0.007271615477587481 },
          { 0.0014455996222482222 },
          { 0.009223072580491742 },
          { 0.01728823913768101 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.004380007035333964 },
          { 0.008210128283251733 },
          { 0.008528136573677774 },
          { 0.005976138273459339 },
          { 0.0026624678993838725 },
          { 0.000529299521056948 } };
    double copy_12[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_12[r][0] - X_12[r][1];
        const double w1 = X_12[r][0];
        const double w2 = X_12[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_12[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_12[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_12[D_12[r][s]] * W_12[r][s];
    }
    values[12] = result;
    result = 0.0;
    double X_13[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_13[36][1] =
        { { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 } };
    double W_13[36][1] =
        { { -0.009710973194534896 },
          { -0.015975694174423887 },
          { -0.012914808498775162 },
          { -0.006024109540551331 },
          { -0.0014033523604530267 },
          { -8.831972792250468e-5 },
          { -0.01449999797697064 },
          { -0.023854203751711895 },
          { -0.019283823912786737 },
          { -0.00899493535830189 },
          { -0.00209542400951097 },
          { -0.00013187513244538945 },
          { -0.006787033586233021 },
          { -0.011165469284399073 },
          { -0.009026205436370045 },
          { -0.0042102715103650165 },
          { -0.0009808079389071213 },
          { -6.172697089456968e-5 },
          { 0.006787033586233017 },
          { 0.011165469284399062 },
          { 0.00902620543637004 },
          { 0.004210271510365018 },
          { 0.0009808079389071207 },
          { 6.172697089456923e-5 },
          { 0.014499997976970646 },
          { 0.023854203751711905 },
          { 0.01928382391278674 },
          { 0.008994935358301898 },
          { 0.00209542400951097 },
          { 0.00013187513244538915 },
          { 0.00971097319453492 },
          { 0.015975694174423925 },
          { 0.012914808498775193 },
          { 0.006024109540551347 },
          { 0.0014033523604530306 },
          { 8.831972792250464e-5 } };
    double copy_13[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_13[r][0] - X_13[r][1];
        const double w1 = X_13[r][0];
        const double w2 = X_13[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_13[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_13[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_13[D_13[r][s]] * W_13[r][s];
    }
    values[13] = result;
    result = 0.0;
    double X_14[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_14[36][1] =
        { { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 } };
    double W_14[36][1] =
        { { -0.00564948416560004 },
          { -0.006452908537728117 },
          { 0.0001321127369674421 },
          { 0.005713361221947881 },
          { 0.00492388644483935 },
          { 0.0013330322995734722 },
          { -0.011896237170700168 },
          { -0.013588024703755641 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.015429623211032667 },
          { -0.017623900595856532 },
          { 0.0003608205091003015 },
          { 0.015604081423921987 },
          { 0.013447902560801864 },
          { 0.0036407193130650224 },
          { -0.015429623211032657 },
          { -0.017623900595856525 },
          { 0.00036082050910030123 },
          { 0.015604081423921978 },
          { 0.013447902560801856 },
          { 0.0036407193130650202 },
          { -0.011896237170700168 },
          { -0.013588024703755645 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.005649484165600055 },
          { -0.006452908537728134 },
          { 0.00013211273696744246 },
          { 0.005713361221947897 },
          { 0.004923886444839364 },
          { 0.0013330322995734759 } };
    double copy_14[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_14[r][0] - X_14[r][1];
        const double w1 = X_14[r][0];
        const double w2 = X_14[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_14[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_14[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_14[D_14[r][s]] * W_14[r][s];
    }
    values[14] = result;
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::coordinate_mapping * cm=nullptr
                                 ) const final override
  {
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Evaluate function and change variables
    vertex_values[0] = dof_values[3] * (K[2] * 3.0000000000000004) + dof_values[4] * (K[2] * -2.9999999999999987) + dof_values[5] * K[2] + dof_values[6] * (K[0] * 3.0) + dof_values[7] * (K[0] * -2.999999999999999) + dof_values[8] * K[0];
    vertex_values[2] = dof_values[0] * (K[2] * 3.000000000000002) + dof_values[1] * (K[2] * -3.000000000000002) + dof_values[2] * K[2] + dof_values[6] * (K[0] + K[2]) + dof_values[7] * (K[0] * -2.999999999999999 + K[2] * -2.9999999999999987) + dof_values[8] * (K[0] * 3.0 + K[2] * 3.0000000000000027);
    vertex_values[4] = dof_values[0] * -K[0] + dof_values[1] * (K[0] * 2.9999999999999987) + dof_values[2] * (K[0] * -3.000000000000001) + dof_values[3] * (K[0] + K[2]) + dof_values[4] * (K[0] * -3.0000000000000004 + K[2] * -3.0000000000000004) + dof_values[5] * (K[0] * 3.0 + K[2] * 3.000000000000001);
    vertex_values[1] = dof_values[3] * (K[2 + 1] * 3.0000000000000004) + dof_values[4] * (K[2 + 1] * -2.9999999999999987) + dof_values[5] * K[2 + 1] + dof_values[6] * (K[1] * 3.0) + dof_values[7] * (K[1] * -2.999999999999999) + dof_values[8] * K[1];
    vertex_values[3] = dof_values[0] * (K[2 + 1] * 3.000000000000002) + dof_values[1] * (K[2 + 1] * -3.000000000000002) + dof_values[2] * K[2 + 1] + dof_values[6] * (K[1] + K[2 + 1]) + dof_values[7] * (K[1] * -2.999999999999999 + K[2 + 1] * -2.9999999999999987) + dof_values[8] * (K[1] * 3.0 + K[2 + 1] * 3.0000000000000027);
    vertex_values[5] = dof_values[0] * -K[1] + dof_values[1] * (K[1] * 2.9999999999999987) + dof_values[2] * (K[1] * -3.000000000000001) + dof_values[3] * (K[1] + K[2 + 1]) + dof_values[4] * (K[1] * -3.0000000000000004 + K[2 + 1] * -3.0000000000000004) + dof_values[5] * (K[1] * 3.0 + K[2 + 1] * 3.000000000000001);
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs,
                                const ufc::coordinate_mapping * cm=nullptr
                                ) const final override
  {
    throw std::runtime_error("tabulate_dof_coordinates is not defined for this element");
  }

  void tabulate_reference_dof_coordinates(double * reference_dof_coordinates) const final override
  {
    throw std::runtime_error("tabulate_reference_dof_coordinates is not defined for this element");
  }

  std::size_t num_sub_elements() const final override
  {
    return 0;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_2();
  }

};


class forms_dofmap_0: public ufc::dofmap
{
public:

  forms_dofmap_0() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for FiniteElement('Lagrange', triangle, 1)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    static const bool return_values[3] = { true, false, false };
    if (d >= 3)
        return false;
    return return_values[d];
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return num_global_entities[0];
  }

  std::size_t num_global_support_dofs() const final override
  {
    return 0;
  }

  std::size_t num_element_support_dofs() const final override
  {
    return 3;
  }

  std::size_t num_element_dofs() const final override
  {
    return 3;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 2;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 1, 0, 0 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 1, 2, 3 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    dofs[0] = entity_indices[0][0];
    dofs[1] = entity_indices[0][1];
    dofs[2] = entity_indices[0][2];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
        dofs[0] = 1;
        dofs[1] = 2;
        break;
    case 1:
        dofs[0] = 0;
        dofs[1] = 2;
        break;
    case 2:
        dofs[0] = 0;
        dofs[1] = 1;
        break;
    }
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            break;
        case 1:
            dofs[0] = 1;
            break;
        case 2:
            dofs[0] = 2;
            break;
        }
        break;
    }
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            break;
        case 1:
            dofs[0] = 1;
            break;
        case 2:
            dofs[0] = 2;
            break;
        }
        break;
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 1;
            dofs[1] = 2;
            break;
        case 1:
            dofs[0] = 0;
            dofs[1] = 2;
            break;
        case 2:
            dofs[0] = 0;
            dofs[1] = 1;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            break;
        }
        break;
    }
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 0;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_0();
  }

};


class forms_dofmap_1: public ufc::dofmap
{
public:

  forms_dofmap_1() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    static const bool return_values[3] = { true, false, false };
    if (d >= 3)
        return false;
    return return_values[d];
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return 2 * num_global_entities[0];
  }

  std::size_t num_global_support_dofs() const final override
  {
    return 0;
  }

  std::size_t num_element_support_dofs() const final override
  {
    return 6;
  }

  std::size_t num_element_dofs() const final override
  {
    return 6;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 4;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 2, 0, 0 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 2, 4, 6 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    std::size_t offset = 0;
    dofs[0] = offset + entity_indices[0][0];
    dofs[1] = offset + entity_indices[0][1];
    dofs[2] = offset + entity_indices[0][2];
    offset += num_global_entities[0];
    dofs[3] = offset + entity_indices[0][0];
    dofs[4] = offset + entity_indices[0][1];
    dofs[5] = offset + entity_indices[0][2];
    offset += num_global_entities[0];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
        dofs[0] = 1;
        dofs[1] = 2;
        dofs[2] = 4;
        dofs[3] = 5;
        break;
    case 1:
        dofs[0] = 0;
        dofs[1] = 2;
        dofs[2] = 3;
        dofs[3] = 5;
        break;
    case 2:
        dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 3;
        dofs[3] = 4;
        break;
    }
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 3;
            break;
        case 1:
            dofs[0] = 1;
            dofs[1] = 4;
            break;
        case 2:
            dofs[0] = 2;
            dofs[1] = 5;
            break;
        }
        break;
    }
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 3;
            break;
        case 1:
            dofs[0] = 1;
            dofs[1] = 4;
            break;
        case 2:
            dofs[0] = 2;
            dofs[1] = 5;
            break;
        }
        break;
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 1;
            dofs[1] = 2;
            dofs[2] = 4;
            dofs[3] = 5;
            break;
        case 1:
            dofs[0] = 0;
            dofs[1] = 2;
            dofs[2] = 3;
            dofs[3] = 5;
            break;
        case 2:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 3;
            dofs[3] = 4;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            dofs[3] = 3;
            dofs[4] = 4;
            dofs[5] = 5;
            break;
        }
        break;
    }
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 2;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_dofmap_0();
    case 1:
        return new forms_dofmap_0();
    default:
        return nullptr;
    }
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_1();
  }

};


class forms_dofmap_2: public ufc::dofmap
{
public:

  forms_dofmap_2() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_2() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for FiniteElement('Nedelec 1st kind H(curl)', triangle, 3)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    static const bool return_values[3] = { false, true, true };
    if (d >= 3)
        return false;
    return return_values[d];
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return 3 * num_global_entities[1] + 6 * num_global_entities[2];
  }

  std::size_t num_global_support_dofs() const final override
  {
    return 0;
  }

  std::size_t num_element_support_dofs() const final override
  {
    return 15;
  }

  std::size_t num_element_dofs() const final override
  {
    return 15;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 3;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 0, 3, 6 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 0, 3, 15 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    std::size_t offset = 0;
    dofs[0] = offset + 3 * entity_indices[1][0];
    dofs[1] = offset + 3 * entity_indices[1][0] + 1;
    dofs[2] = offset + 3 * entity_indices[1][0] + 2;
    dofs[3] = offset + 3 * entity_indices[1][1];
    dofs[4] = offset + 3 * entity_indices[1][1] + 1;
    dofs[5] = offset + 3 * entity_indices[1][1] + 2;
    dofs[6] = offset + 3 * entity_indices[1][2];
    dofs[7] = offset + 3 * entity_indices[1][2] + 1;
    dofs[8] = offset + 3 * entity_indices[1][2] + 2;
    offset += 3 * num_global_entities[1];
    dofs[9] = offset + 6 * entity_indices[2][0];
    dofs[10] = offset + 6 * entity_indices[2][0] + 1;
    dofs[11] = offset + 6 * entity_indices[2][0] + 2;
    dofs[12] = offset + 6 * entity_indices[2][0] + 3;
    dofs[13] = offset + 6 * entity_indices[2][0] + 4;
    dofs[14] = offset + 6 * entity_indices[2][0] + 5;
    offset += 6 * num_global_entities[2];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
        dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 2;
        break;
    case 1:
        dofs[0] = 3;
        dofs[1] = 4;
        dofs[2] = 5;
        break;
    case 2:
        dofs[0] = 6;
        dofs[1] = 7;
        dofs[2] = 8;
        break;
    }
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            break;
        case 1:
            dofs[0] = 3;
            dofs[1] = 4;
            dofs[2] = 5;
            break;
        case 2:
            dofs[0] = 6;
            dofs[1] = 7;
            dofs[2] = 8;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 9;
            dofs[1] = 10;
            dofs[2] = 11;
            dofs[3] = 12;
            dofs[4] = 13;
            dofs[5] = 14;
            break;
        }
        break;
    }
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            break;
        case 1:
            break;
        case 2:
            break;
        }
        break;
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            break;
        case 1:
            dofs[0] = 3;
            dofs[1] = 4;
            dofs[2] = 5;
            break;
        case 2:
            dofs[0] = 6;
            dofs[1] = 7;
            dofs[2] = 8;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            dofs[3] = 3;
            dofs[4] = 4;
            dofs[5] = 5;
            dofs[6] = 6;
            dofs[7] = 7;
            dofs[8] = 8;
            dofs[9] = 9;
            dofs[10] = 10;
            dofs[11] = 11;
            dofs[12] = 12;
            dofs[13] = 13;
            dofs[14] = 14;
            break;
        }
        break;
    }
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 0;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_2();
  }

};


class forms_coordinate_mapping_1: public ufc::coordinate_mapping
{
public:

  forms_coordinate_mapping_1() : ufc::coordinate_mapping()
  {
    // Do nothing
  }

  ~forms_coordinate_mapping_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC coordinate_mapping from VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
  }

  ufc::coordinate_mapping * create() const final override
  {
    return new forms_coordinate_mapping_1();
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  ufc::finite_element * create_coordinate_finite_element() const final override
  {
    return new forms_finite_element_1();
  }

  ufc::dofmap * create_coordinate_dofmap() const final override
  {
    return new forms_dofmap_1();
  }

  void compute_physical_coordinates(
      double * x, std::size_t num_points,
      const double * X,
      const double * coordinate_dofs) const final override
  {
    forms_finite_element_0 xelement;
    double phi[3];
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Compute basis values of coordinate element
        xelement.evaluate_reference_basis(phi, 1, &X[2 * ip]);
        // Compute x
        for (std::size_t i = 0; i < 2; ++i)
            for (std::size_t d = 0; d < 3; ++d)
                x[2 * ip + i] += coordinate_dofs[2 * d + i] * phi[d];
    }
  }

  void compute_reference_coordinates(
      double * X, std::size_t num_points,
      const double * x,
      const double * coordinate_dofs, int cell_orientation) const final override
  {
    const double phi_X0[3] = { 1.0, 0.0, 0.0 };
    const double dphi_X0[2][3] =
        { { -1.0, 1.0, 0.0 },
          { -1.0, 0.0, 1.0 } };
    double J[4];
    double detJ[1];
    double K[4];
    double x0[2] = {};
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t k = 0; k < 3; ++k)
            x0[i] += coordinate_dofs[2 * k + i] * phi_X0[k];
    for (std::size_t i = 0; i < 2; ++i)
    {
        for (std::size_t j = 0; j < 2; ++j)
        {
            J[2 * i + j] = 0.0;
            for (std::size_t k = 0; k < 3; ++k)
                J[2 * i + j] += coordinate_dofs[2 * k + i] * dphi_X0[j][k];
        }
    }
    compute_jacobian_determinants(detJ, 1, J, cell_orientation);
    compute_jacobian_inverses(K, 1, J, detJ);
    for (std::size_t ip = 0; ip < num_points; ++ip)
        for (std::size_t j = 0; j < 2; ++j)
            for (std::size_t i = 0; i < 2; ++i)
                X[2 * ip + j] += K[2 * j + i] * (x[2 * ip + i] - x0[i]);
  }

  void compute_reference_geometry(
      double * X, double * J, double * detJ, double * K, std::size_t num_points,
      const double * x,
      const double * coordinate_dofs, int cell_orientation) const final override
  {
    const double phi_X0[3] = { 1.0, 0.0, 0.0 };
    const double dphi_X0[2][3] =
        { { -1.0, 1.0, 0.0 },
          { -1.0, 0.0, 1.0 } };
    double x0[2] = {};
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t k = 0; k < 3; ++k)
            x0[i] += coordinate_dofs[2 * k + i] * phi_X0[k];
    for (std::size_t i = 0; i < 2; ++i)
    {
        for (std::size_t j = 0; j < 2; ++j)
        {
            J[2 * i + j] = 0.0;
            for (std::size_t k = 0; k < 3; ++k)
                J[2 * i + j] += coordinate_dofs[2 * k + i] * dphi_X0[j][k];
        }
    }
    compute_jacobian_determinants(detJ, 1, J, cell_orientation);
    compute_jacobian_inverses(K, 1, J, detJ);
    for (std::size_t ip = 0; ip < num_points; ++ip)
        for (std::size_t j = 0; j < 2; ++j)
            for (std::size_t i = 0; i < 2; ++i)
                X[2 * ip + j] += K[2 * j + i] * (x[2 * ip + i] - x0[i]);
  }

  void compute_jacobians(
      double * J, std::size_t num_points,
      const double * X,
      const double * coordinate_dofs) const final override
  {
    forms_finite_element_0 xelement;
    double dphi[6];
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Compute basis derivatives of coordinate element
        xelement.evaluate_reference_basis_derivatives(dphi, 1, 1, &X[2 * ip]);
        // Compute J
        for (std::size_t i = 0; i < 2; ++i)
            for (std::size_t j = 0; j < 2; ++j)
                for (std::size_t d = 0; d < 3; ++d)
                    J[2 * 2 * ip + 2 * i + j] += coordinate_dofs[2 * d + i] * dphi[2 * d + j];
    }
  }

  void compute_jacobian_determinants(
      double * detJ, std::size_t num_points,
      const double * J,
      int cell_orientation) const final override
  {
    for (std::size_t ip = 0; ip < num_points; ++ip)
        detJ[ip] = J[2 * 2 * ip] * J[2 * 2 * ip + 2 + 1] - J[2 * 2 * ip + 1] * J[2 * 2 * ip + 2];
  }

  void compute_jacobian_inverses(
      double * K, std::size_t num_points,
      const double * J, const double * detJ) const final override
  {
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        K[2 * 2 * ip] = J[2 * 2 * ip + 2 + 1] / detJ[ip];
        K[2 * 2 * ip + 1] = -J[2 * 2 * ip + 1] / detJ[ip];
        K[2 * 2 * ip + 2] = -J[2 * 2 * ip + 2] / detJ[ip];
        K[2 * 2 * ip + 2 + 1] = J[2 * 2 * ip] / detJ[ip];
    }
  }

  void compute_geometry(
      double * x, double * J, double * detJ, double * K, std::size_t num_points,
      const double * X,
      const double * coordinate_dofs, int cell_orientation) const final override
  {
    compute_physical_coordinates(x, num_points, X, coordinate_dofs);
    compute_jacobians(J, num_points, X, coordinate_dofs);
    compute_jacobian_determinants(detJ, num_points, J, cell_orientation);
    compute_jacobian_inverses(K, num_points, J, detJ);
  }

  void compute_midpoint_geometry(
      double * x, double * J,
      const double * coordinate_dofs) const final override
  {
    const double phi_Xm[3] = { 0.33333333333333337, 0.33333333333333337, 0.3333333333333333 };
    const double dphi_Xm[2][3] =
        { { -1.0, 1.0, 0.0 },
          { -1.0, 0.0, 1.0 } };
    // Compute x
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t d = 0; d < 3; ++d)
            x[i] += coordinate_dofs[2 * d + i] * phi_Xm[d];
    // Compute J
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t j = 0; j < 2; ++j)
            for (std::size_t d = 0; d < 3; ++d)
                J[2 * i + j] += coordinate_dofs[2 * d + i] * dphi_Xm[j][d];
  }

};


class forms_cell_integral_0_otherwise: public ufc::cell_integral
{
public:

  forms_cell_integral_0_otherwise() : ufc::cell_integral()
  {

  }

  ~forms_cell_integral_0_otherwise() override
  {

  }

  const std::vector<bool> & enabled_coefficients() const final override
  {
static const std::vector<bool> enabled({});
return enabled;
  }

  void tabulate_tensor(double * A,
                       const double * const * w,
                       const double * coordinate_dofs,
                       int cell_orientation,
                       std::size_t local_facet) const final override
  {
    // This function was generated using 'uflacs' representation
    // with the following integrals metadata:
    // 
    // num_cells:         None
    // optimize:          True
    // precision:         16
    // quadrature_degree: 4
    // quadrature_rule:   'default'
    // representation:    'uflacs'
    // 
    // and the following integral 0 metadata:
    // 
    // estimated_polynomial_degree: 4
    // optimize:                    True
    // precision:                   16
    // quadrature_degree:           4
    // quadrature_rule:             'default'
    // representation:              'uflacs'
    // Precomputed values of basis functions and precomputations
    // FE* dimensions: [entities][points][dofs]
    // PI* dimensions: [entities][dofs][dofs] or [entities][dofs]
    // PM* dimensions: [entities][dofs][dofs]
    alignas(32) static const double FE3_C0_D01_Q6[1][1][2] = { { { -1.0, 1.0 } } };
    alignas(32) static const double PI0[1][15][15] =
        { { { 2.633333333333339, -2.016666666666669, -0.03333333333332661, -1.591666666666673, -0.06666666666665666, -1.008333333333336, -1.091666666666669, 2.600000000000013, -1.508333333333339, 1.649915822768624, 10.9696551146029, -6.833333333333296, 5.892556509887874, -16.88749537379661, 10.41666666666663 },
            { -2.016666666666669, 2.533333333333343, 0.8166666666666661, -0.06666666666667315, 1.633333333333336, 1.266666666666673, 0.1833333333333346, -1.200000000000008, 1.016666666666666, 3.771236166328288, -8.948929172439156, 11.16666666666667, -11.78511301977583, 7.794228634059976, -20.8333333333334 },
            { -0.03333333333332661, 0.8166666666666661, 0.6333333333333345, -1.008333333333341, 1.26666666666667, 0.4083333333333333, -0.5083333333333346, 0.6000000000000056, -0.09166666666667328, 4.006938426723792, -0.5773502691895656, 4.833333333333325, -5.892556509887905, -3.897114317030003, -10.41666666666668 },
            { -1.591666666666673, -0.06666666666667315, -1.008333333333341, 2.633333333333348, -2.016666666666681, -0.03333333333333596, 1.508333333333333, -2.600000000000008, 1.091666666666674, -7.542472332656558, -5.917840259193728, -3.583333333333379, 5.892556509887958, 16.8874953737966, 10.41666666666677 },
            { -0.06666666666665666, 1.633333333333336, 1.26666666666667, -2.016666666666681, 2.533333333333341, 0.8166666666666682, -1.016666666666667, 1.200000000000006, -0.1833333333333433, 8.013876853447588, -1.154700538379144, 9.666666666666668, -11.78511301977582, -7.79422863405999, -20.8333333333334 },
            { -1.008333333333336, 1.266666666666673, 0.4083333333333333, -0.03333333333333596, 0.8166666666666682, 0.6333333333333369, 0.09166666666666737, -0.6000000000000048, 0.5083333333333339, 1.885618083164143, -4.47446458621959, 5.583333333333337, -5.892556509887918, 3.897114317029996, -10.41666666666671 },
            { -1.091666666666669, 0.1833333333333346, -0.5083333333333346, 1.508333333333333, -1.016666666666667, 0.09166666666666737, 3.683333333333329, -5.866666666666667, 2.183333333333337, -4.006938426723772, 2.742413778650699, -1.083333333333339, 2.35702260395516, 10.39230484541327, 4.166666666666665 },
            { 2.600000000000013, -1.200000000000008, 0.6000000000000056, -2.600000000000008, 1.200000000000006, -0.6000000000000048, -5.866666666666667, 11.73333333333335, -5.866666666666677, 5.656854249492394, 10.39230484541329, -1.999999999999986, 0.0, -20.7846096908266, 0.0 },
            { -1.508333333333339, 1.016666666666666, -0.09166666666667328, 1.091666666666674, -0.1833333333333433, 0.5083333333333339, 2.183333333333337, -5.866666666666677, 3.683333333333338, -1.649915822768631, -13.13471862406396, 3.083333333333294, -2.357022603955125, 10.39230484541331, -4.166666666666616 },
            { 1.649915822768624, 3.771236166328288, 4.006938426723792, -7.542472332656558, 8.013876853447588, 1.885618083164143, -4.006938426723772, 5.656854249492394, -1.649915822768631, 26.66666666666687, 4.082482904638805, 25.92724864350689, -33.33333333333357, -36.74234614174775, -58.9255650988794 },
            { 10.9696551146029, -8.948929172439156, -0.5773502691895656, -5.917840259193728, -1.154700538379144, -4.47446458621959, 2.742413778650699, 10.39230484541329, -13.13471862406396, 4.082482904638805, 189.9999999999993, -31.75426480542896, 28.57738033247, -67.50000000000026, 50.5181485540916 },
            { -6.833333333333296, 11.16666666666667, 4.833333333333325, -3.583333333333379, 9.666666666666668, 5.583333333333337, -1.083333333333339, -1.999999999999986, 3.083333333333294, 25.92724864350689, -31.75426480542896, 53.33333333333319, -58.92556509887898, 12.9903810567665, -104.1666666666667 },
            { 5.892556509887874, -11.78511301977583, -5.892556509887905, 5.892556509887958, -11.78511301977582, -5.892556509887918, 2.35702260395516, 0.0, -2.357022603955125, -33.33333333333357, 28.57738033247, -58.92556509887898, 66.66666666666686, 0.0, 117.8511301977583 },
            { -16.88749537379661, 7.794228634059976, -3.897114317030003, 16.8874953737966, -7.79422863405999, 3.897114317029996, 10.39230484541327, -20.7846096908266, 10.39230484541331, -36.74234614174775, -67.50000000000026, 12.9903810567665, 0.0, 135.0000000000003, 0.0 },
            { 10.41666666666663, -20.8333333333334, -10.41666666666668, 10.41666666666677, -20.8333333333334, -10.41666666666671, 4.166666666666665, 0.0, -4.166666666666616, -58.9255650988794, 50.5181485540916, -104.1666666666667, 117.8511301977583, 0.0, 208.3333333333341 } } };
    alignas(32) static const double PI1[1][15][15] =
        { { { 0.3583333333333396, 1.116666666666663, -0.8916666666666637, -0.6500000000000052, -0.5333333333333291, 1.18333333333333, -1.108333333333343, 1.21666666666667, 0.3083333333333453, 0.4714045207910331, 0.7216878364869707, 1.583333333333339, -1.649915822768611, -7.361215932167762, -2.916666666666669 },
            { 0.2833333333333343, -1.733333333333341, 2.783333333333349, -0.9500000000000066, 3.066666666666685, -2.116666666666679, -0.03333333333332253, -0.4333333333333315, -0.3666666666666855, 6.128258770283455, -1.443375672973955, 1.833333333333375, -3.771236166328287, 1.732050807568876, -6.666666666666722 },
            { 0.44166666666667, -0.7166666666666708, 1.691666666666673, -1.150000000000005, 2.133333333333341, -0.9833333333333383, -0.6916666666666651, 0.3833333333333385, -0.1083333333333403, 5.185449728701365, -0.7216878364869843, 2.416666666666694, -4.006938426723782, -3.031088913245556, -7.083333333333355 },
            { -0.9416666666666762, 0.466666666666681, -2.191666666666687, 2.275000000000013, -3.133333333333356, 0.8583333333333497, 1.816666666666666, -1.383333333333339, -0.01666666666666144, -8.720983634634127, 0.7216878364869852, -4.916666666666717, 7.542472332656537, 9.526279441628866, 13.33333333333338 },
            { 0.8833333333333403, -1.433333333333344, 3.38333333333335, -2.30000000000001, 4.266666666666686, -1.96666666666668, -1.383333333333327, 0.7666666666666739, -0.2166666666666816, 10.37089945740274, -1.443375672973957, 4.833333333333393, -8.013876853447572, -6.062177826491107, -14.16666666666672 },
            { 0.1416666666666672, -0.8666666666666712, 1.391666666666675, -0.4750000000000034, 1.533333333333343, -1.05833333333334, -0.01666666666666097, -0.216666666666666, -0.1833333333333426, 3.064129385141727, -0.7216878364869805, 0.9166666666666841, -1.885618083164143, 0.8660254037844396, -3.333333333333359 },
            { -0.7333333333333438, -0.1166666666666567, 0.2666666666666639, 0.7750000000000046, 0.03333333333333272, -0.3083333333333285, 5.50833333333332, -3.433333333333326, -0.2416666666666658, -6.835365551469955, 17.89785834487832, 12.16666666666667, 0.2357022603954975, 7.361215932167785, 0.4166666666666323 },
            { 1.466666666666685, -0.9333333333333427, 0.1333333333333398, -1.13333333333335, 0.2666666666666748, -0.466666666666671, -7.933333333333319, 5.866666666666658, 2.066666666666681, 1.885618083164129, -30.02221399786046, -2.666666666666628, 1.885618083164121, -10.3923048454134, 3.333333333333326 },
            { -0.7333333333333414, 1.050000000000004, -0.4000000000000123, 0.3583333333333473, -0.3000000000000168, 0.7750000000000057, 2.424999999999997, -2.433333333333329, -1.825000000000015, 4.949747468305815, 12.12435565298214, -9.500000000000057, -2.121320343559607, 3.03108891324561, -3.749999999999938 },
            { 3.064129385141736, -3.771236166328305, 10.13519719700726, -7.77817459305207, 13.19932658214898, -5.421151989096926, -5.185449728701335, 3.299831645537244, -0.4714045207910715, 33.33333333333351, -4.082482904638378, 16.49915822768627, -26.66666666666681, -24.49489742783193, -47.1404520791034 },
            { 0.144337567297331, -3.175426480542811, 4.474464586219652, -0.8660254037844846, 4.618802153517116, -3.752776749732506, 0.7216878364868657, -1.443375672974024, -0.7216878364868835, 8.164965809277515, 57.49999999999886, 105.3664241271069, -4.082482904639276, 7.50000000000011, -7.216878364871469 },
            { 2.416666666666677, -8.166666666666691, 14.91666666666671, -7.000000000000024, 17.33333333333339, -10.33333333333337, -2.416666666666632, -0.1666666666666337, -1.583333333333416, 37.71236166328266, -7.216878364869807, 14.16666666666687, -25.92724864350685, -4.330127018922262, -45.83333333333349 },
            { -3.299831645537245, 8.956685895029658, -17.44196726926827, 9.192388155425167, -20.7417989148055, 11.54941075938035, 4.006938426723726, -0.9428090415820941, 1.649915822768704, -46.6666666666669, 8.164965809276678, -18.85618083164155, 33.33333333333352, 12.24744871391601, 58.92556509887927 },
            { -5.196152422706676, -2.598076211353294, -5.196152422706629, 11.69134295108994, -10.39230484541326, -1.299038105676645, 11.69134295108996, -10.3923048454133, -1.299038105676681, -36.74234614174767, 0.0, -25.9807621135331, 36.74234614174761, 67.50000000000023, 64.95190528383279 },
            { -5.833333333333375, 15.83333333333344, -30.83333333333351, 16.25000000000009, -36.66666666666686, 20.4166666666668, 7.08333333333325, -1.666666666666715, 2.916666666666833, -82.49579113843097, 14.4337567297396, -33.3333333333338, 58.9255650988793, 21.65063509461117, 104.1666666666672 } } };
    alignas(32) static const double PI2[1][15][15] =
        { { { -0.6083333333333359, -0.6166666666666668, -0.191666666666669, -2.283333333333347, -0.09999999999998854, -2.116666666666669, -1.108333333333335, 1.216666666666665, 0.3083333333333337, -5.185449728701348, -10.53664241271068, 0.08333333333332149, 16.73486048808166, -7.36121593216778, 10.08333333333333 },
            { 0.2166666666666672, 0.7333333333333375, -0.6166666666666737, 0.3166666666666685, 1.199999999999993, 2.483333333333342, -0.03333333333334004, -0.4333333333333298, -0.3666666666666691, 3.299831645537228, 3.752776749732555, -5.166666666666723, -12.25651754056683, 1.732050807568884, -12.66666666666668 },
            { -0.1916666666666678, 0.2166666666666678, -0.6083333333333381, -1.116666666666675, 0.8999999999999986, 0.7166666666666655, -0.691666666666672, 0.3833333333333356, -0.1083333333333341, -0.4714045207910332, -3.319764047840367, -4.083333333333369, 0.2357022603955596, -3.031088913245569, -4.083333333333316 },
            { 0.6916666666666685, 0.03333333333332966, 1.108333333333344, 3.241666666666681, -1.400000000000006, 0.1583333333333281, 1.816666666666675, -1.383333333333333, -0.01666666666666483, 4.006938426723758, 11.98001808568475, 6.583333333333411, -10.84230397819377, 9.526279441628891, 0.3333333333333468 },
            { -0.3833333333333345, 0.4333333333333362, -1.216666666666677, -2.233333333333346, 1.799999999999997, 1.433333333333334, -1.383333333333343, 0.7666666666666695, -0.2166666666666679, -0.9428090415820598, -6.639528095680728, -8.166666666666746, 0.4714045207910948, -6.062177826491126, -8.166666666666645 },
            { 0.1083333333333333, 0.3666666666666691, -0.3083333333333369, 0.1583333333333355, 0.5999999999999968, 1.241666666666672, -0.01666666666666997, -0.2166666666666648, -0.183333333333335, 1.649915822768615, 1.87638837486628, -2.583333333333361, -6.128258770283424, 0.8660254037844457, -6.333333333333344 },
            { 2.133333333333345, -0.6833333333333435, 0.4666666666666722, 4.308333333333326, -2.866666666666663, 0.5583333333333305, 1.508333333333336, -2.766666666666674, 1.091666666666677, 5.892556509887889, 10.96965511460288, -1.833333333333321, -11.07800623858924, 7.361215932167692, 8.416666666666679 },
            { -4.933333333333358, 2.533333333333349, -0.9333333333333438, -7.533333333333335, 3.733333333333336, -1.533333333333334, -2.600000000000009, 5.866666666666686, -3.266666666666684, -9.428090415820648, -16.16580753730956, 5.333333333333321, 24.51303508113369, -10.39230484541325, -12.66666666666668 },
            { 2.800000000000013, -1.850000000000008, 0.4666666666666735, 3.225000000000007, -0.8666666666666751, 0.9749999999999965, 1.091666666666673, -3.100000000000009, 2.175000000000008, 3.535533905932748, 5.196152422706668, -3.499999999999983, -13.43502884254442, 3.031088913245552, 4.250000000000033 },
            { -1.649915822768619, 0.9428090415820796, -4.006938426723809, -8.720983634634127, 5.65685424949239, 3.064129385141736, -5.185449728701385, 3.299831645537232, -0.4714045207910416, -6.666666666666639, -28.5773803324705, -25.92724864350704, 13.33333333333342, -24.49489742783197, -18.85618083164133 },
            { 0.7216878364870946, 1.443375672974021, -0.7216878364870511, -11.83568051838744, -5.196152422706517, -8.948929172439174, 0.7216878364870225, -1.443375672974129, -0.721687836486979, 8.164965809277302, 12.49999999999992, -7.21687836487062, 69.4022093788567, 7.499999999998987, 44.74464586219583 },
            { 0.08333333333333044, 3.166666666666676, -4.083333333333363, -2.6666666666667, 6.999999999999962, 10.66666666666666, -2.416666666666702, -0.1666666666666466, -1.58333333333334, 9.428090415820625, 1.443375672973946, -30.83333333333357, -40.06938426723744, -4.330127018922328, -55.83333333333318 },
            { 0.4714045207910376, -3.299831645537244, 5.185449728701398, 5.421151989096901, -8.485281374238543, -11.07800623858927, 4.006938426723819, -0.9428090415820858, 1.649915822768625, -6.666666666666687, 8.164965809277396, 37.71236166328291, 33.33333333333317, 12.24744871391604, 58.92556509887895 },
            { 5.196152422706645, 2.598076211353321, 5.196152422706653, 22.08364779650326, -5.196152422706671, 9.093266739736638, 11.69134295108994, -10.39230484541325, -1.299038105676663, 36.74234614174766, 90.00000000000006, 25.98076211353331, -110.2270384252434, 67.50000000000036, -38.97114317029987 },
            { 0.8333333333333413, -5.833333333333371, 9.166666666666757, 9.583333333333387, -14.99999999999995, -19.58333333333339, 7.083333333333421, -1.666666666666704, 2.91666666666669, -11.78511301977583, 14.43375672974087, 66.66666666666735, 58.92556509887874, 21.65063509461122, 104.1666666666666 } } };
    alignas(32) static const double PI3[1][15][15] =
        { { { -0.6083333333333295, -0.61666666666668, -0.1916666666666638, -0.650000000000012, -0.5333333333333287, 1.183333333333329, -1.108333333333335, 1.216666666666663, 0.3083333333333455, -5.185449728701379, -10.53664241271073, 0.08333333333334547, 4.006938426723796, 3.897114317029956, -1.416666666666684 },
            { 0.2166666666666597, 0.7333333333333509, -0.6166666666666758, -0.949999999999998, 3.066666666666675, -2.116666666666676, -0.03333333333333696, -0.4333333333333268, -0.3666666666666821, 3.299831645537256, 3.752776749732616, -5.166666666666719, -0.942809041582058, -3.464101615137762, 0.3333333333333739 },
            { -0.1916666666666704, 0.2166666666666706, -0.6083333333333367, -1.150000000000003, 2.133333333333335, -0.9833333333333373, -0.69166666666667, 0.3833333333333372, -0.1083333333333374, -0.4714045207910302, -3.319764047840351, -4.083333333333352, 1.649915822768632, -0.4330127018922272, -0.5833333333333124 },
            { 0.6916666666666688, 0.03333333333333216, 1.108333333333338, 2.275000000000013, -3.133333333333344, 0.858333333333348, 1.816666666666671, -1.383333333333334, -0.01666666666666619, 4.006938426723767, 11.98001808568475, 6.58333333333337, -5.185449728701389, -1.732050807568837, 1.833333333333308 },
            { -0.38333333333334, 0.433333333333343, -1.216666666666675, -2.300000000000006, 4.266666666666672, -1.966666666666677, -1.383333333333339, 0.7666666666666725, -0.2166666666666757, -0.9428090415820503, -6.639528095680687, -8.166666666666712, 3.299831645537258, -0.8660254037844624, -1.16666666666662 },
            { 0.1083333333333299, 0.3666666666666754, -0.3083333333333378, -0.4749999999999986, 1.533333333333338, -1.058333333333338, -0.0166666666666683, -0.2166666666666635, -0.1833333333333411, 1.649915822768629, 1.876388374866309, -2.583333333333359, -0.4714045207910296, -1.732050807568883, 0.1666666666666831 },
            { 1.150000000000003, 0.9499999999999976, 0.6500000000000036, 2.591666666666665, -3.933333333333322, 1.341666666666667, 2.275, -2.299999999999998, -0.4750000000000001, 9.19238815542511, 19.91858428704208, 2.000000000000021, -7.778174593052059, -6.495190528383236, 2.749999999999975 },
            { -2.133333333333336, -3.066666666666678, 0.5333333333333332, -3.933333333333342, 5.866666666666656, -1.933333333333332, -3.133333333333336, 4.266666666666663, 1.533333333333347, -20.74179891480543, -36.95041722813611, 9.333333333333336, 13.19932658214895, 17.3205080756887, -4.666666666666699 },
            { 0.9833333333333321, 2.116666666666679, -1.183333333333336, 1.341666666666679, -1.93333333333334, 0.591666666666669, 0.8583333333333343, -1.966666666666664, -1.058333333333346, 11.54941075938031, 17.03183294109402, -11.33333333333335, -5.421151989096884, -10.82531754730545, 1.91666666666673 },
            { -1.649915822768629, 0.942809041582089, -4.006938426723798, -7.778174593052059, 13.19932658214893, -5.421151989096917, -5.185449728701371, 3.299831645537237, -0.4714045207910539, -6.666666666666631, -28.57738033247042, -25.92724864350692, 13.33333333333347, 0.0, -4.714045207910235 },
            { 0.7216878364870847, 1.443375672973954, -0.7216878364870327, -0.866025403784572, 4.618802153517128, -3.752776749732477, 0.7216878364869861, -1.443375672974077, -0.7216878364869348, 8.16496580927698, 12.49999999999937, -7.216878364870418, -4.082482904638981, 52.5000000000002, 105.3664241271055 },
            { 0.08333333333329554, 3.16666666666673, -4.083333333333367, -6.999999999999997, 17.33333333333334, -10.33333333333336, -2.416666666666688, -0.1666666666666282, -1.583333333333394, 9.428090415820719, 1.443375672974187, -30.83333333333351, 2.357022603955251, -12.99038105676659, -0.8333333333331194 },
            { 0.471404520791072, -3.299831645537296, 5.185449728701396, 9.192388155425132, -20.74179891480544, 11.54941075938033, 4.006938426723798, -0.9428090415821022, 1.649915822768679, -6.666666666666784, 8.164965809277124, 37.71236166328281, -6.666666666666796, 12.24744871391598, 2.357022603954935 },
            { 5.196152422706621, 2.59807621135337, 5.196152422706628, 11.69134295108998, -10.39230484541323, -1.299038105676628, 11.69134295108993, -10.39230484541324, -1.299038105676708, 36.74234614174779, 90.00000000000021, 25.98076211353317, -36.7423461417479, -22.4999999999998, 12.9903810567665 },
            { 0.8333333333334033, -5.833333333333468, 9.166666666666751, 16.25000000000002, -36.66666666666674, 20.41666666666676, 7.083333333333383, -1.666666666666732, 2.916666666666788, -11.78511301977602, 14.43375672974038, 66.66666666666717, -11.78511301977601, 21.65063509461114, 4.166666666666284 } } };
    alignas(32) static const double PI4[1][15][15] =
        { { { 0.8583333333333463, -0.8000000000000083, 1.275000000000007, -1.295833333333347, 1.67500000000001, -0.8375000000000068, -0.3624999999999962, 0.308333333333342, 0.7625000000000088, 1.767766952966345, -1.732050807568895, 3.749999999999996, -2.474873734152925, -6.278684177437274, -4.375000000000012 },
            { -0.8000000000000083, 2.766666666666674, -3.466666666666687, 1.258333333333353, -3.683333333333361, 3.008333333333345, -0.858333333333348, 0.2166666666666571, -1.275000000000009, 1.178511301977604, 2.020725942163685, -16.66666666666674, 2.592724864350736, -0.4330127018921361, 4.583333333333441 },
            { 1.275000000000007, -3.466666666666687, 6.191666666666706, -3.170833333333353, 7.258333333333379, -4.295833333333364, 1.095833333333347, -0.4416666666666556, 0.6374999999999899, 7.660323462854303, 4.041451884327475, 22.91666666666682, -10.72445284799605, -4.113620667976114, -18.95833333333346 },
            { -1.295833333333347, 1.258333333333353, -3.170833333333353, 2.775000000000014, -4.216666666666688, 1.691666666666688, 0.3208333333333264, -0.225000000000009, -0.3874999999999973, -8.249579113843057, -2.237232293109846, -7.708333333333395, 8.367430244040825, 10.60881119635943, 14.79166666666669 },
            { 1.67500000000001, -3.683333333333361, 7.258333333333379, -4.216666666666688, 8.766666666666719, -4.716666666666703, 0.9416666666666832, -0.3833333333333215, 0.5249999999999854, 11.78511301977584, 5.917840259193794, 24.58333333333351, -14.37783788412654, -8.227241335952197, -25.41666666666679 },
            { -0.8375000000000068, 3.008333333333345, -4.295833333333364, 1.691666666666688, -4.716666666666703, 3.441666666666685, -1.054166666666685, 0.3583333333333256, -1.012500000000003, -1.178511301977574, -0.07216878364874901, -18.95833333333345, 4.83189633810815, -0.2165063509460521, 8.541666666666796 },
            { -0.3624999999999962, -0.858333333333348, 1.095833333333347, 0.3208333333333264, 0.9416666666666832, -1.054166666666685, 10.04166666666667, -5.083333333333321, 1.625000000000021, -18.97403196183912, 24.75389279150506, 27.9583333333334, -0.2357022603955099, 6.062177826491077, -0.4166666666666599 },
            { 0.308333333333342, 0.2166666666666571, -0.4416666666666556, -0.225000000000009, -0.3833333333333215, 0.3583333333333256, -5.083333333333321, 3.833333333333324, 0.4166666666666574, 2.592724864350725, -19.19689645055493, -8.416666666666659, 0.4714045207910189, -3.464101615137807, 0.8333333333333126 },
            { 0.7625000000000088, -1.275000000000009, 0.6374999999999899, -0.3874999999999973, 0.5249999999999854, -1.012500000000003, 1.625000000000021, 0.4166666666666574, 2.70833333333334, -13.0814754519512, -6.278684177437072, 13.37500000000008, 2.121320343559711, -2.598076211353352, 3.75000000000012 },
            { 1.767766952966345, 1.178511301977604, 7.660323462854303, -8.249579113843057, 11.78511301977584, -1.178511301977574, -18.97403196183912, 2.592724864350725, -13.0814754519512, 113.3333333333337, 14.28869016623512, -64.81812160876699, -36.6666666666669, -30.61862178478959, -64.81812160876723 },
            { -1.732050807568895, 2.020725942163685, 4.041451884327475, -2.237232293109846, 5.917840259193794, -0.07216878364874901, 24.75389279150506, -19.19689645055493, -6.278684177437072, 14.28869016623512, 132.4999999999986, 57.73502691896257, -22.45365597551278, 3.750000000000113, -39.69283100678732 },
            { 3.749999999999996, -16.66666666666674, 22.91666666666682, -7.708333333333395, 24.58333333333351, -18.95833333333345, 27.9583333333334, -8.416666666666659, 13.37500000000008, -64.81812160876699, 57.73502691896257, 219.1666666666678, -22.39171473757429, 10.82531754730559, -39.58333333333383 },
            { -2.474873734152925, 2.592724864350736, -10.72445284799605, 8.367430244040825, -14.37783788412654, 4.83189633810815, -0.2357022603955099, 0.4714045207910189, 2.121320343559711, -36.6666666666669, -22.45365597551278, -22.39171473757429, 33.33333333333339, 24.49489742783165, 58.92556509887903 },
            { -6.278684177437274, -0.4330127018921361, -4.113620667976114, 10.60881119635943, -8.227241335952197, -0.2165063509460521, 6.062177826491077, -3.464101615137807, -2.598076211353352, -30.61862178478959, 3.750000000000113, 10.82531754730559, 24.49489742783165, 67.5000000000005, 43.3012701892217 },
            { -4.375000000000012, 4.583333333333441, -18.95833333333346, 14.79166666666669, -25.41666666666679, 8.541666666666796, -0.4166666666666599, 0.8333333333333126, 3.75000000000012, -64.81812160876723, -39.69283100678732, -39.58333333333383, 58.92556509887903, 43.3012701892217, 104.1666666666668 } } };
    alignas(32) static const double PI5[1][15][15] =
        { { { -1.875000000000022, 1.0, -0.7916666666666742, -0.1125000000000028, 0.1416666666666698, 0.5125000000000025, -1.479166666666681, 2.375000000000024, -1.187500000000012, -3.889087296526056, -8.660254037844481, -1.250000000000003, 3.181980515339506, 4.979646071760505, -2.875000000000027 },
            { 1.666666666666684, -2.166666666666676, 1.0, -0.1083333333333307, -0.2833333333333343, -2.025000000000009, 0.7083333333333519, -1.583333333333357, 1.958333333333344, -1.64991582276857, -1.443375672973956, 3.333333333333377, 5.421151989096836, -5.629165124598773, 11.58333333333337 },
            { -0.7916666666666726, 1.666666666666677, -1.875000000000016, -1.154166666666681, 1.058333333333333, 2.887500000000014, -1.520833333333349, 0.9583333333333429, -1.145833333333341, 2.003469213361891, -2.886751345948171, -12.08333333333345, -5.067598598503559, -1.515544456622852, -12.45833333333337 },
            { 1.520833333333349, -0.7083333333333455, 1.479166666666677, 1.008333333333342, -0.6833333333333345, -1.075000000000007, 2.270833333333346, -2.291666666666682, 0.729166666666678, 4.478342947514811, 13.35122497501014, 7.291666666666714, -4.360491817317085, -0.6495190528383086, 3.291666666666697 },
            { -0.9583333333333406, 1.583333333333347, -2.375000000000019, -1.683333333333349, 1.366666666666665, 3.150000000000016, -2.291666666666684, 1.416666666666677, -1.041666666666677, 0.4714045207910478, -7.938566201357388, -15.4166666666668, -3.064129385141666, -3.03108891324561, -12.41666666666671 },
            { 1.145833333333344, -1.958333333333342, 1.187500000000013, 0.2583333333333382, -0.5166666666666656, -2.325000000000012, 0.7291666666666836, -1.041666666666683, 1.604166666666675, -2.592724864350655, -1.804219591217501, 6.041666666666741, 6.246109900481149, -2.814582562299345, 12.0416666666667 },
            { 1.154166666666655, 0.1083333333333382, 0.1125000000000013, 7.504166666666666, -5.258333333333325, 0.9625000000000086, 1.008333333333326, -1.683333333333313, 0.2583333333333261, 5.067598598503547, 9.165435523385238, -2.041666666666623, -12.96362432175339, 12.99038105676658, 13.58333333333326 },
            { -1.05833333333333, 0.2833333333333338, -0.1416666666666735, -5.258333333333335, 3.016666666666668, -1.00833333333333, -0.6833333333333353, 1.36666666666666, -0.5166666666666655, -3.064129385141687, -5.340489990004029, 1.583333333333275, 11.78511301977579, -17.32050807568879, -7.166666666666662 },
            { -2.887500000000015, 2.025000000000007, -0.5124999999999953, 0.9625000000000039, -1.008333333333345, 0.1708333333333176, -1.074999999999997, 3.150000000000011, -2.325000000000009, -3.181980515339481, -4.546633369868302, 3.375000000000075, 3.535533905932807, 4.3301270189223, -2.249999999999943 },
            { 5.067598598503622, -5.421151989096858, -3.181980515339498, -12.96362432175343, 11.7851130197758, 3.53553390593277, -4.360491817317058, -3.064129385141742, 6.246109900481178, -6.666666666666535, -34.70110468942825, -36.53385036130531, 3.333333333333353, -6.123724356958295, -22.3917147375741 },
            { 11.54700538379249, -7.216878364870301, 0.0, 18.25870226312186, -14.86676943163276, 0.2165063509461984, 2.525907427704557, -12.26869322027949, 9.021097956087885, 14.28869016623509, 12.49999999999969, -28.86751345948143, -22.45365597551267, 48.74999999999939, 72.89047148518966 },
            { -4.916666666666665, 10.66666666666669, -5.750000000000028, 4.458333333333266, -11.41666666666665, 4.87500000000003, -2.20833333333335, 3.583333333333333, -8.458333333333352, 20.03469213361893, 23.09401076758505, -30.83333333333354, 5.892556509887964, 2.165063509460783, 5.416666666666536 },
            { -2.003469213361912, 1.649915822768597, 3.889087296526036, 5.067598598503638, -3.064129385141707, -3.181980515339487, 4.478342947514802, 0.471404520791068, -2.592724864350675, 3.333333333333178, 26.53613888015091, 34.17682775735007, -6.666666666666707, 24.49489742783181, 2.357022603955221 },
            { 11.90784930203617, -2.165063509461165, 5.41265877365278, 2.814582562299457, -1.299038105676687, 0.649519052838321, 12.99038105676665, -17.3205080756889, 4.330127018922272, 42.86607049870581, 93.75000000000038, 10.82531754730544, -48.98979485566382, -22.50000000000004, -8.660254037844167 },
            { -3.541666666666715, 2.916666666666644, 6.875000000000042, 8.958333333333414, -5.416666666666665, -5.625000000000036, 7.916666666666665, 0.8333333333333983, -4.583333333333336, 5.892556509887624, 46.90970937165676, 60.41666666666712, -11.78511301977587, 43.30127018922199, 4.166666666666751 } } };
    alignas(32) static const double PI6[1][15][15] =
        { { { -0.6083333333333414, -0.6166666666666798, -0.1916666666666615, -0.4666666666666725, 0.9333333333333298, -0.4666666666666673, -1.108333333333341, 1.216666666666679, 0.308333333333341, -5.185449728701423, -10.53664241271079, 0.08333333333338921, 4.006938426723837, 3.897114317029944, -1.416666666666769 },
            { 0.2166666666666766, 0.7333333333333443, -0.6166666666666745, 0.6833333333333423, -2.533333333333335, 1.849999999999996, -0.03333333333332844, -0.4333333333333487, -0.3666666666666707, 3.299831645537296, 3.752776749732667, -5.16666666666675, -0.9428090415821044, -3.464101615137706, 0.3333333333335444 },
            { -0.1916666666666753, 0.2166666666666714, -0.6083333333333344, -2.133333333333346, 4.933333333333353, -2.800000000000019, -0.6916666666666701, 0.3833333333333433, -0.1083333333333408, -0.4714045207910421, -3.319764047840355, -4.083333333333325, 1.649915822768642, -0.4330127018922482, -0.5833333333333716 },
            { 0.6916666666666738, 0.03333333333333807, 1.108333333333332, 1.508333333333341, -2.600000000000005, 1.091666666666683, 1.816666666666672, -1.383333333333342, -0.01666666666666773, 4.006938426723806, 11.98001808568479, 6.58333333333331, -5.185449728701414, -1.732050807568853, 1.833333333333327 },
            { -0.3833333333333426, 0.4333333333333401, -1.216666666666669, -2.76666666666668, 5.866666666666688, -3.100000000000027, -1.383333333333337, 0.7666666666666763, -0.216666666666676, -0.9428090415820662, -6.639528095680689, -8.166666666666668, 3.299831645537266, -0.8660254037844669, -1.166666666666653 },
            { 0.108333333333342, 0.3666666666666711, -0.3083333333333383, 1.091666666666677, -3.266666666666675, 2.175000000000003, -0.0166666666666635, -0.2166666666666789, -0.1833333333333327, 1.649915822768657, 1.87638837486634, -2.583333333333389, -0.4714045207910589, -1.732050807568836, 0.1666666666668224 },
            { 1.116666666666664, -0.3166666666666932, 2.283333333333361, 4.308333333333328, -7.533333333333321, 3.224999999999988, 3.241666666666674, -2.233333333333322, 0.158333333333347, 5.421151989096761, 19.34123401785236, 14.33333333333355, -8.720983634634065, -8.227241335952151, -8.916666666666835 },
            { -0.8999999999999999, -1.199999999999988, 0.09999999999998965, -2.866666666666672, 3.733333333333335, -0.8666666666666734, -1.399999999999999, 1.799999999999992, 0.599999999999995, -8.485281374238518, -15.58845726811983, 2.99999999999992, 5.656854249492401, 3.464101615137669, -7.999999999999952 },
            { -0.7166666666666658, -2.483333333333345, 2.116666666666683, 0.5583333333333429, -1.533333333333354, 0.9749999999999936, 0.1583333333333471, 1.433333333333327, 1.241666666666676, -11.07800623858926, -12.41303078757693, 17.66666666666678, 3.064129385141738, 4.763139720814417, -13.08333333333323 },
            { -0.2357022603955332, 12.25651754056689, -16.73486048808172, -11.07800623858927, 24.51303508113371, -13.4350288425444, -10.8423039781938, 0.4714045207910647, -6.128258770283469, 33.33333333333346, -4.082482904638667, -124.9221980096241, 13.3333333333333, 0.0, 80.13876853447556 },
            { 5.051814855409215, 10.10362971081834, -5.05181485540918, 10.9696551146028, -16.16580753730937, 5.196152422706627, 5.051814855409166, -10.10362971081836, -5.051814855409169, 57.15476066494028, 87.49999999999913, -50.51814855409186, -28.5773803324704, -22.49999999999978, 62.06515393788354 },
            { 0.5833333333333568, -7.83333333333342, 11.41666666666676, 2.166666666666598, -2.666666666666574, 0.5, 8.083333333333401, -1.166666666666691, 3.916666666666727, -18.85618083164144, 10.10362971081845, 84.16666666666734, -11.78511301977591, 12.99038105676661, -25.83333333333369 },
            { 0.4714045207910319, -3.299831645537272, 5.18544972870138, 5.892556509887917, -9.428090415820702, 3.535533905932832, 4.006938426723771, -0.9428090415820511, 1.649915822768649, -6.666666666666857, 8.164965809276987, 37.71236166328279, -6.666666666666691, 12.24744871391584, 2.357022603954546 },
            { 5.196152422706672, 2.598076211353393, 5.196152422706607, 3.897114317030007, -3.46410161513774, -0.4330127018921683, 11.69134295108996, -10.39230484541332, -1.299038105676707, 36.74234614174807, 90.00000000000064, 25.9807621135329, -36.74234614174816, -22.49999999999986, 12.99038105676671 },
            { 0.8333333333333326, -5.83333333333342, 9.166666666666721, 10.4166666666667, -16.66666666666678, 6.25000000000016, 7.083333333333334, -1.666666666666644, 2.916666666666734, -11.78511301977612, 14.43375672974015, 66.6666666666671, -11.78511301977583, 21.65063509461088, 4.166666666665584 } } };
    alignas(32) static const double PI7[1][15][15] =
        { { { 6.191666666666708, -3.466666666666689, 1.275000000000005, -1.095833333333339, 0.4416666666666632, -0.6375000000000045, 3.170833333333345, -7.258333333333367, 4.29583333333336, 10.72445284799602, 18.47520861406811, -5.91666666666673, -7.660323462854272, -21.86714144555718, 7.958333333333413 },
            { -3.466666666666689, 2.76666666666668, -0.8000000000000052, 0.8583333333333322, -0.2166666666666626, 1.275000000000006, -1.258333333333341, 3.683333333333354, -3.008333333333348, -2.5927248643507, -3.752776749732616, 2.666666666666685, -1.178511301977581, 13.42339375865884, -10.0833333333334 },
            { 1.275000000000005, -0.8000000000000052, 0.8583333333333405, 0.362500000000013, -0.3083333333333402, -0.7625000000000054, 1.29583333333334, -1.675000000000005, 0.8375000000000038, 2.474873734152916, 6.928203230275533, 3.250000000000041, -1.767766952966387, -2.381569860407164, 3.375000000000037 },
            { -1.095833333333339, 0.8583333333333322, 0.362500000000013, 10.04166666666668, -5.083333333333335, 1.625, 0.3208333333333415, 0.9416666666666728, -1.054166666666667, -0.2357022603955414, 2.670244995002017, 5.458333333333448, -18.9740319618391, 36.58957330989263, 7.458333333333297 },
            { 0.4416666666666632, -0.2166666666666626, -0.3083333333333402, -5.083333333333335, 3.833333333333322, 0.4166666666666621, -0.2250000000000065, -0.3833333333333281, 0.3583333333333288, 0.4714045207910327, -1.010362971081858, -3.416666666666712, 2.59272486435074, -16.88749537379656, -12.41666666666661 },
            { -0.6375000000000045, 1.275000000000006, -0.7625000000000054, 1.625, 0.4166666666666621, 2.708333333333341, -0.3875000000000062, 0.5250000000000075, -1.012500000000005, 2.121320343559641, 1.948557158514969, -4.125000000000032, -13.08147545195114, 8.443747686898293, -12.12500000000003 },
            { 3.170833333333345, -1.258333333333341, 1.29583333333334, 0.3208333333333415, -0.2250000000000065, -0.3875000000000062, 2.775000000000005, -4.216666666666671, 1.691666666666674, 8.367430244040808, 18.11436469582452, 1.791666666666693, -8.249579113843058, -7.794228634059924, 1.916666666666714 },
            { -7.258333333333367, 3.683333333333354, -1.675000000000005, 0.9416666666666728, -0.3833333333333281, 0.5250000000000075, -4.216666666666671, 8.766666666666689, -4.716666666666688, -14.37783788412649, -26.1250996808306, 5.583333333333384, 11.78511301977576, 24.24871130596436, -7.16666666666676 },
            { 4.29583333333336, -3.008333333333348, 0.8375000000000038, -1.054166666666667, 0.3583333333333288, -1.012500000000005, 1.691666666666674, -4.716666666666688, 3.441666666666683, 4.831896338108099, 7.289047148519069, -4.458333333333368, -1.178511301977574, -16.45448267190438, 9.416666666666737 },
            { 10.72445284799602, -2.5927248643507, 2.474873734152916, -0.2357022603955414, 0.4714045207910327, 2.121320343559641, 8.367430244040808, -14.37783788412649, 4.831896338108099, 33.33333333333334, 63.27848502189875, -8.24957911384317, -36.66666666666663, -30.61862178478989, -8.249579113842982 },
            { 18.47520861406811, -3.752776749732616, 6.928203230275533, 2.670244995002017, -1.010362971081858, 1.948557158514969, 18.11436469582452, -26.1250996808306, 7.289047148519069, 63.27848502189875, 132.5, 5.77350269189626, -71.44345083117604, -41.25000000000007, -13.71206889325345 },
            { -5.91666666666673, 2.666666666666685, 3.250000000000041, 5.458333333333448, -3.416666666666712, -4.125000000000032, 1.791666666666693, 5.583333333333384, -4.458333333333368, -8.24957911384317, 5.77350269189626, 39.16666666666714, 5.89255650988777, 36.80607966083922, 5.416666666666746 },
            { -7.660323462854272, -1.178511301977581, -1.767766952966387, -18.9740319618391, 2.59272486435074, -13.08147545195114, -8.249579113843058, 11.78511301977576, -1.178511301977574, -36.66666666666663, -71.44345083117604, 5.89255650988777, 113.3333333333335, -48.98979485566393, 44.78342947514795 },
            { -21.86714144555718, 13.42339375865884, -2.381569860407164, 36.58957330989263, -16.88749537379656, 8.443747686898293, -7.794228634059924, 24.24871130596436, -16.45448267190438, -30.61862178478989, -41.25000000000007, 36.80607966083922, -48.98979485566393, 247.5000000000002, -8.660254037844702 },
            { 7.958333333333413, -10.0833333333334, 3.375000000000037, 7.458333333333297, -12.41666666666661, -12.12500000000003, 1.916666666666714, -7.16666666666676, 9.416666666666737, -8.249579113842982, -13.71206889325345, 5.416666666666746, 44.78342947514795, -8.660254037844702, 104.1666666666667 } } };
    alignas(32) static const double PI8[1][15][15] =
        { { { 1.691666666666673, 2.783333333333354, -0.8916666666666767, -0.2666666666666646, -0.1333333333333286, 0.4000000000000106, 2.191666666666669, -3.383333333333339, -1.391666666666683, 17.44196726926825, 29.30052616137364, -10.91666666666675, -10.13519719700728, -15.15544456622764, 3.583333333333363 },
            { -0.7166666666666714, -1.733333333333342, 1.116666666666671, 0.1166666666666614, 0.9333333333333419, -1.050000000000008, -0.4666666666666685, 1.433333333333338, 0.8666666666666734, -8.956685895029644, -12.41303078757702, 10.16666666666671, 3.771236166328293, 8.660254037844371, -1.333333333333372 },
            { 0.4416666666666701, 0.2833333333333328, 0.358333333333336, 0.7333333333333438, -1.466666666666681, 0.7333333333333472, 0.9416666666666706, -0.8833333333333366, -0.1416666666666661, 3.29983164553723, 7.649891066762564, 1.583333333333347, -3.064129385141741, -2.16506350946107, 1.083333333333327 },
            { 0.6916666666666684, 0.033333333333324, 1.108333333333346, 5.508333333333347, -7.933333333333336, 2.424999999999998, 1.816666666666673, -1.383333333333332, -0.01666666666666133, 4.006938426723741, 11.98001808568472, 6.583333333333428, -5.185449728701354, -1.732050807568846, 1.833333333333325 },
            { -0.3833333333333406, 0.4333333333333462, -1.216666666666677, -3.43333333333333, 5.866666666666655, -2.433333333333327, -1.383333333333339, 0.7666666666666726, -0.2166666666666777, -0.9428090415820428, -6.639528095680674, -8.166666666666725, 3.299831645537241, -0.8660254037844441, -1.166666666666619 },
            { 0.1083333333333261, 0.3666666666666791, -0.3083333333333385, -0.2416666666666654, 2.066666666666676, -1.825000000000011, -0.01666666666666944, -0.2166666666666595, -0.1833333333333452, 1.649915822768629, 1.876388374866311, -2.583333333333358, -0.4714045207910167, -1.732050807568881, 0.1666666666666998 },
            { 1.150000000000002, 0.9500000000000036, 0.6499999999999997, 0.7750000000000086, -1.13333333333334, 0.3583333333333508, 2.275000000000001, -2.299999999999998, -0.475000000000004, 9.192388155425128, 19.9185842870421, 1.999999999999997, -7.778174593052085, -6.495190528383221, 2.749999999999978 },
            { -2.133333333333336, -3.066666666666685, 0.5333333333333443, 0.03333333333333033, 0.2666666666666609, -0.3000000000000165, -3.13333333333333, 4.266666666666664, 1.53333333333335, -20.74179891480545, -36.95041722813612, 9.333333333333416, 13.19932658214898, 17.32050807568868, -4.666666666666679 },
            { 0.9833333333333374, 2.116666666666679, -1.18333333333334, -0.308333333333329, -0.4666666666666714, 0.775000000000008, 0.8583333333333333, -1.966666666666669, -1.058333333333343, 11.54941075938032, 17.03183294109403, -11.33333333333339, -5.421151989096912, -10.82531754730546, 1.916666666666709 },
            { 4.006938426723767, 3.771236166328288, 1.64991582276859, 0.2357022603955059, 1.885618083164174, -2.121320343559623, 7.542472332656494, -8.013876853447522, -1.885618083164158, 33.3333333333334, 69.40220937885678, 2.357022603955023, -26.66666666666685, -24.49489742783159, 9.428090415820545 },
            { 7.649891066762548, 4.907477288111863, 6.206515393788457, 4.041451884327392, -2.309401076758462, -1.732050807568799, 16.31014510460692, -15.29978213352506, -2.453738644055949, 57.15476066494091, 132.5000000000001, 27.42413778650711, -53.0722777603026, -37.49999999999959, 18.76388374866261 },
            { -0.9166666666666557, -4.833333333333393, 4.916666666666716, 6.166666666666744, -10.6666666666668, 4.500000000000081, 1.583333333333361, 1.83333333333332, 2.416666666666714, -18.85618083164141, -15.87713240271484, 39.16666666666702, 2.357022603955125, 21.65063509461107, -0.83333333333346 },
            { -5.185449728701321, -6.128258770283482, -0.4714045207910185, -6.835365551470034, 1.885618083164141, 4.949747468305812, -8.720983634634084, 10.37089945740266, 3.064129385141779, -46.66666666666678, -89.81462390205009, 9.428090415820662, 33.33333333333348, 36.7423461417474, -11.78511301977596 },
            { -1.732050807568873, -0.8660254037845536, -1.732050807568811, 19.48557158514992, -17.32050807568885, -2.165063509460992, -3.897114317029979, 3.464101615137774, 0.4330127018923018, -12.2474487139163, -30.00000000000058, -8.660254037843906, 12.24744871391585, 67.50000000000017, 99.59292143520966 },
            { 1.833333333333385, 2.166666666666608, 0.1666666666666972, 9.416666666666636, -24.66666666666665, 15.25000000000001, 3.083333333333354, -3.666666666666713, -1.08333333333328, 16.49915822768608, 31.75426480542938, -3.333333333333222, -11.78511301977591, -12.99038105676656, 4.166666666666558 } } };
    alignas(32) static const double PI9[1][15][15] =
        { { { 0.6333333333333344, 0.8166666666666679, -0.03333333333333238, 0.5083333333333395, -0.6000000000000071, 0.09166666666667672, 1.008333333333334, -1.266666666666665, -0.4083333333333357, 5.892556509887898, 10.9696551146029, -1.833333333333326, -4.006938426723801, -3.897114317029921, 2.916666666666678 },
            { 0.8166666666666679, 2.533333333333347, -2.016666666666681, -0.1833333333333421, 1.200000000000024, -1.016666666666665, 0.06666666666665752, -1.633333333333331, -1.266666666666678, 11.78511301977583, 14.14508159514585, -17.16666666666677, -3.771236166328301, -5.196152422706623, 13.33333333333327 },
            { -0.03333333333333238, -2.016666666666681, 2.633333333333353, 1.091666666666674, -2.600000000000018, 1.508333333333337, 1.591666666666681, 0.06666666666666354, 1.008333333333343, -5.89255650988793, -0.5773502691896235, 19.83333333333348, -1.649915822768605, 0.4330127018922001, -12.91666666666672 },
            { 0.5083333333333395, -0.1833333333333421, 1.091666666666674, 3.683333333333339, -5.866666666666667, 2.183333333333338, 1.508333333333338, -1.016666666666671, 0.09166666666667439, 2.357022603955146, 8.804591605141781, 6.916666666666709, -4.006938426723798, 0.4330127018922367, 2.916666666666627 },
            { -0.6000000000000071, 1.200000000000024, -2.600000000000018, -5.866666666666667, 11.73333333333333, -5.866666666666664, -2.600000000000006, 1.200000000000003, -0.6000000000000192, 0.0, -10.39230484541318, -18.00000000000012, 5.65685424949236, 3.464101615137739, 10.00000000000002 },
            { 0.09166666666667672, -1.016666666666665, 1.508333333333337, 2.183333333333338, -5.866666666666664, 3.683333333333314, 1.091666666666679, -0.1833333333333501, 0.5083333333333365, -2.357022603955108, 1.587713240271561, 11.08333333333333, -1.649915822768616, -3.897114317029961, -12.91666666666645 },
            { 1.008333333333334, 0.06666666666665752, 1.591666666666681, 1.508333333333338, -2.600000000000006, 1.091666666666679, 2.633333333333341, -2.016666666666663, -0.03333333333332969, 5.892556509887862, 17.46484564298617, 9.416666666666774, -7.542472332656544, -6.062177826491036, -3.333333333333441 },
            { -1.266666666666665, -1.633333333333331, 0.06666666666666354, -1.016666666666671, 1.200000000000003, -0.1833333333333501, -2.016666666666663, 2.533333333333323, 0.8166666666666687, -11.78511301977576, -21.93931022920574, 3.666666666666635, 8.013876853447579, 7.794228634059855, -5.833333333333274 },
            { -0.4083333333333357, -1.266666666666678, 1.008333333333343, 0.09166666666667439, -0.6000000000000192, 0.5083333333333365, -0.03333333333332969, 0.8166666666666687, 0.6333333333333412, -5.892556509887935, -7.072540797572957, 8.583333333333414, 1.88561808316416, 2.59807621135334, -6.666666666666628 },
            { 5.892556509887898, 11.78511301977583, -5.89255650988793, 2.357022603955146, 0.0, -2.357022603955108, 5.892556509887862, -11.78511301977576, -5.892556509887935, 66.6666666666667, 102.0620726159657, -58.9255650988792, -33.33333333333359, -36.7423461417474, 54.21151989096832 },
            { 10.9696551146029, 14.14508159514585, -0.5773502691896235, 8.804591605141781, -10.39230484541318, 1.587713240271561, 17.46484564298617, -21.93931022920574, -7.072540797572957, 102.0620726159657, 190.0, -31.75426480542939, -69.40220937885719, -67.49999999999963, 50.51814855409143 },
            { -1.833333333333326, -17.16666666666677, 19.83333333333348, 6.916666666666709, -18.00000000000012, 11.08333333333333, 9.416666666666774, 3.666666666666635, 8.583333333333414, -58.9255650988792, -31.75426480542939, 153.3333333333344, -2.357022603955054, 12.99038105676631, -104.166666666667 },
            { -4.006938426723801, -3.771236166328301, -1.649915822768605, -4.006938426723798, 5.65685424949236, -1.649915822768616, -7.542472332656544, 8.013876853447579, 1.88561808316416, -33.33333333333359, -69.40220937885719, -2.357022603955054, 26.666666666667, 24.49489742783155, -9.428090415820998 },
            { -3.897114317029921, -5.196152422706623, 0.4330127018922001, 0.4330127018922367, 3.464101615137739, -3.897114317029961, -6.062177826491036, 7.794228634059855, 2.59807621135334, -36.7423461417474, -67.49999999999963, 12.99038105676631, 24.49489742783155, 59.99999999999999, 43.30127018922231 },
            { 2.916666666666678, 13.33333333333327, -12.91666666666672, 2.916666666666627, 10.00000000000002, -12.91666666666645, -3.333333333333441, -5.833333333333274, -6.666666666666628, 54.21151989096832, 50.51814855409143, -104.166666666667, -9.428090415820998, 43.30127018922231, 183.3333333333319 } } };
    // Unstructured piecewise computations
    const double J_c3 = coordinate_dofs[1] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[5] * FE3_C0_D01_Q6[0][0][1];
    const double J_c0 = coordinate_dofs[0] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[2] * FE3_C0_D01_Q6[0][0][1];
    const double J_c1 = coordinate_dofs[0] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[4] * FE3_C0_D01_Q6[0][0][1];
    const double J_c2 = coordinate_dofs[1] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[3] * FE3_C0_D01_Q6[0][0][1];
    alignas(32) double sp[36];
    sp[0] = J_c0 * J_c3;
    sp[1] = J_c1 * J_c2;
    sp[2] = sp[0] + -1 * sp[1];
    sp[3] = J_c3 / sp[2];
    sp[4] = -1 * J_c2 / sp[2];
    sp[5] = J_c0 / sp[2];
    sp[6] = sp[5] * sp[3];
    sp[7] = sp[5] * sp[4];
    sp[8] = -1 * J_c1 / sp[2];
    sp[9] = sp[3] * sp[8];
    sp[10] = sp[8] * sp[4];
    sp[11] = -1 * sp[10] + sp[6];
    sp[12] = -1 * sp[7] + sp[7];
    sp[13] = -1 * sp[9] + sp[9];
    sp[14] = -1 * sp[6] + sp[10];
    sp[15] = sp[11] * sp[11];
    sp[16] = sp[11] * sp[12];
    sp[17] = sp[11] * sp[13];
    sp[18] = sp[11] * sp[14];
    sp[19] = sp[12] * sp[12];
    sp[20] = sp[13] * sp[12];
    sp[21] = sp[12] * sp[14];
    sp[22] = sp[13] * sp[13];
    sp[23] = sp[13] * sp[14];
    sp[24] = sp[14] * sp[14];
    sp[25] = std::abs(sp[2]);
    sp[26] = sp[15] * sp[25];
    sp[27] = sp[16] * sp[25];
    sp[28] = sp[17] * sp[25];
    sp[29] = sp[18] * sp[25];
    sp[30] = sp[19] * sp[25];
    sp[31] = sp[20] * sp[25];
    sp[32] = sp[21] * sp[25];
    sp[33] = sp[22] * sp[25];
    sp[34] = sp[23] * sp[25];
    sp[35] = sp[24] * sp[25];
    A[0] = sp[33] * PI0[0][0][0] + sp[34] * PI1[0][0][0] + sp[28] * PI2[0][0][0] + sp[31] * PI3[0][0][0] + sp[34] * PI1[0][0][0] + sp[35] * PI4[0][0][0] + sp[29] * PI5[0][0][0] + sp[32] * PI6[0][0][0] + sp[28] * PI2[0][0][0] + sp[29] * PI5[0][0][0] + sp[26] * PI7[0][0][0] + sp[27] * PI8[0][0][0] + sp[31] * PI3[0][0][0] + sp[32] * PI6[0][0][0] + sp[27] * PI8[0][0][0] + sp[30] * PI9[0][0][0];
    A[1] = sp[33] * PI0[0][0][1] + sp[34] * PI1[0][0][1] + sp[28] * PI2[0][0][1] + sp[31] * PI3[0][0][1] + sp[34] * PI1[0][1][0] + sp[35] * PI4[0][0][1] + sp[29] * PI5[0][0][1] + sp[32] * PI6[0][0][1] + sp[28] * PI2[0][1][0] + sp[29] * PI5[0][1][0] + sp[26] * PI7[0][0][1] + sp[27] * PI8[0][0][1] + sp[31] * PI3[0][1][0] + sp[32] * PI6[0][1][0] + sp[27] * PI8[0][1][0] + sp[30] * PI9[0][0][1];
    A[2] = sp[33] * PI0[0][0][2] + sp[34] * PI1[0][0][2] + sp[28] * PI2[0][0][2] + sp[31] * PI3[0][0][2] + sp[34] * PI1[0][2][0] + sp[35] * PI4[0][0][2] + sp[29] * PI5[0][0][2] + sp[32] * PI6[0][0][2] + sp[28] * PI2[0][2][0] + sp[29] * PI5[0][2][0] + sp[26] * PI7[0][0][2] + sp[27] * PI8[0][0][2] + sp[31] * PI3[0][2][0] + sp[32] * PI6[0][2][0] + sp[27] * PI8[0][2][0] + sp[30] * PI9[0][0][2];
    A[3] = sp[33] * PI0[0][0][3] + sp[34] * PI1[0][0][3] + sp[28] * PI2[0][0][3] + sp[31] * PI3[0][0][3] + sp[34] * PI1[0][3][0] + sp[35] * PI4[0][0][3] + sp[29] * PI5[0][0][3] + sp[32] * PI6[0][0][3] + sp[28] * PI2[0][3][0] + sp[29] * PI5[0][3][0] + sp[26] * PI7[0][0][3] + sp[27] * PI8[0][0][3] + sp[31] * PI3[0][3][0] + sp[32] * PI6[0][3][0] + sp[27] * PI8[0][3][0] + sp[30] * PI9[0][0][3];
    A[4] = sp[33] * PI0[0][0][4] + sp[34] * PI1[0][0][4] + sp[28] * PI2[0][0][4] + sp[31] * PI3[0][0][4] + sp[34] * PI1[0][4][0] + sp[35] * PI4[0][0][4] + sp[29] * PI5[0][0][4] + sp[32] * PI6[0][0][4] + sp[28] * PI2[0][4][0] + sp[29] * PI5[0][4][0] + sp[26] * PI7[0][0][4] + sp[27] * PI8[0][0][4] + sp[31] * PI3[0][4][0] + sp[32] * PI6[0][4][0] + sp[27] * PI8[0][4][0] + sp[30] * PI9[0][0][4];
    A[5] = sp[33] * PI0[0][0][5] + sp[34] * PI1[0][0][5] + sp[28] * PI2[0][0][5] + sp[31] * PI3[0][0][5] + sp[34] * PI1[0][5][0] + sp[35] * PI4[0][0][5] + sp[29] * PI5[0][0][5] + sp[32] * PI6[0][0][5] + sp[28] * PI2[0][5][0] + sp[29] * PI5[0][5][0] + sp[26] * PI7[0][0][5] + sp[27] * PI8[0][0][5] + sp[31] * PI3[0][5][0] + sp[32] * PI6[0][5][0] + sp[27] * PI8[0][5][0] + sp[30] * PI9[0][0][5];
    A[6] = sp[33] * PI0[0][0][6] + sp[34] * PI1[0][0][6] + sp[28] * PI2[0][0][6] + sp[31] * PI3[0][0][6] + sp[34] * PI1[0][6][0] + sp[35] * PI4[0][0][6] + sp[29] * PI5[0][0][6] + sp[32] * PI6[0][0][6] + sp[28] * PI2[0][6][0] + sp[29] * PI5[0][6][0] + sp[26] * PI7[0][0][6] + sp[27] * PI8[0][0][6] + sp[31] * PI3[0][6][0] + sp[32] * PI6[0][6][0] + sp[27] * PI8[0][6][0] + sp[30] * PI9[0][0][6];
    A[7] = sp[33] * PI0[0][0][7] + sp[34] * PI1[0][0][7] + sp[28] * PI2[0][0][7] + sp[31] * PI3[0][0][7] + sp[34] * PI1[0][7][0] + sp[35] * PI4[0][0][7] + sp[29] * PI5[0][0][7] + sp[32] * PI6[0][0][7] + sp[28] * PI2[0][7][0] + sp[29] * PI5[0][7][0] + sp[26] * PI7[0][0][7] + sp[27] * PI8[0][0][7] + sp[31] * PI3[0][7][0] + sp[32] * PI6[0][7][0] + sp[27] * PI8[0][7][0] + sp[30] * PI9[0][0][7];
    A[8] = sp[33] * PI0[0][0][8] + sp[34] * PI1[0][0][8] + sp[28] * PI2[0][0][8] + sp[31] * PI3[0][0][8] + sp[34] * PI1[0][8][0] + sp[35] * PI4[0][0][8] + sp[29] * PI5[0][0][8] + sp[32] * PI6[0][0][8] + sp[28] * PI2[0][8][0] + sp[29] * PI5[0][8][0] + sp[26] * PI7[0][0][8] + sp[27] * PI8[0][0][8] + sp[31] * PI3[0][8][0] + sp[32] * PI6[0][8][0] + sp[27] * PI8[0][8][0] + sp[30] * PI9[0][0][8];
    A[9] = sp[33] * PI0[0][0][9] + sp[34] * PI1[0][0][9] + sp[28] * PI2[0][0][9] + sp[31] * PI3[0][0][9] + sp[34] * PI1[0][9][0] + sp[35] * PI4[0][0][9] + sp[29] * PI5[0][0][9] + sp[32] * PI6[0][0][9] + sp[28] * PI2[0][9][0] + sp[29] * PI5[0][9][0] + sp[26] * PI7[0][0][9] + sp[27] * PI8[0][0][9] + sp[31] * PI3[0][9][0] + sp[32] * PI6[0][9][0] + sp[27] * PI8[0][9][0] + sp[30] * PI9[0][0][9];
    A[10] = sp[33] * PI0[0][0][10] + sp[34] * PI1[0][0][10] + sp[28] * PI2[0][0][10] + sp[31] * PI3[0][0][10] + sp[34] * PI1[0][10][0] + sp[35] * PI4[0][0][10] + sp[29] * PI5[0][0][10] + sp[32] * PI6[0][0][10] + sp[28] * PI2[0][10][0] + sp[29] * PI5[0][10][0] + sp[26] * PI7[0][0][10] + sp[27] * PI8[0][0][10] + sp[31] * PI3[0][10][0] + sp[32] * PI6[0][10][0] + sp[27] * PI8[0][10][0] + sp[30] * PI9[0][0][10];
    A[11] = sp[33] * PI0[0][0][11] + sp[34] * PI1[0][0][11] + sp[28] * PI2[0][0][11] + sp[31] * PI3[0][0][11] + sp[34] * PI1[0][11][0] + sp[35] * PI4[0][0][11] + sp[29] * PI5[0][0][11] + sp[32] * PI6[0][0][11] + sp[28] * PI2[0][11][0] + sp[29] * PI5[0][11][0] + sp[26] * PI7[0][0][11] + sp[27] * PI8[0][0][11] + sp[31] * PI3[0][11][0] + sp[32] * PI6[0][11][0] + sp[27] * PI8[0][11][0] + sp[30] * PI9[0][0][11];
    A[12] = sp[33] * PI0[0][0][12] + sp[34] * PI1[0][0][12] + sp[28] * PI2[0][0][12] + sp[31] * PI3[0][0][12] + sp[34] * PI1[0][12][0] + sp[35] * PI4[0][0][12] + sp[29] * PI5[0][0][12] + sp[32] * PI6[0][0][12] + sp[28] * PI2[0][12][0] + sp[29] * PI5[0][12][0] + sp[26] * PI7[0][0][12] + sp[27] * PI8[0][0][12] + sp[31] * PI3[0][12][0] + sp[32] * PI6[0][12][0] + sp[27] * PI8[0][12][0] + sp[30] * PI9[0][0][12];
    A[13] = sp[33] * PI0[0][0][13] + sp[34] * PI1[0][0][13] + sp[28] * PI2[0][0][13] + sp[31] * PI3[0][0][13] + sp[34] * PI1[0][13][0] + sp[35] * PI4[0][0][13] + sp[29] * PI5[0][0][13] + sp[32] * PI6[0][0][13] + sp[28] * PI2[0][13][0] + sp[29] * PI5[0][13][0] + sp[26] * PI7[0][0][13] + sp[27] * PI8[0][0][13] + sp[31] * PI3[0][13][0] + sp[32] * PI6[0][13][0] + sp[27] * PI8[0][13][0] + sp[30] * PI9[0][0][13];
    A[14] = sp[33] * PI0[0][0][14] + sp[34] * PI1[0][0][14] + sp[28] * PI2[0][0][14] + sp[31] * PI3[0][0][14] + sp[34] * PI1[0][14][0] + sp[35] * PI4[0][0][14] + sp[29] * PI5[0][0][14] + sp[32] * PI6[0][0][14] + sp[28] * PI2[0][14][0] + sp[29] * PI5[0][14][0] + sp[26] * PI7[0][0][14] + sp[27] * PI8[0][0][14] + sp[31] * PI3[0][14][0] + sp[32] * PI6[0][14][0] + sp[27] * PI8[0][14][0] + sp[30] * PI9[0][0][14];
    A[15] = sp[33] * PI0[0][1][0] + sp[34] * PI1[0][1][0] + sp[28] * PI2[0][1][0] + sp[31] * PI3[0][1][0] + sp[34] * PI1[0][0][1] + sp[35] * PI4[0][1][0] + sp[29] * PI5[0][1][0] + sp[32] * PI6[0][1][0] + sp[28] * PI2[0][0][1] + sp[29] * PI5[0][0][1] + sp[26] * PI7[0][1][0] + sp[27] * PI8[0][1][0] + sp[31] * PI3[0][0][1] + sp[32] * PI6[0][0][1] + sp[27] * PI8[0][0][1] + sp[30] * PI9[0][1][0];
    A[16] = sp[33] * PI0[0][1][1] + sp[34] * PI1[0][1][1] + sp[28] * PI2[0][1][1] + sp[31] * PI3[0][1][1] + sp[34] * PI1[0][1][1] + sp[35] * PI4[0][1][1] + sp[29] * PI5[0][1][1] + sp[32] * PI6[0][1][1] + sp[28] * PI2[0][1][1] + sp[29] * PI5[0][1][1] + sp[26] * PI7[0][1][1] + sp[27] * PI8[0][1][1] + sp[31] * PI3[0][1][1] + sp[32] * PI6[0][1][1] + sp[27] * PI8[0][1][1] + sp[30] * PI9[0][1][1];
    A[17] = sp[33] * PI0[0][1][2] + sp[34] * PI1[0][1][2] + sp[28] * PI2[0][1][2] + sp[31] * PI3[0][1][2] + sp[34] * PI1[0][2][1] + sp[35] * PI4[0][1][2] + sp[29] * PI5[0][1][2] + sp[32] * PI6[0][1][2] + sp[28] * PI2[0][2][1] + sp[29] * PI5[0][2][1] + sp[26] * PI7[0][1][2] + sp[27] * PI8[0][1][2] + sp[31] * PI3[0][2][1] + sp[32] * PI6[0][2][1] + sp[27] * PI8[0][2][1] + sp[30] * PI9[0][1][2];
    A[18] = sp[33] * PI0[0][1][3] + sp[34] * PI1[0][1][3] + sp[28] * PI2[0][1][3] + sp[31] * PI3[0][1][3] + sp[34] * PI1[0][3][1] + sp[35] * PI4[0][1][3] + sp[29] * PI5[0][1][3] + sp[32] * PI6[0][1][3] + sp[28] * PI2[0][3][1] + sp[29] * PI5[0][3][1] + sp[26] * PI7[0][1][3] + sp[27] * PI8[0][1][3] + sp[31] * PI3[0][3][1] + sp[32] * PI6[0][3][1] + sp[27] * PI8[0][3][1] + sp[30] * PI9[0][1][3];
    A[19] = sp[33] * PI0[0][1][4] + sp[34] * PI1[0][1][4] + sp[28] * PI2[0][1][4] + sp[31] * PI3[0][1][4] + sp[34] * PI1[0][4][1] + sp[35] * PI4[0][1][4] + sp[29] * PI5[0][1][4] + sp[32] * PI6[0][1][4] + sp[28] * PI2[0][4][1] + sp[29] * PI5[0][4][1] + sp[26] * PI7[0][1][4] + sp[27] * PI8[0][1][4] + sp[31] * PI3[0][4][1] + sp[32] * PI6[0][4][1] + sp[27] * PI8[0][4][1] + sp[30] * PI9[0][1][4];
    A[20] = sp[33] * PI0[0][1][5] + sp[34] * PI1[0][1][5] + sp[28] * PI2[0][1][5] + sp[31] * PI3[0][1][5] + sp[34] * PI1[0][5][1] + sp[35] * PI4[0][1][5] + sp[29] * PI5[0][1][5] + sp[32] * PI6[0][1][5] + sp[28] * PI2[0][5][1] + sp[29] * PI5[0][5][1] + sp[26] * PI7[0][1][5] + sp[27] * PI8[0][1][5] + sp[31] * PI3[0][5][1] + sp[32] * PI6[0][5][1] + sp[27] * PI8[0][5][1] + sp[30] * PI9[0][1][5];
    A[21] = sp[33] * PI0[0][1][6] + sp[34] * PI1[0][1][6] + sp[28] * PI2[0][1][6] + sp[31] * PI3[0][1][6] + sp[34] * PI1[0][6][1] + sp[35] * PI4[0][1][6] + sp[29] * PI5[0][1][6] + sp[32] * PI6[0][1][6] + sp[28] * PI2[0][6][1] + sp[29] * PI5[0][6][1] + sp[26] * PI7[0][1][6] + sp[27] * PI8[0][1][6] + sp[31] * PI3[0][6][1] + sp[32] * PI6[0][6][1] + sp[27] * PI8[0][6][1] + sp[30] * PI9[0][1][6];
    A[22] = sp[33] * PI0[0][1][7] + sp[34] * PI1[0][1][7] + sp[28] * PI2[0][1][7] + sp[31] * PI3[0][1][7] + sp[34] * PI1[0][7][1] + sp[35] * PI4[0][1][7] + sp[29] * PI5[0][1][7] + sp[32] * PI6[0][1][7] + sp[28] * PI2[0][7][1] + sp[29] * PI5[0][7][1] + sp[26] * PI7[0][1][7] + sp[27] * PI8[0][1][7] + sp[31] * PI3[0][7][1] + sp[32] * PI6[0][7][1] + sp[27] * PI8[0][7][1] + sp[30] * PI9[0][1][7];
    A[23] = sp[33] * PI0[0][1][8] + sp[34] * PI1[0][1][8] + sp[28] * PI2[0][1][8] + sp[31] * PI3[0][1][8] + sp[34] * PI1[0][8][1] + sp[35] * PI4[0][1][8] + sp[29] * PI5[0][1][8] + sp[32] * PI6[0][1][8] + sp[28] * PI2[0][8][1] + sp[29] * PI5[0][8][1] + sp[26] * PI7[0][1][8] + sp[27] * PI8[0][1][8] + sp[31] * PI3[0][8][1] + sp[32] * PI6[0][8][1] + sp[27] * PI8[0][8][1] + sp[30] * PI9[0][1][8];
    A[24] = sp[33] * PI0[0][1][9] + sp[34] * PI1[0][1][9] + sp[28] * PI2[0][1][9] + sp[31] * PI3[0][1][9] + sp[34] * PI1[0][9][1] + sp[35] * PI4[0][1][9] + sp[29] * PI5[0][1][9] + sp[32] * PI6[0][1][9] + sp[28] * PI2[0][9][1] + sp[29] * PI5[0][9][1] + sp[26] * PI7[0][1][9] + sp[27] * PI8[0][1][9] + sp[31] * PI3[0][9][1] + sp[32] * PI6[0][9][1] + sp[27] * PI8[0][9][1] + sp[30] * PI9[0][1][9];
    A[25] = sp[33] * PI0[0][1][10] + sp[34] * PI1[0][1][10] + sp[28] * PI2[0][1][10] + sp[31] * PI3[0][1][10] + sp[34] * PI1[0][10][1] + sp[35] * PI4[0][1][10] + sp[29] * PI5[0][1][10] + sp[32] * PI6[0][1][10] + sp[28] * PI2[0][10][1] + sp[29] * PI5[0][10][1] + sp[26] * PI7[0][1][10] + sp[27] * PI8[0][1][10] + sp[31] * PI3[0][10][1] + sp[32] * PI6[0][10][1] + sp[27] * PI8[0][10][1] + sp[30] * PI9[0][1][10];
    A[26] = sp[33] * PI0[0][1][11] + sp[34] * PI1[0][1][11] + sp[28] * PI2[0][1][11] + sp[31] * PI3[0][1][11] + sp[34] * PI1[0][11][1] + sp[35] * PI4[0][1][11] + sp[29] * PI5[0][1][11] + sp[32] * PI6[0][1][11] + sp[28] * PI2[0][11][1] + sp[29] * PI5[0][11][1] + sp[26] * PI7[0][1][11] + sp[27] * PI8[0][1][11] + sp[31] * PI3[0][11][1] + sp[32] * PI6[0][11][1] + sp[27] * PI8[0][11][1] + sp[30] * PI9[0][1][11];
    A[27] = sp[33] * PI0[0][1][12] + sp[34] * PI1[0][1][12] + sp[28] * PI2[0][1][12] + sp[31] * PI3[0][1][12] + sp[34] * PI1[0][12][1] + sp[35] * PI4[0][1][12] + sp[29] * PI5[0][1][12] + sp[32] * PI6[0][1][12] + sp[28] * PI2[0][12][1] + sp[29] * PI5[0][12][1] + sp[26] * PI7[0][1][12] + sp[27] * PI8[0][1][12] + sp[31] * PI3[0][12][1] + sp[32] * PI6[0][12][1] + sp[27] * PI8[0][12][1] + sp[30] * PI9[0][1][12];
    A[28] = sp[33] * PI0[0][1][13] + sp[34] * PI1[0][1][13] + sp[28] * PI2[0][1][13] + sp[31] * PI3[0][1][13] + sp[34] * PI1[0][13][1] + sp[35] * PI4[0][1][13] + sp[29] * PI5[0][1][13] + sp[32] * PI6[0][1][13] + sp[28] * PI2[0][13][1] + sp[29] * PI5[0][13][1] + sp[26] * PI7[0][1][13] + sp[27] * PI8[0][1][13] + sp[31] * PI3[0][13][1] + sp[32] * PI6[0][13][1] + sp[27] * PI8[0][13][1] + sp[30] * PI9[0][1][13];
    A[29] = sp[33] * PI0[0][1][14] + sp[34] * PI1[0][1][14] + sp[28] * PI2[0][1][14] + sp[31] * PI3[0][1][14] + sp[34] * PI1[0][14][1] + sp[35] * PI4[0][1][14] + sp[29] * PI5[0][1][14] + sp[32] * PI6[0][1][14] + sp[28] * PI2[0][14][1] + sp[29] * PI5[0][14][1] + sp[26] * PI7[0][1][14] + sp[27] * PI8[0][1][14] + sp[31] * PI3[0][14][1] + sp[32] * PI6[0][14][1] + sp[27] * PI8[0][14][1] + sp[30] * PI9[0][1][14];
    A[30] = sp[33] * PI0[0][2][0] + sp[34] * PI1[0][2][0] + sp[28] * PI2[0][2][0] + sp[31] * PI3[0][2][0] + sp[34] * PI1[0][0][2] + sp[35] * PI4[0][2][0] + sp[29] * PI5[0][2][0] + sp[32] * PI6[0][2][0] + sp[28] * PI2[0][0][2] + sp[29] * PI5[0][0][2] + sp[26] * PI7[0][2][0] + sp[27] * PI8[0][2][0] + sp[31] * PI3[0][0][2] + sp[32] * PI6[0][0][2] + sp[27] * PI8[0][0][2] + sp[30] * PI9[0][2][0];
    A[31] = sp[33] * PI0[0][2][1] + sp[34] * PI1[0][2][1] + sp[28] * PI2[0][2][1] + sp[31] * PI3[0][2][1] + sp[34] * PI1[0][1][2] + sp[35] * PI4[0][2][1] + sp[29] * PI5[0][2][1] + sp[32] * PI6[0][2][1] + sp[28] * PI2[0][1][2] + sp[29] * PI5[0][1][2] + sp[26] * PI7[0][2][1] + sp[27] * PI8[0][2][1] + sp[31] * PI3[0][1][2] + sp[32] * PI6[0][1][2] + sp[27] * PI8[0][1][2] + sp[30] * PI9[0][2][1];
    A[32] = sp[33] * PI0[0][2][2] + sp[34] * PI1[0][2][2] + sp[28] * PI2[0][2][2] + sp[31] * PI3[0][2][2] + sp[34] * PI1[0][2][2] + sp[35] * PI4[0][2][2] + sp[29] * PI5[0][2][2] + sp[32] * PI6[0][2][2] + sp[28] * PI2[0][2][2] + sp[29] * PI5[0][2][2] + sp[26] * PI7[0][2][2] + sp[27] * PI8[0][2][2] + sp[31] * PI3[0][2][2] + sp[32] * PI6[0][2][2] + sp[27] * PI8[0][2][2] + sp[30] * PI9[0][2][2];
    A[33] = sp[33] * PI0[0][2][3] + sp[34] * PI1[0][2][3] + sp[28] * PI2[0][2][3] + sp[31] * PI3[0][2][3] + sp[34] * PI1[0][3][2] + sp[35] * PI4[0][2][3] + sp[29] * PI5[0][2][3] + sp[32] * PI6[0][2][3] + sp[28] * PI2[0][3][2] + sp[29] * PI5[0][3][2] + sp[26] * PI7[0][2][3] + sp[27] * PI8[0][2][3] + sp[31] * PI3[0][3][2] + sp[32] * PI6[0][3][2] + sp[27] * PI8[0][3][2] + sp[30] * PI9[0][2][3];
    A[34] = sp[33] * PI0[0][2][4] + sp[34] * PI1[0][2][4] + sp[28] * PI2[0][2][4] + sp[31] * PI3[0][2][4] + sp[34] * PI1[0][4][2] + sp[35] * PI4[0][2][4] + sp[29] * PI5[0][2][4] + sp[32] * PI6[0][2][4] + sp[28] * PI2[0][4][2] + sp[29] * PI5[0][4][2] + sp[26] * PI7[0][2][4] + sp[27] * PI8[0][2][4] + sp[31] * PI3[0][4][2] + sp[32] * PI6[0][4][2] + sp[27] * PI8[0][4][2] + sp[30] * PI9[0][2][4];
    A[35] = sp[33] * PI0[0][2][5] + sp[34] * PI1[0][2][5] + sp[28] * PI2[0][2][5] + sp[31] * PI3[0][2][5] + sp[34] * PI1[0][5][2] + sp[35] * PI4[0][2][5] + sp[29] * PI5[0][2][5] + sp[32] * PI6[0][2][5] + sp[28] * PI2[0][5][2] + sp[29] * PI5[0][5][2] + sp[26] * PI7[0][2][5] + sp[27] * PI8[0][2][5] + sp[31] * PI3[0][5][2] + sp[32] * PI6[0][5][2] + sp[27] * PI8[0][5][2] + sp[30] * PI9[0][2][5];
    A[36] = sp[33] * PI0[0][2][6] + sp[34] * PI1[0][2][6] + sp[28] * PI2[0][2][6] + sp[31] * PI3[0][2][6] + sp[34] * PI1[0][6][2] + sp[35] * PI4[0][2][6] + sp[29] * PI5[0][2][6] + sp[32] * PI6[0][2][6] + sp[28] * PI2[0][6][2] + sp[29] * PI5[0][6][2] + sp[26] * PI7[0][2][6] + sp[27] * PI8[0][2][6] + sp[31] * PI3[0][6][2] + sp[32] * PI6[0][6][2] + sp[27] * PI8[0][6][2] + sp[30] * PI9[0][2][6];
    A[37] = sp[33] * PI0[0][2][7] + sp[34] * PI1[0][2][7] + sp[28] * PI2[0][2][7] + sp[31] * PI3[0][2][7] + sp[34] * PI1[0][7][2] + sp[35] * PI4[0][2][7] + sp[29] * PI5[0][2][7] + sp[32] * PI6[0][2][7] + sp[28] * PI2[0][7][2] + sp[29] * PI5[0][7][2] + sp[26] * PI7[0][2][7] + sp[27] * PI8[0][2][7] + sp[31] * PI3[0][7][2] + sp[32] * PI6[0][7][2] + sp[27] * PI8[0][7][2] + sp[30] * PI9[0][2][7];
    A[38] = sp[33] * PI0[0][2][8] + sp[34] * PI1[0][2][8] + sp[28] * PI2[0][2][8] + sp[31] * PI3[0][2][8] + sp[34] * PI1[0][8][2] + sp[35] * PI4[0][2][8] + sp[29] * PI5[0][2][8] + sp[32] * PI6[0][2][8] + sp[28] * PI2[0][8][2] + sp[29] * PI5[0][8][2] + sp[26] * PI7[0][2][8] + sp[27] * PI8[0][2][8] + sp[31] * PI3[0][8][2] + sp[32] * PI6[0][8][2] + sp[27] * PI8[0][8][2] + sp[30] * PI9[0][2][8];
    A[39] = sp[33] * PI0[0][2][9] + sp[34] * PI1[0][2][9] + sp[28] * PI2[0][2][9] + sp[31] * PI3[0][2][9] + sp[34] * PI1[0][9][2] + sp[35] * PI4[0][2][9] + sp[29] * PI5[0][2][9] + sp[32] * PI6[0][2][9] + sp[28] * PI2[0][9][2] + sp[29] * PI5[0][9][2] + sp[26] * PI7[0][2][9] + sp[27] * PI8[0][2][9] + sp[31] * PI3[0][9][2] + sp[32] * PI6[0][9][2] + sp[27] * PI8[0][9][2] + sp[30] * PI9[0][2][9];
    A[40] = sp[33] * PI0[0][2][10] + sp[34] * PI1[0][2][10] + sp[28] * PI2[0][2][10] + sp[31] * PI3[0][2][10] + sp[34] * PI1[0][10][2] + sp[35] * PI4[0][2][10] + sp[29] * PI5[0][2][10] + sp[32] * PI6[0][2][10] + sp[28] * PI2[0][10][2] + sp[29] * PI5[0][10][2] + sp[26] * PI7[0][2][10] + sp[27] * PI8[0][2][10] + sp[31] * PI3[0][10][2] + sp[32] * PI6[0][10][2] + sp[27] * PI8[0][10][2] + sp[30] * PI9[0][2][10];
    A[41] = sp[33] * PI0[0][2][11] + sp[34] * PI1[0][2][11] + sp[28] * PI2[0][2][11] + sp[31] * PI3[0][2][11] + sp[34] * PI1[0][11][2] + sp[35] * PI4[0][2][11] + sp[29] * PI5[0][2][11] + sp[32] * PI6[0][2][11] + sp[28] * PI2[0][11][2] + sp[29] * PI5[0][11][2] + sp[26] * PI7[0][2][11] + sp[27] * PI8[0][2][11] + sp[31] * PI3[0][11][2] + sp[32] * PI6[0][11][2] + sp[27] * PI8[0][11][2] + sp[30] * PI9[0][2][11];
    A[42] = sp[33] * PI0[0][2][12] + sp[34] * PI1[0][2][12] + sp[28] * PI2[0][2][12] + sp[31] * PI3[0][2][12] + sp[34] * PI1[0][12][2] + sp[35] * PI4[0][2][12] + sp[29] * PI5[0][2][12] + sp[32] * PI6[0][2][12] + sp[28] * PI2[0][12][2] + sp[29] * PI5[0][12][2] + sp[26] * PI7[0][2][12] + sp[27] * PI8[0][2][12] + sp[31] * PI3[0][12][2] + sp[32] * PI6[0][12][2] + sp[27] * PI8[0][12][2] + sp[30] * PI9[0][2][12];
    A[43] = sp[33] * PI0[0][2][13] + sp[34] * PI1[0][2][13] + sp[28] * PI2[0][2][13] + sp[31] * PI3[0][2][13] + sp[34] * PI1[0][13][2] + sp[35] * PI4[0][2][13] + sp[29] * PI5[0][2][13] + sp[32] * PI6[0][2][13] + sp[28] * PI2[0][13][2] + sp[29] * PI5[0][13][2] + sp[26] * PI7[0][2][13] + sp[27] * PI8[0][2][13] + sp[31] * PI3[0][13][2] + sp[32] * PI6[0][13][2] + sp[27] * PI8[0][13][2] + sp[30] * PI9[0][2][13];
    A[44] = sp[33] * PI0[0][2][14] + sp[34] * PI1[0][2][14] + sp[28] * PI2[0][2][14] + sp[31] * PI3[0][2][14] + sp[34] * PI1[0][14][2] + sp[35] * PI4[0][2][14] + sp[29] * PI5[0][2][14] + sp[32] * PI6[0][2][14] + sp[28] * PI2[0][14][2] + sp[29] * PI5[0][14][2] + sp[26] * PI7[0][2][14] + sp[27] * PI8[0][2][14] + sp[31] * PI3[0][14][2] + sp[32] * PI6[0][14][2] + sp[27] * PI8[0][14][2] + sp[30] * PI9[0][2][14];
    A[45] = sp[33] * PI0[0][3][0] + sp[34] * PI1[0][3][0] + sp[28] * PI2[0][3][0] + sp[31] * PI3[0][3][0] + sp[34] * PI1[0][0][3] + sp[35] * PI4[0][3][0] + sp[29] * PI5[0][3][0] + sp[32] * PI6[0][3][0] + sp[28] * PI2[0][0][3] + sp[29] * PI5[0][0][3] + sp[26] * PI7[0][3][0] + sp[27] * PI8[0][3][0] + sp[31] * PI3[0][0][3] + sp[32] * PI6[0][0][3] + sp[27] * PI8[0][0][3] + sp[30] * PI9[0][3][0];
    A[46] = sp[33] * PI0[0][3][1] + sp[34] * PI1[0][3][1] + sp[28] * PI2[0][3][1] + sp[31] * PI3[0][3][1] + sp[34] * PI1[0][1][3] + sp[35] * PI4[0][3][1] + sp[29] * PI5[0][3][1] + sp[32] * PI6[0][3][1] + sp[28] * PI2[0][1][3] + sp[29] * PI5[0][1][3] + sp[26] * PI7[0][3][1] + sp[27] * PI8[0][3][1] + sp[31] * PI3[0][1][3] + sp[32] * PI6[0][1][3] + sp[27] * PI8[0][1][3] + sp[30] * PI9[0][3][1];
    A[47] = sp[33] * PI0[0][3][2] + sp[34] * PI1[0][3][2] + sp[28] * PI2[0][3][2] + sp[31] * PI3[0][3][2] + sp[34] * PI1[0][2][3] + sp[35] * PI4[0][3][2] + sp[29] * PI5[0][3][2] + sp[32] * PI6[0][3][2] + sp[28] * PI2[0][2][3] + sp[29] * PI5[0][2][3] + sp[26] * PI7[0][3][2] + sp[27] * PI8[0][3][2] + sp[31] * PI3[0][2][3] + sp[32] * PI6[0][2][3] + sp[27] * PI8[0][2][3] + sp[30] * PI9[0][3][2];
    A[48] = sp[33] * PI0[0][3][3] + sp[34] * PI1[0][3][3] + sp[28] * PI2[0][3][3] + sp[31] * PI3[0][3][3] + sp[34] * PI1[0][3][3] + sp[35] * PI4[0][3][3] + sp[29] * PI5[0][3][3] + sp[32] * PI6[0][3][3] + sp[28] * PI2[0][3][3] + sp[29] * PI5[0][3][3] + sp[26] * PI7[0][3][3] + sp[27] * PI8[0][3][3] + sp[31] * PI3[0][3][3] + sp[32] * PI6[0][3][3] + sp[27] * PI8[0][3][3] + sp[30] * PI9[0][3][3];
    A[49] = sp[33] * PI0[0][3][4] + sp[34] * PI1[0][3][4] + sp[28] * PI2[0][3][4] + sp[31] * PI3[0][3][4] + sp[34] * PI1[0][4][3] + sp[35] * PI4[0][3][4] + sp[29] * PI5[0][3][4] + sp[32] * PI6[0][3][4] + sp[28] * PI2[0][4][3] + sp[29] * PI5[0][4][3] + sp[26] * PI7[0][3][4] + sp[27] * PI8[0][3][4] + sp[31] * PI3[0][4][3] + sp[32] * PI6[0][4][3] + sp[27] * PI8[0][4][3] + sp[30] * PI9[0][3][4];
    A[50] = sp[33] * PI0[0][3][5] + sp[34] * PI1[0][3][5] + sp[28] * PI2[0][3][5] + sp[31] * PI3[0][3][5] + sp[34] * PI1[0][5][3] + sp[35] * PI4[0][3][5] + sp[29] * PI5[0][3][5] + sp[32] * PI6[0][3][5] + sp[28] * PI2[0][5][3] + sp[29] * PI5[0][5][3] + sp[26] * PI7[0][3][5] + sp[27] * PI8[0][3][5] + sp[31] * PI3[0][5][3] + sp[32] * PI6[0][5][3] + sp[27] * PI8[0][5][3] + sp[30] * PI9[0][3][5];
    A[51] = sp[33] * PI0[0][3][6] + sp[34] * PI1[0][3][6] + sp[28] * PI2[0][3][6] + sp[31] * PI3[0][3][6] + sp[34] * PI1[0][6][3] + sp[35] * PI4[0][3][6] + sp[29] * PI5[0][3][6] + sp[32] * PI6[0][3][6] + sp[28] * PI2[0][6][3] + sp[29] * PI5[0][6][3] + sp[26] * PI7[0][3][6] + sp[27] * PI8[0][3][6] + sp[31] * PI3[0][6][3] + sp[32] * PI6[0][6][3] + sp[27] * PI8[0][6][3] + sp[30] * PI9[0][3][6];
    A[52] = sp[33] * PI0[0][3][7] + sp[34] * PI1[0][3][7] + sp[28] * PI2[0][3][7] + sp[31] * PI3[0][3][7] + sp[34] * PI1[0][7][3] + sp[35] * PI4[0][3][7] + sp[29] * PI5[0][3][7] + sp[32] * PI6[0][3][7] + sp[28] * PI2[0][7][3] + sp[29] * PI5[0][7][3] + sp[26] * PI7[0][3][7] + sp[27] * PI8[0][3][7] + sp[31] * PI3[0][7][3] + sp[32] * PI6[0][7][3] + sp[27] * PI8[0][7][3] + sp[30] * PI9[0][3][7];
    A[53] = sp[33] * PI0[0][3][8] + sp[34] * PI1[0][3][8] + sp[28] * PI2[0][3][8] + sp[31] * PI3[0][3][8] + sp[34] * PI1[0][8][3] + sp[35] * PI4[0][3][8] + sp[29] * PI5[0][3][8] + sp[32] * PI6[0][3][8] + sp[28] * PI2[0][8][3] + sp[29] * PI5[0][8][3] + sp[26] * PI7[0][3][8] + sp[27] * PI8[0][3][8] + sp[31] * PI3[0][8][3] + sp[32] * PI6[0][8][3] + sp[27] * PI8[0][8][3] + sp[30] * PI9[0][3][8];
    A[54] = sp[33] * PI0[0][3][9] + sp[34] * PI1[0][3][9] + sp[28] * PI2[0][3][9] + sp[31] * PI3[0][3][9] + sp[34] * PI1[0][9][3] + sp[35] * PI4[0][3][9] + sp[29] * PI5[0][3][9] + sp[32] * PI6[0][3][9] + sp[28] * PI2[0][9][3] + sp[29] * PI5[0][9][3] + sp[26] * PI7[0][3][9] + sp[27] * PI8[0][3][9] + sp[31] * PI3[0][9][3] + sp[32] * PI6[0][9][3] + sp[27] * PI8[0][9][3] + sp[30] * PI9[0][3][9];
    A[55] = sp[33] * PI0[0][3][10] + sp[34] * PI1[0][3][10] + sp[28] * PI2[0][3][10] + sp[31] * PI3[0][3][10] + sp[34] * PI1[0][10][3] + sp[35] * PI4[0][3][10] + sp[29] * PI5[0][3][10] + sp[32] * PI6[0][3][10] + sp[28] * PI2[0][10][3] + sp[29] * PI5[0][10][3] + sp[26] * PI7[0][3][10] + sp[27] * PI8[0][3][10] + sp[31] * PI3[0][10][3] + sp[32] * PI6[0][10][3] + sp[27] * PI8[0][10][3] + sp[30] * PI9[0][3][10];
    A[56] = sp[33] * PI0[0][3][11] + sp[34] * PI1[0][3][11] + sp[28] * PI2[0][3][11] + sp[31] * PI3[0][3][11] + sp[34] * PI1[0][11][3] + sp[35] * PI4[0][3][11] + sp[29] * PI5[0][3][11] + sp[32] * PI6[0][3][11] + sp[28] * PI2[0][11][3] + sp[29] * PI5[0][11][3] + sp[26] * PI7[0][3][11] + sp[27] * PI8[0][3][11] + sp[31] * PI3[0][11][3] + sp[32] * PI6[0][11][3] + sp[27] * PI8[0][11][3] + sp[30] * PI9[0][3][11];
    A[57] = sp[33] * PI0[0][3][12] + sp[34] * PI1[0][3][12] + sp[28] * PI2[0][3][12] + sp[31] * PI3[0][3][12] + sp[34] * PI1[0][12][3] + sp[35] * PI4[0][3][12] + sp[29] * PI5[0][3][12] + sp[32] * PI6[0][3][12] + sp[28] * PI2[0][12][3] + sp[29] * PI5[0][12][3] + sp[26] * PI7[0][3][12] + sp[27] * PI8[0][3][12] + sp[31] * PI3[0][12][3] + sp[32] * PI6[0][12][3] + sp[27] * PI8[0][12][3] + sp[30] * PI9[0][3][12];
    A[58] = sp[33] * PI0[0][3][13] + sp[34] * PI1[0][3][13] + sp[28] * PI2[0][3][13] + sp[31] * PI3[0][3][13] + sp[34] * PI1[0][13][3] + sp[35] * PI4[0][3][13] + sp[29] * PI5[0][3][13] + sp[32] * PI6[0][3][13] + sp[28] * PI2[0][13][3] + sp[29] * PI5[0][13][3] + sp[26] * PI7[0][3][13] + sp[27] * PI8[0][3][13] + sp[31] * PI3[0][13][3] + sp[32] * PI6[0][13][3] + sp[27] * PI8[0][13][3] + sp[30] * PI9[0][3][13];
    A[59] = sp[33] * PI0[0][3][14] + sp[34] * PI1[0][3][14] + sp[28] * PI2[0][3][14] + sp[31] * PI3[0][3][14] + sp[34] * PI1[0][14][3] + sp[35] * PI4[0][3][14] + sp[29] * PI5[0][3][14] + sp[32] * PI6[0][3][14] + sp[28] * PI2[0][14][3] + sp[29] * PI5[0][14][3] + sp[26] * PI7[0][3][14] + sp[27] * PI8[0][3][14] + sp[31] * PI3[0][14][3] + sp[32] * PI6[0][14][3] + sp[27] * PI8[0][14][3] + sp[30] * PI9[0][3][14];
    A[60] = sp[33] * PI0[0][4][0] + sp[34] * PI1[0][4][0] + sp[28] * PI2[0][4][0] + sp[31] * PI3[0][4][0] + sp[34] * PI1[0][0][4] + sp[35] * PI4[0][4][0] + sp[29] * PI5[0][4][0] + sp[32] * PI6[0][4][0] + sp[28] * PI2[0][0][4] + sp[29] * PI5[0][0][4] + sp[26] * PI7[0][4][0] + sp[27] * PI8[0][4][0] + sp[31] * PI3[0][0][4] + sp[32] * PI6[0][0][4] + sp[27] * PI8[0][0][4] + sp[30] * PI9[0][4][0];
    A[61] = sp[33] * PI0[0][4][1] + sp[34] * PI1[0][4][1] + sp[28] * PI2[0][4][1] + sp[31] * PI3[0][4][1] + sp[34] * PI1[0][1][4] + sp[35] * PI4[0][4][1] + sp[29] * PI5[0][4][1] + sp[32] * PI6[0][4][1] + sp[28] * PI2[0][1][4] + sp[29] * PI5[0][1][4] + sp[26] * PI7[0][4][1] + sp[27] * PI8[0][4][1] + sp[31] * PI3[0][1][4] + sp[32] * PI6[0][1][4] + sp[27] * PI8[0][1][4] + sp[30] * PI9[0][4][1];
    A[62] = sp[33] * PI0[0][4][2] + sp[34] * PI1[0][4][2] + sp[28] * PI2[0][4][2] + sp[31] * PI3[0][4][2] + sp[34] * PI1[0][2][4] + sp[35] * PI4[0][4][2] + sp[29] * PI5[0][4][2] + sp[32] * PI6[0][4][2] + sp[28] * PI2[0][2][4] + sp[29] * PI5[0][2][4] + sp[26] * PI7[0][4][2] + sp[27] * PI8[0][4][2] + sp[31] * PI3[0][2][4] + sp[32] * PI6[0][2][4] + sp[27] * PI8[0][2][4] + sp[30] * PI9[0][4][2];
    A[63] = sp[33] * PI0[0][4][3] + sp[34] * PI1[0][4][3] + sp[28] * PI2[0][4][3] + sp[31] * PI3[0][4][3] + sp[34] * PI1[0][3][4] + sp[35] * PI4[0][4][3] + sp[29] * PI5[0][4][3] + sp[32] * PI6[0][4][3] + sp[28] * PI2[0][3][4] + sp[29] * PI5[0][3][4] + sp[26] * PI7[0][4][3] + sp[27] * PI8[0][4][3] + sp[31] * PI3[0][3][4] + sp[32] * PI6[0][3][4] + sp[27] * PI8[0][3][4] + sp[30] * PI9[0][4][3];
    A[64] = sp[33] * PI0[0][4][4] + sp[34] * PI1[0][4][4] + sp[28] * PI2[0][4][4] + sp[31] * PI3[0][4][4] + sp[34] * PI1[0][4][4] + sp[35] * PI4[0][4][4] + sp[29] * PI5[0][4][4] + sp[32] * PI6[0][4][4] + sp[28] * PI2[0][4][4] + sp[29] * PI5[0][4][4] + sp[26] * PI7[0][4][4] + sp[27] * PI8[0][4][4] + sp[31] * PI3[0][4][4] + sp[32] * PI6[0][4][4] + sp[27] * PI8[0][4][4] + sp[30] * PI9[0][4][4];
    A[65] = sp[33] * PI0[0][4][5] + sp[34] * PI1[0][4][5] + sp[28] * PI2[0][4][5] + sp[31] * PI3[0][4][5] + sp[34] * PI1[0][5][4] + sp[35] * PI4[0][4][5] + sp[29] * PI5[0][4][5] + sp[32] * PI6[0][4][5] + sp[28] * PI2[0][5][4] + sp[29] * PI5[0][5][4] + sp[26] * PI7[0][4][5] + sp[27] * PI8[0][4][5] + sp[31] * PI3[0][5][4] + sp[32] * PI6[0][5][4] + sp[27] * PI8[0][5][4] + sp[30] * PI9[0][4][5];
    A[66] = sp[33] * PI0[0][4][6] + sp[34] * PI1[0][4][6] + sp[28] * PI2[0][4][6] + sp[31] * PI3[0][4][6] + sp[34] * PI1[0][6][4] + sp[35] * PI4[0][4][6] + sp[29] * PI5[0][4][6] + sp[32] * PI6[0][4][6] + sp[28] * PI2[0][6][4] + sp[29] * PI5[0][6][4] + sp[26] * PI7[0][4][6] + sp[27] * PI8[0][4][6] + sp[31] * PI3[0][6][4] + sp[32] * PI6[0][6][4] + sp[27] * PI8[0][6][4] + sp[30] * PI9[0][4][6];
    A[67] = sp[33] * PI0[0][4][7] + sp[34] * PI1[0][4][7] + sp[28] * PI2[0][4][7] + sp[31] * PI3[0][4][7] + sp[34] * PI1[0][7][4] + sp[35] * PI4[0][4][7] + sp[29] * PI5[0][4][7] + sp[32] * PI6[0][4][7] + sp[28] * PI2[0][7][4] + sp[29] * PI5[0][7][4] + sp[26] * PI7[0][4][7] + sp[27] * PI8[0][4][7] + sp[31] * PI3[0][7][4] + sp[32] * PI6[0][7][4] + sp[27] * PI8[0][7][4] + sp[30] * PI9[0][4][7];
    A[68] = sp[33] * PI0[0][4][8] + sp[34] * PI1[0][4][8] + sp[28] * PI2[0][4][8] + sp[31] * PI3[0][4][8] + sp[34] * PI1[0][8][4] + sp[35] * PI4[0][4][8] + sp[29] * PI5[0][4][8] + sp[32] * PI6[0][4][8] + sp[28] * PI2[0][8][4] + sp[29] * PI5[0][8][4] + sp[26] * PI7[0][4][8] + sp[27] * PI8[0][4][8] + sp[31] * PI3[0][8][4] + sp[32] * PI6[0][8][4] + sp[27] * PI8[0][8][4] + sp[30] * PI9[0][4][8];
    A[69] = sp[33] * PI0[0][4][9] + sp[34] * PI1[0][4][9] + sp[28] * PI2[0][4][9] + sp[31] * PI3[0][4][9] + sp[34] * PI1[0][9][4] + sp[35] * PI4[0][4][9] + sp[29] * PI5[0][4][9] + sp[32] * PI6[0][4][9] + sp[28] * PI2[0][9][4] + sp[29] * PI5[0][9][4] + sp[26] * PI7[0][4][9] + sp[27] * PI8[0][4][9] + sp[31] * PI3[0][9][4] + sp[32] * PI6[0][9][4] + sp[27] * PI8[0][9][4] + sp[30] * PI9[0][4][9];
    A[70] = sp[33] * PI0[0][4][10] + sp[34] * PI1[0][4][10] + sp[28] * PI2[0][4][10] + sp[31] * PI3[0][4][10] + sp[34] * PI1[0][10][4] + sp[35] * PI4[0][4][10] + sp[29] * PI5[0][4][10] + sp[32] * PI6[0][4][10] + sp[28] * PI2[0][10][4] + sp[29] * PI5[0][10][4] + sp[26] * PI7[0][4][10] + sp[27] * PI8[0][4][10] + sp[31] * PI3[0][10][4] + sp[32] * PI6[0][10][4] + sp[27] * PI8[0][10][4] + sp[30] * PI9[0][4][10];
    A[71] = sp[33] * PI0[0][4][11] + sp[34] * PI1[0][4][11] + sp[28] * PI2[0][4][11] + sp[31] * PI3[0][4][11] + sp[34] * PI1[0][11][4] + sp[35] * PI4[0][4][11] + sp[29] * PI5[0][4][11] + sp[32] * PI6[0][4][11] + sp[28] * PI2[0][11][4] + sp[29] * PI5[0][11][4] + sp[26] * PI7[0][4][11] + sp[27] * PI8[0][4][11] + sp[31] * PI3[0][11][4] + sp[32] * PI6[0][11][4] + sp[27] * PI8[0][11][4] + sp[30] * PI9[0][4][11];
    A[72] = sp[33] * PI0[0][4][12] + sp[34] * PI1[0][4][12] + sp[28] * PI2[0][4][12] + sp[31] * PI3[0][4][12] + sp[34] * PI1[0][12][4] + sp[35] * PI4[0][4][12] + sp[29] * PI5[0][4][12] + sp[32] * PI6[0][4][12] + sp[28] * PI2[0][12][4] + sp[29] * PI5[0][12][4] + sp[26] * PI7[0][4][12] + sp[27] * PI8[0][4][12] + sp[31] * PI3[0][12][4] + sp[32] * PI6[0][12][4] + sp[27] * PI8[0][12][4] + sp[30] * PI9[0][4][12];
    A[73] = sp[33] * PI0[0][4][13] + sp[34] * PI1[0][4][13] + sp[28] * PI2[0][4][13] + sp[31] * PI3[0][4][13] + sp[34] * PI1[0][13][4] + sp[35] * PI4[0][4][13] + sp[29] * PI5[0][4][13] + sp[32] * PI6[0][4][13] + sp[28] * PI2[0][13][4] + sp[29] * PI5[0][13][4] + sp[26] * PI7[0][4][13] + sp[27] * PI8[0][4][13] + sp[31] * PI3[0][13][4] + sp[32] * PI6[0][13][4] + sp[27] * PI8[0][13][4] + sp[30] * PI9[0][4][13];
    A[74] = sp[33] * PI0[0][4][14] + sp[34] * PI1[0][4][14] + sp[28] * PI2[0][4][14] + sp[31] * PI3[0][4][14] + sp[34] * PI1[0][14][4] + sp[35] * PI4[0][4][14] + sp[29] * PI5[0][4][14] + sp[32] * PI6[0][4][14] + sp[28] * PI2[0][14][4] + sp[29] * PI5[0][14][4] + sp[26] * PI7[0][4][14] + sp[27] * PI8[0][4][14] + sp[31] * PI3[0][14][4] + sp[32] * PI6[0][14][4] + sp[27] * PI8[0][14][4] + sp[30] * PI9[0][4][14];
    A[75] = sp[33] * PI0[0][5][0] + sp[34] * PI1[0][5][0] + sp[28] * PI2[0][5][0] + sp[31] * PI3[0][5][0] + sp[34] * PI1[0][0][5] + sp[35] * PI4[0][5][0] + sp[29] * PI5[0][5][0] + sp[32] * PI6[0][5][0] + sp[28] * PI2[0][0][5] + sp[29] * PI5[0][0][5] + sp[26] * PI7[0][5][0] + sp[27] * PI8[0][5][0] + sp[31] * PI3[0][0][5] + sp[32] * PI6[0][0][5] + sp[27] * PI8[0][0][5] + sp[30] * PI9[0][5][0];
    A[76] = sp[33] * PI0[0][5][1] + sp[34] * PI1[0][5][1] + sp[28] * PI2[0][5][1] + sp[31] * PI3[0][5][1] + sp[34] * PI1[0][1][5] + sp[35] * PI4[0][5][1] + sp[29] * PI5[0][5][1] + sp[32] * PI6[0][5][1] + sp[28] * PI2[0][1][5] + sp[29] * PI5[0][1][5] + sp[26] * PI7[0][5][1] + sp[27] * PI8[0][5][1] + sp[31] * PI3[0][1][5] + sp[32] * PI6[0][1][5] + sp[27] * PI8[0][1][5] + sp[30] * PI9[0][5][1];
    A[77] = sp[33] * PI0[0][5][2] + sp[34] * PI1[0][5][2] + sp[28] * PI2[0][5][2] + sp[31] * PI3[0][5][2] + sp[34] * PI1[0][2][5] + sp[35] * PI4[0][5][2] + sp[29] * PI5[0][5][2] + sp[32] * PI6[0][5][2] + sp[28] * PI2[0][2][5] + sp[29] * PI5[0][2][5] + sp[26] * PI7[0][5][2] + sp[27] * PI8[0][5][2] + sp[31] * PI3[0][2][5] + sp[32] * PI6[0][2][5] + sp[27] * PI8[0][2][5] + sp[30] * PI9[0][5][2];
    A[78] = sp[33] * PI0[0][5][3] + sp[34] * PI1[0][5][3] + sp[28] * PI2[0][5][3] + sp[31] * PI3[0][5][3] + sp[34] * PI1[0][3][5] + sp[35] * PI4[0][5][3] + sp[29] * PI5[0][5][3] + sp[32] * PI6[0][5][3] + sp[28] * PI2[0][3][5] + sp[29] * PI5[0][3][5] + sp[26] * PI7[0][5][3] + sp[27] * PI8[0][5][3] + sp[31] * PI3[0][3][5] + sp[32] * PI6[0][3][5] + sp[27] * PI8[0][3][5] + sp[30] * PI9[0][5][3];
    A[79] = sp[33] * PI0[0][5][4] + sp[34] * PI1[0][5][4] + sp[28] * PI2[0][5][4] + sp[31] * PI3[0][5][4] + sp[34] * PI1[0][4][5] + sp[35] * PI4[0][5][4] + sp[29] * PI5[0][5][4] + sp[32] * PI6[0][5][4] + sp[28] * PI2[0][4][5] + sp[29] * PI5[0][4][5] + sp[26] * PI7[0][5][4] + sp[27] * PI8[0][5][4] + sp[31] * PI3[0][4][5] + sp[32] * PI6[0][4][5] + sp[27] * PI8[0][4][5] + sp[30] * PI9[0][5][4];
    A[80] = sp[33] * PI0[0][5][5] + sp[34] * PI1[0][5][5] + sp[28] * PI2[0][5][5] + sp[31] * PI3[0][5][5] + sp[34] * PI1[0][5][5] + sp[35] * PI4[0][5][5] + sp[29] * PI5[0][5][5] + sp[32] * PI6[0][5][5] + sp[28] * PI2[0][5][5] + sp[29] * PI5[0][5][5] + sp[26] * PI7[0][5][5] + sp[27] * PI8[0][5][5] + sp[31] * PI3[0][5][5] + sp[32] * PI6[0][5][5] + sp[27] * PI8[0][5][5] + sp[30] * PI9[0][5][5];
    A[81] = sp[33] * PI0[0][5][6] + sp[34] * PI1[0][5][6] + sp[28] * PI2[0][5][6] + sp[31] * PI3[0][5][6] + sp[34] * PI1[0][6][5] + sp[35] * PI4[0][5][6] + sp[29] * PI5[0][5][6] + sp[32] * PI6[0][5][6] + sp[28] * PI2[0][6][5] + sp[29] * PI5[0][6][5] + sp[26] * PI7[0][5][6] + sp[27] * PI8[0][5][6] + sp[31] * PI3[0][6][5] + sp[32] * PI6[0][6][5] + sp[27] * PI8[0][6][5] + sp[30] * PI9[0][5][6];
    A[82] = sp[33] * PI0[0][5][7] + sp[34] * PI1[0][5][7] + sp[28] * PI2[0][5][7] + sp[31] * PI3[0][5][7] + sp[34] * PI1[0][7][5] + sp[35] * PI4[0][5][7] + sp[29] * PI5[0][5][7] + sp[32] * PI6[0][5][7] + sp[28] * PI2[0][7][5] + sp[29] * PI5[0][7][5] + sp[26] * PI7[0][5][7] + sp[27] * PI8[0][5][7] + sp[31] * PI3[0][7][5] + sp[32] * PI6[0][7][5] + sp[27] * PI8[0][7][5] + sp[30] * PI9[0][5][7];
    A[83] = sp[33] * PI0[0][5][8] + sp[34] * PI1[0][5][8] + sp[28] * PI2[0][5][8] + sp[31] * PI3[0][5][8] + sp[34] * PI1[0][8][5] + sp[35] * PI4[0][5][8] + sp[29] * PI5[0][5][8] + sp[32] * PI6[0][5][8] + sp[28] * PI2[0][8][5] + sp[29] * PI5[0][8][5] + sp[26] * PI7[0][5][8] + sp[27] * PI8[0][5][8] + sp[31] * PI3[0][8][5] + sp[32] * PI6[0][8][5] + sp[27] * PI8[0][8][5] + sp[30] * PI9[0][5][8];
    A[84] = sp[33] * PI0[0][5][9] + sp[34] * PI1[0][5][9] + sp[28] * PI2[0][5][9] + sp[31] * PI3[0][5][9] + sp[34] * PI1[0][9][5] + sp[35] * PI4[0][5][9] + sp[29] * PI5[0][5][9] + sp[32] * PI6[0][5][9] + sp[28] * PI2[0][9][5] + sp[29] * PI5[0][9][5] + sp[26] * PI7[0][5][9] + sp[27] * PI8[0][5][9] + sp[31] * PI3[0][9][5] + sp[32] * PI6[0][9][5] + sp[27] * PI8[0][9][5] + sp[30] * PI9[0][5][9];
    A[85] = sp[33] * PI0[0][5][10] + sp[34] * PI1[0][5][10] + sp[28] * PI2[0][5][10] + sp[31] * PI3[0][5][10] + sp[34] * PI1[0][10][5] + sp[35] * PI4[0][5][10] + sp[29] * PI5[0][5][10] + sp[32] * PI6[0][5][10] + sp[28] * PI2[0][10][5] + sp[29] * PI5[0][10][5] + sp[26] * PI7[0][5][10] + sp[27] * PI8[0][5][10] + sp[31] * PI3[0][10][5] + sp[32] * PI6[0][10][5] + sp[27] * PI8[0][10][5] + sp[30] * PI9[0][5][10];
    A[86] = sp[33] * PI0[0][5][11] + sp[34] * PI1[0][5][11] + sp[28] * PI2[0][5][11] + sp[31] * PI3[0][5][11] + sp[34] * PI1[0][11][5] + sp[35] * PI4[0][5][11] + sp[29] * PI5[0][5][11] + sp[32] * PI6[0][5][11] + sp[28] * PI2[0][11][5] + sp[29] * PI5[0][11][5] + sp[26] * PI7[0][5][11] + sp[27] * PI8[0][5][11] + sp[31] * PI3[0][11][5] + sp[32] * PI6[0][11][5] + sp[27] * PI8[0][11][5] + sp[30] * PI9[0][5][11];
    A[87] = sp[33] * PI0[0][5][12] + sp[34] * PI1[0][5][12] + sp[28] * PI2[0][5][12] + sp[31] * PI3[0][5][12] + sp[34] * PI1[0][12][5] + sp[35] * PI4[0][5][12] + sp[29] * PI5[0][5][12] + sp[32] * PI6[0][5][12] + sp[28] * PI2[0][12][5] + sp[29] * PI5[0][12][5] + sp[26] * PI7[0][5][12] + sp[27] * PI8[0][5][12] + sp[31] * PI3[0][12][5] + sp[32] * PI6[0][12][5] + sp[27] * PI8[0][12][5] + sp[30] * PI9[0][5][12];
    A[88] = sp[33] * PI0[0][5][13] + sp[34] * PI1[0][5][13] + sp[28] * PI2[0][5][13] + sp[31] * PI3[0][5][13] + sp[34] * PI1[0][13][5] + sp[35] * PI4[0][5][13] + sp[29] * PI5[0][5][13] + sp[32] * PI6[0][5][13] + sp[28] * PI2[0][13][5] + sp[29] * PI5[0][13][5] + sp[26] * PI7[0][5][13] + sp[27] * PI8[0][5][13] + sp[31] * PI3[0][13][5] + sp[32] * PI6[0][13][5] + sp[27] * PI8[0][13][5] + sp[30] * PI9[0][5][13];
    A[89] = sp[33] * PI0[0][5][14] + sp[34] * PI1[0][5][14] + sp[28] * PI2[0][5][14] + sp[31] * PI3[0][5][14] + sp[34] * PI1[0][14][5] + sp[35] * PI4[0][5][14] + sp[29] * PI5[0][5][14] + sp[32] * PI6[0][5][14] + sp[28] * PI2[0][14][5] + sp[29] * PI5[0][14][5] + sp[26] * PI7[0][5][14] + sp[27] * PI8[0][5][14] + sp[31] * PI3[0][14][5] + sp[32] * PI6[0][14][5] + sp[27] * PI8[0][14][5] + sp[30] * PI9[0][5][14];
    A[90] = sp[33] * PI0[0][6][0] + sp[34] * PI1[0][6][0] + sp[28] * PI2[0][6][0] + sp[31] * PI3[0][6][0] + sp[34] * PI1[0][0][6] + sp[35] * PI4[0][6][0] + sp[29] * PI5[0][6][0] + sp[32] * PI6[0][6][0] + sp[28] * PI2[0][0][6] + sp[29] * PI5[0][0][6] + sp[26] * PI7[0][6][0] + sp[27] * PI8[0][6][0] + sp[31] * PI3[0][0][6] + sp[32] * PI6[0][0][6] + sp[27] * PI8[0][0][6] + sp[30] * PI9[0][6][0];
    A[91] = sp[33] * PI0[0][6][1] + sp[34] * PI1[0][6][1] + sp[28] * PI2[0][6][1] + sp[31] * PI3[0][6][1] + sp[34] * PI1[0][1][6] + sp[35] * PI4[0][6][1] + sp[29] * PI5[0][6][1] + sp[32] * PI6[0][6][1] + sp[28] * PI2[0][1][6] + sp[29] * PI5[0][1][6] + sp[26] * PI7[0][6][1] + sp[27] * PI8[0][6][1] + sp[31] * PI3[0][1][6] + sp[32] * PI6[0][1][6] + sp[27] * PI8[0][1][6] + sp[30] * PI9[0][6][1];
    A[92] = sp[33] * PI0[0][6][2] + sp[34] * PI1[0][6][2] + sp[28] * PI2[0][6][2] + sp[31] * PI3[0][6][2] + sp[34] * PI1[0][2][6] + sp[35] * PI4[0][6][2] + sp[29] * PI5[0][6][2] + sp[32] * PI6[0][6][2] + sp[28] * PI2[0][2][6] + sp[29] * PI5[0][2][6] + sp[26] * PI7[0][6][2] + sp[27] * PI8[0][6][2] + sp[31] * PI3[0][2][6] + sp[32] * PI6[0][2][6] + sp[27] * PI8[0][2][6] + sp[30] * PI9[0][6][2];
    A[93] = sp[33] * PI0[0][6][3] + sp[34] * PI1[0][6][3] + sp[28] * PI2[0][6][3] + sp[31] * PI3[0][6][3] + sp[34] * PI1[0][3][6] + sp[35] * PI4[0][6][3] + sp[29] * PI5[0][6][3] + sp[32] * PI6[0][6][3] + sp[28] * PI2[0][3][6] + sp[29] * PI5[0][3][6] + sp[26] * PI7[0][6][3] + sp[27] * PI8[0][6][3] + sp[31] * PI3[0][3][6] + sp[32] * PI6[0][3][6] + sp[27] * PI8[0][3][6] + sp[30] * PI9[0][6][3];
    A[94] = sp[33] * PI0[0][6][4] + sp[34] * PI1[0][6][4] + sp[28] * PI2[0][6][4] + sp[31] * PI3[0][6][4] + sp[34] * PI1[0][4][6] + sp[35] * PI4[0][6][4] + sp[29] * PI5[0][6][4] + sp[32] * PI6[0][6][4] + sp[28] * PI2[0][4][6] + sp[29] * PI5[0][4][6] + sp[26] * PI7[0][6][4] + sp[27] * PI8[0][6][4] + sp[31] * PI3[0][4][6] + sp[32] * PI6[0][4][6] + sp[27] * PI8[0][4][6] + sp[30] * PI9[0][6][4];
    A[95] = sp[33] * PI0[0][6][5] + sp[34] * PI1[0][6][5] + sp[28] * PI2[0][6][5] + sp[31] * PI3[0][6][5] + sp[34] * PI1[0][5][6] + sp[35] * PI4[0][6][5] + sp[29] * PI5[0][6][5] + sp[32] * PI6[0][6][5] + sp[28] * PI2[0][5][6] + sp[29] * PI5[0][5][6] + sp[26] * PI7[0][6][5] + sp[27] * PI8[0][6][5] + sp[31] * PI3[0][5][6] + sp[32] * PI6[0][5][6] + sp[27] * PI8[0][5][6] + sp[30] * PI9[0][6][5];
    A[96] = sp[33] * PI0[0][6][6] + sp[34] * PI1[0][6][6] + sp[28] * PI2[0][6][6] + sp[31] * PI3[0][6][6] + sp[34] * PI1[0][6][6] + sp[35] * PI4[0][6][6] + sp[29] * PI5[0][6][6] + sp[32] * PI6[0][6][6] + sp[28] * PI2[0][6][6] + sp[29] * PI5[0][6][6] + sp[26] * PI7[0][6][6] + sp[27] * PI8[0][6][6] + sp[31] * PI3[0][6][6] + sp[32] * PI6[0][6][6] + sp[27] * PI8[0][6][6] + sp[30] * PI9[0][6][6];
    A[97] = sp[33] * PI0[0][6][7] + sp[34] * PI1[0][6][7] + sp[28] * PI2[0][6][7] + sp[31] * PI3[0][6][7] + sp[34] * PI1[0][7][6] + sp[35] * PI4[0][6][7] + sp[29] * PI5[0][6][7] + sp[32] * PI6[0][6][7] + sp[28] * PI2[0][7][6] + sp[29] * PI5[0][7][6] + sp[26] * PI7[0][6][7] + sp[27] * PI8[0][6][7] + sp[31] * PI3[0][7][6] + sp[32] * PI6[0][7][6] + sp[27] * PI8[0][7][6] + sp[30] * PI9[0][6][7];
    A[98] = sp[33] * PI0[0][6][8] + sp[34] * PI1[0][6][8] + sp[28] * PI2[0][6][8] + sp[31] * PI3[0][6][8] + sp[34] * PI1[0][8][6] + sp[35] * PI4[0][6][8] + sp[29] * PI5[0][6][8] + sp[32] * PI6[0][6][8] + sp[28] * PI2[0][8][6] + sp[29] * PI5[0][8][6] + sp[26] * PI7[0][6][8] + sp[27] * PI8[0][6][8] + sp[31] * PI3[0][8][6] + sp[32] * PI6[0][8][6] + sp[27] * PI8[0][8][6] + sp[30] * PI9[0][6][8];
    A[99] = sp[33] * PI0[0][6][9] + sp[34] * PI1[0][6][9] + sp[28] * PI2[0][6][9] + sp[31] * PI3[0][6][9] + sp[34] * PI1[0][9][6] + sp[35] * PI4[0][6][9] + sp[29] * PI5[0][6][9] + sp[32] * PI6[0][6][9] + sp[28] * PI2[0][9][6] + sp[29] * PI5[0][9][6] + sp[26] * PI7[0][6][9] + sp[27] * PI8[0][6][9] + sp[31] * PI3[0][9][6] + sp[32] * PI6[0][9][6] + sp[27] * PI8[0][9][6] + sp[30] * PI9[0][6][9];
    A[100] = sp[33] * PI0[0][6][10] + sp[34] * PI1[0][6][10] + sp[28] * PI2[0][6][10] + sp[31] * PI3[0][6][10] + sp[34] * PI1[0][10][6] + sp[35] * PI4[0][6][10] + sp[29] * PI5[0][6][10] + sp[32] * PI6[0][6][10] + sp[28] * PI2[0][10][6] + sp[29] * PI5[0][10][6] + sp[26] * PI7[0][6][10] + sp[27] * PI8[0][6][10] + sp[31] * PI3[0][10][6] + sp[32] * PI6[0][10][6] + sp[27] * PI8[0][10][6] + sp[30] * PI9[0][6][10];
    A[101] = sp[33] * PI0[0][6][11] + sp[34] * PI1[0][6][11] + sp[28] * PI2[0][6][11] + sp[31] * PI3[0][6][11] + sp[34] * PI1[0][11][6] + sp[35] * PI4[0][6][11] + sp[29] * PI5[0][6][11] + sp[32] * PI6[0][6][11] + sp[28] * PI2[0][11][6] + sp[29] * PI5[0][11][6] + sp[26] * PI7[0][6][11] + sp[27] * PI8[0][6][11] + sp[31] * PI3[0][11][6] + sp[32] * PI6[0][11][6] + sp[27] * PI8[0][11][6] + sp[30] * PI9[0][6][11];
    A[102] = sp[33] * PI0[0][6][12] + sp[34] * PI1[0][6][12] + sp[28] * PI2[0][6][12] + sp[31] * PI3[0][6][12] + sp[34] * PI1[0][12][6] + sp[35] * PI4[0][6][12] + sp[29] * PI5[0][6][12] + sp[32] * PI6[0][6][12] + sp[28] * PI2[0][12][6] + sp[29] * PI5[0][12][6] + sp[26] * PI7[0][6][12] + sp[27] * PI8[0][6][12] + sp[31] * PI3[0][12][6] + sp[32] * PI6[0][12][6] + sp[27] * PI8[0][12][6] + sp[30] * PI9[0][6][12];
    A[103] = sp[33] * PI0[0][6][13] + sp[34] * PI1[0][6][13] + sp[28] * PI2[0][6][13] + sp[31] * PI3[0][6][13] + sp[34] * PI1[0][13][6] + sp[35] * PI4[0][6][13] + sp[29] * PI5[0][6][13] + sp[32] * PI6[0][6][13] + sp[28] * PI2[0][13][6] + sp[29] * PI5[0][13][6] + sp[26] * PI7[0][6][13] + sp[27] * PI8[0][6][13] + sp[31] * PI3[0][13][6] + sp[32] * PI6[0][13][6] + sp[27] * PI8[0][13][6] + sp[30] * PI9[0][6][13];
    A[104] = sp[33] * PI0[0][6][14] + sp[34] * PI1[0][6][14] + sp[28] * PI2[0][6][14] + sp[31] * PI3[0][6][14] + sp[34] * PI1[0][14][6] + sp[35] * PI4[0][6][14] + sp[29] * PI5[0][6][14] + sp[32] * PI6[0][6][14] + sp[28] * PI2[0][14][6] + sp[29] * PI5[0][14][6] + sp[26] * PI7[0][6][14] + sp[27] * PI8[0][6][14] + sp[31] * PI3[0][14][6] + sp[32] * PI6[0][14][6] + sp[27] * PI8[0][14][6] + sp[30] * PI9[0][6][14];
    A[105] = sp[33] * PI0[0][7][0] + sp[34] * PI1[0][7][0] + sp[28] * PI2[0][7][0] + sp[31] * PI3[0][7][0] + sp[34] * PI1[0][0][7] + sp[35] * PI4[0][7][0] + sp[29] * PI5[0][7][0] + sp[32] * PI6[0][7][0] + sp[28] * PI2[0][0][7] + sp[29] * PI5[0][0][7] + sp[26] * PI7[0][7][0] + sp[27] * PI8[0][7][0] + sp[31] * PI3[0][0][7] + sp[32] * PI6[0][0][7] + sp[27] * PI8[0][0][7] + sp[30] * PI9[0][7][0];
    A[106] = sp[33] * PI0[0][7][1] + sp[34] * PI1[0][7][1] + sp[28] * PI2[0][7][1] + sp[31] * PI3[0][7][1] + sp[34] * PI1[0][1][7] + sp[35] * PI4[0][7][1] + sp[29] * PI5[0][7][1] + sp[32] * PI6[0][7][1] + sp[28] * PI2[0][1][7] + sp[29] * PI5[0][1][7] + sp[26] * PI7[0][7][1] + sp[27] * PI8[0][7][1] + sp[31] * PI3[0][1][7] + sp[32] * PI6[0][1][7] + sp[27] * PI8[0][1][7] + sp[30] * PI9[0][7][1];
    A[107] = sp[33] * PI0[0][7][2] + sp[34] * PI1[0][7][2] + sp[28] * PI2[0][7][2] + sp[31] * PI3[0][7][2] + sp[34] * PI1[0][2][7] + sp[35] * PI4[0][7][2] + sp[29] * PI5[0][7][2] + sp[32] * PI6[0][7][2] + sp[28] * PI2[0][2][7] + sp[29] * PI5[0][2][7] + sp[26] * PI7[0][7][2] + sp[27] * PI8[0][7][2] + sp[31] * PI3[0][2][7] + sp[32] * PI6[0][2][7] + sp[27] * PI8[0][2][7] + sp[30] * PI9[0][7][2];
    A[108] = sp[33] * PI0[0][7][3] + sp[34] * PI1[0][7][3] + sp[28] * PI2[0][7][3] + sp[31] * PI3[0][7][3] + sp[34] * PI1[0][3][7] + sp[35] * PI4[0][7][3] + sp[29] * PI5[0][7][3] + sp[32] * PI6[0][7][3] + sp[28] * PI2[0][3][7] + sp[29] * PI5[0][3][7] + sp[26] * PI7[0][7][3] + sp[27] * PI8[0][7][3] + sp[31] * PI3[0][3][7] + sp[32] * PI6[0][3][7] + sp[27] * PI8[0][3][7] + sp[30] * PI9[0][7][3];
    A[109] = sp[33] * PI0[0][7][4] + sp[34] * PI1[0][7][4] + sp[28] * PI2[0][7][4] + sp[31] * PI3[0][7][4] + sp[34] * PI1[0][4][7] + sp[35] * PI4[0][7][4] + sp[29] * PI5[0][7][4] + sp[32] * PI6[0][7][4] + sp[28] * PI2[0][4][7] + sp[29] * PI5[0][4][7] + sp[26] * PI7[0][7][4] + sp[27] * PI8[0][7][4] + sp[31] * PI3[0][4][7] + sp[32] * PI6[0][4][7] + sp[27] * PI8[0][4][7] + sp[30] * PI9[0][7][4];
    A[110] = sp[33] * PI0[0][7][5] + sp[34] * PI1[0][7][5] + sp[28] * PI2[0][7][5] + sp[31] * PI3[0][7][5] + sp[34] * PI1[0][5][7] + sp[35] * PI4[0][7][5] + sp[29] * PI5[0][7][5] + sp[32] * PI6[0][7][5] + sp[28] * PI2[0][5][7] + sp[29] * PI5[0][5][7] + sp[26] * PI7[0][7][5] + sp[27] * PI8[0][7][5] + sp[31] * PI3[0][5][7] + sp[32] * PI6[0][5][7] + sp[27] * PI8[0][5][7] + sp[30] * PI9[0][7][5];
    A[111] = sp[33] * PI0[0][7][6] + sp[34] * PI1[0][7][6] + sp[28] * PI2[0][7][6] + sp[31] * PI3[0][7][6] + sp[34] * PI1[0][6][7] + sp[35] * PI4[0][7][6] + sp[29] * PI5[0][7][6] + sp[32] * PI6[0][7][6] + sp[28] * PI2[0][6][7] + sp[29] * PI5[0][6][7] + sp[26] * PI7[0][7][6] + sp[27] * PI8[0][7][6] + sp[31] * PI3[0][6][7] + sp[32] * PI6[0][6][7] + sp[27] * PI8[0][6][7] + sp[30] * PI9[0][7][6];
    A[112] = sp[33] * PI0[0][7][7] + sp[34] * PI1[0][7][7] + sp[28] * PI2[0][7][7] + sp[31] * PI3[0][7][7] + sp[34] * PI1[0][7][7] + sp[35] * PI4[0][7][7] + sp[29] * PI5[0][7][7] + sp[32] * PI6[0][7][7] + sp[28] * PI2[0][7][7] + sp[29] * PI5[0][7][7] + sp[26] * PI7[0][7][7] + sp[27] * PI8[0][7][7] + sp[31] * PI3[0][7][7] + sp[32] * PI6[0][7][7] + sp[27] * PI8[0][7][7] + sp[30] * PI9[0][7][7];
    A[113] = sp[33] * PI0[0][7][8] + sp[34] * PI1[0][7][8] + sp[28] * PI2[0][7][8] + sp[31] * PI3[0][7][8] + sp[34] * PI1[0][8][7] + sp[35] * PI4[0][7][8] + sp[29] * PI5[0][7][8] + sp[32] * PI6[0][7][8] + sp[28] * PI2[0][8][7] + sp[29] * PI5[0][8][7] + sp[26] * PI7[0][7][8] + sp[27] * PI8[0][7][8] + sp[31] * PI3[0][8][7] + sp[32] * PI6[0][8][7] + sp[27] * PI8[0][8][7] + sp[30] * PI9[0][7][8];
    A[114] = sp[33] * PI0[0][7][9] + sp[34] * PI1[0][7][9] + sp[28] * PI2[0][7][9] + sp[31] * PI3[0][7][9] + sp[34] * PI1[0][9][7] + sp[35] * PI4[0][7][9] + sp[29] * PI5[0][7][9] + sp[32] * PI6[0][7][9] + sp[28] * PI2[0][9][7] + sp[29] * PI5[0][9][7] + sp[26] * PI7[0][7][9] + sp[27] * PI8[0][7][9] + sp[31] * PI3[0][9][7] + sp[32] * PI6[0][9][7] + sp[27] * PI8[0][9][7] + sp[30] * PI9[0][7][9];
    A[115] = sp[33] * PI0[0][7][10] + sp[34] * PI1[0][7][10] + sp[28] * PI2[0][7][10] + sp[31] * PI3[0][7][10] + sp[34] * PI1[0][10][7] + sp[35] * PI4[0][7][10] + sp[29] * PI5[0][7][10] + sp[32] * PI6[0][7][10] + sp[28] * PI2[0][10][7] + sp[29] * PI5[0][10][7] + sp[26] * PI7[0][7][10] + sp[27] * PI8[0][7][10] + sp[31] * PI3[0][10][7] + sp[32] * PI6[0][10][7] + sp[27] * PI8[0][10][7] + sp[30] * PI9[0][7][10];
    A[116] = sp[33] * PI0[0][7][11] + sp[34] * PI1[0][7][11] + sp[28] * PI2[0][7][11] + sp[31] * PI3[0][7][11] + sp[34] * PI1[0][11][7] + sp[35] * PI4[0][7][11] + sp[29] * PI5[0][7][11] + sp[32] * PI6[0][7][11] + sp[28] * PI2[0][11][7] + sp[29] * PI5[0][11][7] + sp[26] * PI7[0][7][11] + sp[27] * PI8[0][7][11] + sp[31] * PI3[0][11][7] + sp[32] * PI6[0][11][7] + sp[27] * PI8[0][11][7] + sp[30] * PI9[0][7][11];
    A[117] = sp[33] * PI0[0][7][12] + sp[34] * PI1[0][7][12] + sp[28] * PI2[0][7][12] + sp[31] * PI3[0][7][12] + sp[34] * PI1[0][12][7] + sp[35] * PI4[0][7][12] + sp[29] * PI5[0][7][12] + sp[32] * PI6[0][7][12] + sp[28] * PI2[0][12][7] + sp[29] * PI5[0][12][7] + sp[26] * PI7[0][7][12] + sp[27] * PI8[0][7][12] + sp[31] * PI3[0][12][7] + sp[32] * PI6[0][12][7] + sp[27] * PI8[0][12][7] + sp[30] * PI9[0][7][12];
    A[118] = sp[33] * PI0[0][7][13] + sp[34] * PI1[0][7][13] + sp[28] * PI2[0][7][13] + sp[31] * PI3[0][7][13] + sp[34] * PI1[0][13][7] + sp[35] * PI4[0][7][13] + sp[29] * PI5[0][7][13] + sp[32] * PI6[0][7][13] + sp[28] * PI2[0][13][7] + sp[29] * PI5[0][13][7] + sp[26] * PI7[0][7][13] + sp[27] * PI8[0][7][13] + sp[31] * PI3[0][13][7] + sp[32] * PI6[0][13][7] + sp[27] * PI8[0][13][7] + sp[30] * PI9[0][7][13];
    A[119] = sp[33] * PI0[0][7][14] + sp[34] * PI1[0][7][14] + sp[28] * PI2[0][7][14] + sp[31] * PI3[0][7][14] + sp[34] * PI1[0][14][7] + sp[35] * PI4[0][7][14] + sp[29] * PI5[0][7][14] + sp[32] * PI6[0][7][14] + sp[28] * PI2[0][14][7] + sp[29] * PI5[0][14][7] + sp[26] * PI7[0][7][14] + sp[27] * PI8[0][7][14] + sp[31] * PI3[0][14][7] + sp[32] * PI6[0][14][7] + sp[27] * PI8[0][14][7] + sp[30] * PI9[0][7][14];
    A[120] = sp[33] * PI0[0][8][0] + sp[34] * PI1[0][8][0] + sp[28] * PI2[0][8][0] + sp[31] * PI3[0][8][0] + sp[34] * PI1[0][0][8] + sp[35] * PI4[0][8][0] + sp[29] * PI5[0][8][0] + sp[32] * PI6[0][8][0] + sp[28] * PI2[0][0][8] + sp[29] * PI5[0][0][8] + sp[26] * PI7[0][8][0] + sp[27] * PI8[0][8][0] + sp[31] * PI3[0][0][8] + sp[32] * PI6[0][0][8] + sp[27] * PI8[0][0][8] + sp[30] * PI9[0][8][0];
    A[121] = sp[33] * PI0[0][8][1] + sp[34] * PI1[0][8][1] + sp[28] * PI2[0][8][1] + sp[31] * PI3[0][8][1] + sp[34] * PI1[0][1][8] + sp[35] * PI4[0][8][1] + sp[29] * PI5[0][8][1] + sp[32] * PI6[0][8][1] + sp[28] * PI2[0][1][8] + sp[29] * PI5[0][1][8] + sp[26] * PI7[0][8][1] + sp[27] * PI8[0][8][1] + sp[31] * PI3[0][1][8] + sp[32] * PI6[0][1][8] + sp[27] * PI8[0][1][8] + sp[30] * PI9[0][8][1];
    A[122] = sp[33] * PI0[0][8][2] + sp[34] * PI1[0][8][2] + sp[28] * PI2[0][8][2] + sp[31] * PI3[0][8][2] + sp[34] * PI1[0][2][8] + sp[35] * PI4[0][8][2] + sp[29] * PI5[0][8][2] + sp[32] * PI6[0][8][2] + sp[28] * PI2[0][2][8] + sp[29] * PI5[0][2][8] + sp[26] * PI7[0][8][2] + sp[27] * PI8[0][8][2] + sp[31] * PI3[0][2][8] + sp[32] * PI6[0][2][8] + sp[27] * PI8[0][2][8] + sp[30] * PI9[0][8][2];
    A[123] = sp[33] * PI0[0][8][3] + sp[34] * PI1[0][8][3] + sp[28] * PI2[0][8][3] + sp[31] * PI3[0][8][3] + sp[34] * PI1[0][3][8] + sp[35] * PI4[0][8][3] + sp[29] * PI5[0][8][3] + sp[32] * PI6[0][8][3] + sp[28] * PI2[0][3][8] + sp[29] * PI5[0][3][8] + sp[26] * PI7[0][8][3] + sp[27] * PI8[0][8][3] + sp[31] * PI3[0][3][8] + sp[32] * PI6[0][3][8] + sp[27] * PI8[0][3][8] + sp[30] * PI9[0][8][3];
    A[124] = sp[33] * PI0[0][8][4] + sp[34] * PI1[0][8][4] + sp[28] * PI2[0][8][4] + sp[31] * PI3[0][8][4] + sp[34] * PI1[0][4][8] + sp[35] * PI4[0][8][4] + sp[29] * PI5[0][8][4] + sp[32] * PI6[0][8][4] + sp[28] * PI2[0][4][8] + sp[29] * PI5[0][4][8] + sp[26] * PI7[0][8][4] + sp[27] * PI8[0][8][4] + sp[31] * PI3[0][4][8] + sp[32] * PI6[0][4][8] + sp[27] * PI8[0][4][8] + sp[30] * PI9[0][8][4];
    A[125] = sp[33] * PI0[0][8][5] + sp[34] * PI1[0][8][5] + sp[28] * PI2[0][8][5] + sp[31] * PI3[0][8][5] + sp[34] * PI1[0][5][8] + sp[35] * PI4[0][8][5] + sp[29] * PI5[0][8][5] + sp[32] * PI6[0][8][5] + sp[28] * PI2[0][5][8] + sp[29] * PI5[0][5][8] + sp[26] * PI7[0][8][5] + sp[27] * PI8[0][8][5] + sp[31] * PI3[0][5][8] + sp[32] * PI6[0][5][8] + sp[27] * PI8[0][5][8] + sp[30] * PI9[0][8][5];
    A[126] = sp[33] * PI0[0][8][6] + sp[34] * PI1[0][8][6] + sp[28] * PI2[0][8][6] + sp[31] * PI3[0][8][6] + sp[34] * PI1[0][6][8] + sp[35] * PI4[0][8][6] + sp[29] * PI5[0][8][6] + sp[32] * PI6[0][8][6] + sp[28] * PI2[0][6][8] + sp[29] * PI5[0][6][8] + sp[26] * PI7[0][8][6] + sp[27] * PI8[0][8][6] + sp[31] * PI3[0][6][8] + sp[32] * PI6[0][6][8] + sp[27] * PI8[0][6][8] + sp[30] * PI9[0][8][6];
    A[127] = sp[33] * PI0[0][8][7] + sp[34] * PI1[0][8][7] + sp[28] * PI2[0][8][7] + sp[31] * PI3[0][8][7] + sp[34] * PI1[0][7][8] + sp[35] * PI4[0][8][7] + sp[29] * PI5[0][8][7] + sp[32] * PI6[0][8][7] + sp[28] * PI2[0][7][8] + sp[29] * PI5[0][7][8] + sp[26] * PI7[0][8][7] + sp[27] * PI8[0][8][7] + sp[31] * PI3[0][7][8] + sp[32] * PI6[0][7][8] + sp[27] * PI8[0][7][8] + sp[30] * PI9[0][8][7];
    A[128] = sp[33] * PI0[0][8][8] + sp[34] * PI1[0][8][8] + sp[28] * PI2[0][8][8] + sp[31] * PI3[0][8][8] + sp[34] * PI1[0][8][8] + sp[35] * PI4[0][8][8] + sp[29] * PI5[0][8][8] + sp[32] * PI6[0][8][8] + sp[28] * PI2[0][8][8] + sp[29] * PI5[0][8][8] + sp[26] * PI7[0][8][8] + sp[27] * PI8[0][8][8] + sp[31] * PI3[0][8][8] + sp[32] * PI6[0][8][8] + sp[27] * PI8[0][8][8] + sp[30] * PI9[0][8][8];
    A[129] = sp[33] * PI0[0][8][9] + sp[34] * PI1[0][8][9] + sp[28] * PI2[0][8][9] + sp[31] * PI3[0][8][9] + sp[34] * PI1[0][9][8] + sp[35] * PI4[0][8][9] + sp[29] * PI5[0][8][9] + sp[32] * PI6[0][8][9] + sp[28] * PI2[0][9][8] + sp[29] * PI5[0][9][8] + sp[26] * PI7[0][8][9] + sp[27] * PI8[0][8][9] + sp[31] * PI3[0][9][8] + sp[32] * PI6[0][9][8] + sp[27] * PI8[0][9][8] + sp[30] * PI9[0][8][9];
    A[130] = sp[33] * PI0[0][8][10] + sp[34] * PI1[0][8][10] + sp[28] * PI2[0][8][10] + sp[31] * PI3[0][8][10] + sp[34] * PI1[0][10][8] + sp[35] * PI4[0][8][10] + sp[29] * PI5[0][8][10] + sp[32] * PI6[0][8][10] + sp[28] * PI2[0][10][8] + sp[29] * PI5[0][10][8] + sp[26] * PI7[0][8][10] + sp[27] * PI8[0][8][10] + sp[31] * PI3[0][10][8] + sp[32] * PI6[0][10][8] + sp[27] * PI8[0][10][8] + sp[30] * PI9[0][8][10];
    A[131] = sp[33] * PI0[0][8][11] + sp[34] * PI1[0][8][11] + sp[28] * PI2[0][8][11] + sp[31] * PI3[0][8][11] + sp[34] * PI1[0][11][8] + sp[35] * PI4[0][8][11] + sp[29] * PI5[0][8][11] + sp[32] * PI6[0][8][11] + sp[28] * PI2[0][11][8] + sp[29] * PI5[0][11][8] + sp[26] * PI7[0][8][11] + sp[27] * PI8[0][8][11] + sp[31] * PI3[0][11][8] + sp[32] * PI6[0][11][8] + sp[27] * PI8[0][11][8] + sp[30] * PI9[0][8][11];
    A[132] = sp[33] * PI0[0][8][12] + sp[34] * PI1[0][8][12] + sp[28] * PI2[0][8][12] + sp[31] * PI3[0][8][12] + sp[34] * PI1[0][12][8] + sp[35] * PI4[0][8][12] + sp[29] * PI5[0][8][12] + sp[32] * PI6[0][8][12] + sp[28] * PI2[0][12][8] + sp[29] * PI5[0][12][8] + sp[26] * PI7[0][8][12] + sp[27] * PI8[0][8][12] + sp[31] * PI3[0][12][8] + sp[32] * PI6[0][12][8] + sp[27] * PI8[0][12][8] + sp[30] * PI9[0][8][12];
    A[133] = sp[33] * PI0[0][8][13] + sp[34] * PI1[0][8][13] + sp[28] * PI2[0][8][13] + sp[31] * PI3[0][8][13] + sp[34] * PI1[0][13][8] + sp[35] * PI4[0][8][13] + sp[29] * PI5[0][8][13] + sp[32] * PI6[0][8][13] + sp[28] * PI2[0][13][8] + sp[29] * PI5[0][13][8] + sp[26] * PI7[0][8][13] + sp[27] * PI8[0][8][13] + sp[31] * PI3[0][13][8] + sp[32] * PI6[0][13][8] + sp[27] * PI8[0][13][8] + sp[30] * PI9[0][8][13];
    A[134] = sp[33] * PI0[0][8][14] + sp[34] * PI1[0][8][14] + sp[28] * PI2[0][8][14] + sp[31] * PI3[0][8][14] + sp[34] * PI1[0][14][8] + sp[35] * PI4[0][8][14] + sp[29] * PI5[0][8][14] + sp[32] * PI6[0][8][14] + sp[28] * PI2[0][14][8] + sp[29] * PI5[0][14][8] + sp[26] * PI7[0][8][14] + sp[27] * PI8[0][8][14] + sp[31] * PI3[0][14][8] + sp[32] * PI6[0][14][8] + sp[27] * PI8[0][14][8] + sp[30] * PI9[0][8][14];
    A[135] = sp[33] * PI0[0][9][0] + sp[34] * PI1[0][9][0] + sp[28] * PI2[0][9][0] + sp[31] * PI3[0][9][0] + sp[34] * PI1[0][0][9] + sp[35] * PI4[0][9][0] + sp[29] * PI5[0][9][0] + sp[32] * PI6[0][9][0] + sp[28] * PI2[0][0][9] + sp[29] * PI5[0][0][9] + sp[26] * PI7[0][9][0] + sp[27] * PI8[0][9][0] + sp[31] * PI3[0][0][9] + sp[32] * PI6[0][0][9] + sp[27] * PI8[0][0][9] + sp[30] * PI9[0][9][0];
    A[136] = sp[33] * PI0[0][9][1] + sp[34] * PI1[0][9][1] + sp[28] * PI2[0][9][1] + sp[31] * PI3[0][9][1] + sp[34] * PI1[0][1][9] + sp[35] * PI4[0][9][1] + sp[29] * PI5[0][9][1] + sp[32] * PI6[0][9][1] + sp[28] * PI2[0][1][9] + sp[29] * PI5[0][1][9] + sp[26] * PI7[0][9][1] + sp[27] * PI8[0][9][1] + sp[31] * PI3[0][1][9] + sp[32] * PI6[0][1][9] + sp[27] * PI8[0][1][9] + sp[30] * PI9[0][9][1];
    A[137] = sp[33] * PI0[0][9][2] + sp[34] * PI1[0][9][2] + sp[28] * PI2[0][9][2] + sp[31] * PI3[0][9][2] + sp[34] * PI1[0][2][9] + sp[35] * PI4[0][9][2] + sp[29] * PI5[0][9][2] + sp[32] * PI6[0][9][2] + sp[28] * PI2[0][2][9] + sp[29] * PI5[0][2][9] + sp[26] * PI7[0][9][2] + sp[27] * PI8[0][9][2] + sp[31] * PI3[0][2][9] + sp[32] * PI6[0][2][9] + sp[27] * PI8[0][2][9] + sp[30] * PI9[0][9][2];
    A[138] = sp[33] * PI0[0][9][3] + sp[34] * PI1[0][9][3] + sp[28] * PI2[0][9][3] + sp[31] * PI3[0][9][3] + sp[34] * PI1[0][3][9] + sp[35] * PI4[0][9][3] + sp[29] * PI5[0][9][3] + sp[32] * PI6[0][9][3] + sp[28] * PI2[0][3][9] + sp[29] * PI5[0][3][9] + sp[26] * PI7[0][9][3] + sp[27] * PI8[0][9][3] + sp[31] * PI3[0][3][9] + sp[32] * PI6[0][3][9] + sp[27] * PI8[0][3][9] + sp[30] * PI9[0][9][3];
    A[139] = sp[33] * PI0[0][9][4] + sp[34] * PI1[0][9][4] + sp[28] * PI2[0][9][4] + sp[31] * PI3[0][9][4] + sp[34] * PI1[0][4][9] + sp[35] * PI4[0][9][4] + sp[29] * PI5[0][9][4] + sp[32] * PI6[0][9][4] + sp[28] * PI2[0][4][9] + sp[29] * PI5[0][4][9] + sp[26] * PI7[0][9][4] + sp[27] * PI8[0][9][4] + sp[31] * PI3[0][4][9] + sp[32] * PI6[0][4][9] + sp[27] * PI8[0][4][9] + sp[30] * PI9[0][9][4];
    A[140] = sp[33] * PI0[0][9][5] + sp[34] * PI1[0][9][5] + sp[28] * PI2[0][9][5] + sp[31] * PI3[0][9][5] + sp[34] * PI1[0][5][9] + sp[35] * PI4[0][9][5] + sp[29] * PI5[0][9][5] + sp[32] * PI6[0][9][5] + sp[28] * PI2[0][5][9] + sp[29] * PI5[0][5][9] + sp[26] * PI7[0][9][5] + sp[27] * PI8[0][9][5] + sp[31] * PI3[0][5][9] + sp[32] * PI6[0][5][9] + sp[27] * PI8[0][5][9] + sp[30] * PI9[0][9][5];
    A[141] = sp[33] * PI0[0][9][6] + sp[34] * PI1[0][9][6] + sp[28] * PI2[0][9][6] + sp[31] * PI3[0][9][6] + sp[34] * PI1[0][6][9] + sp[35] * PI4[0][9][6] + sp[29] * PI5[0][9][6] + sp[32] * PI6[0][9][6] + sp[28] * PI2[0][6][9] + sp[29] * PI5[0][6][9] + sp[26] * PI7[0][9][6] + sp[27] * PI8[0][9][6] + sp[31] * PI3[0][6][9] + sp[32] * PI6[0][6][9] + sp[27] * PI8[0][6][9] + sp[30] * PI9[0][9][6];
    A[142] = sp[33] * PI0[0][9][7] + sp[34] * PI1[0][9][7] + sp[28] * PI2[0][9][7] + sp[31] * PI3[0][9][7] + sp[34] * PI1[0][7][9] + sp[35] * PI4[0][9][7] + sp[29] * PI5[0][9][7] + sp[32] * PI6[0][9][7] + sp[28] * PI2[0][7][9] + sp[29] * PI5[0][7][9] + sp[26] * PI7[0][9][7] + sp[27] * PI8[0][9][7] + sp[31] * PI3[0][7][9] + sp[32] * PI6[0][7][9] + sp[27] * PI8[0][7][9] + sp[30] * PI9[0][9][7];
    A[143] = sp[33] * PI0[0][9][8] + sp[34] * PI1[0][9][8] + sp[28] * PI2[0][9][8] + sp[31] * PI3[0][9][8] + sp[34] * PI1[0][8][9] + sp[35] * PI4[0][9][8] + sp[29] * PI5[0][9][8] + sp[32] * PI6[0][9][8] + sp[28] * PI2[0][8][9] + sp[29] * PI5[0][8][9] + sp[26] * PI7[0][9][8] + sp[27] * PI8[0][9][8] + sp[31] * PI3[0][8][9] + sp[32] * PI6[0][8][9] + sp[27] * PI8[0][8][9] + sp[30] * PI9[0][9][8];
    A[144] = sp[33] * PI0[0][9][9] + sp[34] * PI1[0][9][9] + sp[28] * PI2[0][9][9] + sp[31] * PI3[0][9][9] + sp[34] * PI1[0][9][9] + sp[35] * PI4[0][9][9] + sp[29] * PI5[0][9][9] + sp[32] * PI6[0][9][9] + sp[28] * PI2[0][9][9] + sp[29] * PI5[0][9][9] + sp[26] * PI7[0][9][9] + sp[27] * PI8[0][9][9] + sp[31] * PI3[0][9][9] + sp[32] * PI6[0][9][9] + sp[27] * PI8[0][9][9] + sp[30] * PI9[0][9][9];
    A[145] = sp[33] * PI0[0][9][10] + sp[34] * PI1[0][9][10] + sp[28] * PI2[0][9][10] + sp[31] * PI3[0][9][10] + sp[34] * PI1[0][10][9] + sp[35] * PI4[0][9][10] + sp[29] * PI5[0][9][10] + sp[32] * PI6[0][9][10] + sp[28] * PI2[0][10][9] + sp[29] * PI5[0][10][9] + sp[26] * PI7[0][9][10] + sp[27] * PI8[0][9][10] + sp[31] * PI3[0][10][9] + sp[32] * PI6[0][10][9] + sp[27] * PI8[0][10][9] + sp[30] * PI9[0][9][10];
    A[146] = sp[33] * PI0[0][9][11] + sp[34] * PI1[0][9][11] + sp[28] * PI2[0][9][11] + sp[31] * PI3[0][9][11] + sp[34] * PI1[0][11][9] + sp[35] * PI4[0][9][11] + sp[29] * PI5[0][9][11] + sp[32] * PI6[0][9][11] + sp[28] * PI2[0][11][9] + sp[29] * PI5[0][11][9] + sp[26] * PI7[0][9][11] + sp[27] * PI8[0][9][11] + sp[31] * PI3[0][11][9] + sp[32] * PI6[0][11][9] + sp[27] * PI8[0][11][9] + sp[30] * PI9[0][9][11];
    A[147] = sp[33] * PI0[0][9][12] + sp[34] * PI1[0][9][12] + sp[28] * PI2[0][9][12] + sp[31] * PI3[0][9][12] + sp[34] * PI1[0][12][9] + sp[35] * PI4[0][9][12] + sp[29] * PI5[0][9][12] + sp[32] * PI6[0][9][12] + sp[28] * PI2[0][12][9] + sp[29] * PI5[0][12][9] + sp[26] * PI7[0][9][12] + sp[27] * PI8[0][9][12] + sp[31] * PI3[0][12][9] + sp[32] * PI6[0][12][9] + sp[27] * PI8[0][12][9] + sp[30] * PI9[0][9][12];
    A[148] = sp[33] * PI0[0][9][13] + sp[34] * PI1[0][9][13] + sp[28] * PI2[0][9][13] + sp[31] * PI3[0][9][13] + sp[34] * PI1[0][13][9] + sp[35] * PI4[0][9][13] + sp[29] * PI5[0][9][13] + sp[32] * PI6[0][9][13] + sp[28] * PI2[0][13][9] + sp[29] * PI5[0][13][9] + sp[26] * PI7[0][9][13] + sp[27] * PI8[0][9][13] + sp[31] * PI3[0][13][9] + sp[32] * PI6[0][13][9] + sp[27] * PI8[0][13][9] + sp[30] * PI9[0][9][13];
    A[149] = sp[33] * PI0[0][9][14] + sp[34] * PI1[0][9][14] + sp[28] * PI2[0][9][14] + sp[31] * PI3[0][9][14] + sp[34] * PI1[0][14][9] + sp[35] * PI4[0][9][14] + sp[29] * PI5[0][9][14] + sp[32] * PI6[0][9][14] + sp[28] * PI2[0][14][9] + sp[29] * PI5[0][14][9] + sp[26] * PI7[0][9][14] + sp[27] * PI8[0][9][14] + sp[31] * PI3[0][14][9] + sp[32] * PI6[0][14][9] + sp[27] * PI8[0][14][9] + sp[30] * PI9[0][9][14];
    A[150] = sp[33] * PI0[0][10][0] + sp[34] * PI1[0][10][0] + sp[28] * PI2[0][10][0] + sp[31] * PI3[0][10][0] + sp[34] * PI1[0][0][10] + sp[35] * PI4[0][10][0] + sp[29] * PI5[0][10][0] + sp[32] * PI6[0][10][0] + sp[28] * PI2[0][0][10] + sp[29] * PI5[0][0][10] + sp[26] * PI7[0][10][0] + sp[27] * PI8[0][10][0] + sp[31] * PI3[0][0][10] + sp[32] * PI6[0][0][10] + sp[27] * PI8[0][0][10] + sp[30] * PI9[0][10][0];
    A[151] = sp[33] * PI0[0][10][1] + sp[34] * PI1[0][10][1] + sp[28] * PI2[0][10][1] + sp[31] * PI3[0][10][1] + sp[34] * PI1[0][1][10] + sp[35] * PI4[0][10][1] + sp[29] * PI5[0][10][1] + sp[32] * PI6[0][10][1] + sp[28] * PI2[0][1][10] + sp[29] * PI5[0][1][10] + sp[26] * PI7[0][10][1] + sp[27] * PI8[0][10][1] + sp[31] * PI3[0][1][10] + sp[32] * PI6[0][1][10] + sp[27] * PI8[0][1][10] + sp[30] * PI9[0][10][1];
    A[152] = sp[33] * PI0[0][10][2] + sp[34] * PI1[0][10][2] + sp[28] * PI2[0][10][2] + sp[31] * PI3[0][10][2] + sp[34] * PI1[0][2][10] + sp[35] * PI4[0][10][2] + sp[29] * PI5[0][10][2] + sp[32] * PI6[0][10][2] + sp[28] * PI2[0][2][10] + sp[29] * PI5[0][2][10] + sp[26] * PI7[0][10][2] + sp[27] * PI8[0][10][2] + sp[31] * PI3[0][2][10] + sp[32] * PI6[0][2][10] + sp[27] * PI8[0][2][10] + sp[30] * PI9[0][10][2];
    A[153] = sp[33] * PI0[0][10][3] + sp[34] * PI1[0][10][3] + sp[28] * PI2[0][10][3] + sp[31] * PI3[0][10][3] + sp[34] * PI1[0][3][10] + sp[35] * PI4[0][10][3] + sp[29] * PI5[0][10][3] + sp[32] * PI6[0][10][3] + sp[28] * PI2[0][3][10] + sp[29] * PI5[0][3][10] + sp[26] * PI7[0][10][3] + sp[27] * PI8[0][10][3] + sp[31] * PI3[0][3][10] + sp[32] * PI6[0][3][10] + sp[27] * PI8[0][3][10] + sp[30] * PI9[0][10][3];
    A[154] = sp[33] * PI0[0][10][4] + sp[34] * PI1[0][10][4] + sp[28] * PI2[0][10][4] + sp[31] * PI3[0][10][4] + sp[34] * PI1[0][4][10] + sp[35] * PI4[0][10][4] + sp[29] * PI5[0][10][4] + sp[32] * PI6[0][10][4] + sp[28] * PI2[0][4][10] + sp[29] * PI5[0][4][10] + sp[26] * PI7[0][10][4] + sp[27] * PI8[0][10][4] + sp[31] * PI3[0][4][10] + sp[32] * PI6[0][4][10] + sp[27] * PI8[0][4][10] + sp[30] * PI9[0][10][4];
    A[155] = sp[33] * PI0[0][10][5] + sp[34] * PI1[0][10][5] + sp[28] * PI2[0][10][5] + sp[31] * PI3[0][10][5] + sp[34] * PI1[0][5][10] + sp[35] * PI4[0][10][5] + sp[29] * PI5[0][10][5] + sp[32] * PI6[0][10][5] + sp[28] * PI2[0][5][10] + sp[29] * PI5[0][5][10] + sp[26] * PI7[0][10][5] + sp[27] * PI8[0][10][5] + sp[31] * PI3[0][5][10] + sp[32] * PI6[0][5][10] + sp[27] * PI8[0][5][10] + sp[30] * PI9[0][10][5];
    A[156] = sp[33] * PI0[0][10][6] + sp[34] * PI1[0][10][6] + sp[28] * PI2[0][10][6] + sp[31] * PI3[0][10][6] + sp[34] * PI1[0][6][10] + sp[35] * PI4[0][10][6] + sp[29] * PI5[0][10][6] + sp[32] * PI6[0][10][6] + sp[28] * PI2[0][6][10] + sp[29] * PI5[0][6][10] + sp[26] * PI7[0][10][6] + sp[27] * PI8[0][10][6] + sp[31] * PI3[0][6][10] + sp[32] * PI6[0][6][10] + sp[27] * PI8[0][6][10] + sp[30] * PI9[0][10][6];
    A[157] = sp[33] * PI0[0][10][7] + sp[34] * PI1[0][10][7] + sp[28] * PI2[0][10][7] + sp[31] * PI3[0][10][7] + sp[34] * PI1[0][7][10] + sp[35] * PI4[0][10][7] + sp[29] * PI5[0][10][7] + sp[32] * PI6[0][10][7] + sp[28] * PI2[0][7][10] + sp[29] * PI5[0][7][10] + sp[26] * PI7[0][10][7] + sp[27] * PI8[0][10][7] + sp[31] * PI3[0][7][10] + sp[32] * PI6[0][7][10] + sp[27] * PI8[0][7][10] + sp[30] * PI9[0][10][7];
    A[158] = sp[33] * PI0[0][10][8] + sp[34] * PI1[0][10][8] + sp[28] * PI2[0][10][8] + sp[31] * PI3[0][10][8] + sp[34] * PI1[0][8][10] + sp[35] * PI4[0][10][8] + sp[29] * PI5[0][10][8] + sp[32] * PI6[0][10][8] + sp[28] * PI2[0][8][10] + sp[29] * PI5[0][8][10] + sp[26] * PI7[0][10][8] + sp[27] * PI8[0][10][8] + sp[31] * PI3[0][8][10] + sp[32] * PI6[0][8][10] + sp[27] * PI8[0][8][10] + sp[30] * PI9[0][10][8];
    A[159] = sp[33] * PI0[0][10][9] + sp[34] * PI1[0][10][9] + sp[28] * PI2[0][10][9] + sp[31] * PI3[0][10][9] + sp[34] * PI1[0][9][10] + sp[35] * PI4[0][10][9] + sp[29] * PI5[0][10][9] + sp[32] * PI6[0][10][9] + sp[28] * PI2[0][9][10] + sp[29] * PI5[0][9][10] + sp[26] * PI7[0][10][9] + sp[27] * PI8[0][10][9] + sp[31] * PI3[0][9][10] + sp[32] * PI6[0][9][10] + sp[27] * PI8[0][9][10] + sp[30] * PI9[0][10][9];
    A[160] = sp[33] * PI0[0][10][10] + sp[34] * PI1[0][10][10] + sp[28] * PI2[0][10][10] + sp[31] * PI3[0][10][10] + sp[34] * PI1[0][10][10] + sp[35] * PI4[0][10][10] + sp[29] * PI5[0][10][10] + sp[32] * PI6[0][10][10] + sp[28] * PI2[0][10][10] + sp[29] * PI5[0][10][10] + sp[26] * PI7[0][10][10] + sp[27] * PI8[0][10][10] + sp[31] * PI3[0][10][10] + sp[32] * PI6[0][10][10] + sp[27] * PI8[0][10][10] + sp[30] * PI9[0][10][10];
    A[161] = sp[33] * PI0[0][10][11] + sp[34] * PI1[0][10][11] + sp[28] * PI2[0][10][11] + sp[31] * PI3[0][10][11] + sp[34] * PI1[0][11][10] + sp[35] * PI4[0][10][11] + sp[29] * PI5[0][10][11] + sp[32] * PI6[0][10][11] + sp[28] * PI2[0][11][10] + sp[29] * PI5[0][11][10] + sp[26] * PI7[0][10][11] + sp[27] * PI8[0][10][11] + sp[31] * PI3[0][11][10] + sp[32] * PI6[0][11][10] + sp[27] * PI8[0][11][10] + sp[30] * PI9[0][10][11];
    A[162] = sp[33] * PI0[0][10][12] + sp[34] * PI1[0][10][12] + sp[28] * PI2[0][10][12] + sp[31] * PI3[0][10][12] + sp[34] * PI1[0][12][10] + sp[35] * PI4[0][10][12] + sp[29] * PI5[0][10][12] + sp[32] * PI6[0][10][12] + sp[28] * PI2[0][12][10] + sp[29] * PI5[0][12][10] + sp[26] * PI7[0][10][12] + sp[27] * PI8[0][10][12] + sp[31] * PI3[0][12][10] + sp[32] * PI6[0][12][10] + sp[27] * PI8[0][12][10] + sp[30] * PI9[0][10][12];
    A[163] = sp[33] * PI0[0][10][13] + sp[34] * PI1[0][10][13] + sp[28] * PI2[0][10][13] + sp[31] * PI3[0][10][13] + sp[34] * PI1[0][13][10] + sp[35] * PI4[0][10][13] + sp[29] * PI5[0][10][13] + sp[32] * PI6[0][10][13] + sp[28] * PI2[0][13][10] + sp[29] * PI5[0][13][10] + sp[26] * PI7[0][10][13] + sp[27] * PI8[0][10][13] + sp[31] * PI3[0][13][10] + sp[32] * PI6[0][13][10] + sp[27] * PI8[0][13][10] + sp[30] * PI9[0][10][13];
    A[164] = sp[33] * PI0[0][10][14] + sp[34] * PI1[0][10][14] + sp[28] * PI2[0][10][14] + sp[31] * PI3[0][10][14] + sp[34] * PI1[0][14][10] + sp[35] * PI4[0][10][14] + sp[29] * PI5[0][10][14] + sp[32] * PI6[0][10][14] + sp[28] * PI2[0][14][10] + sp[29] * PI5[0][14][10] + sp[26] * PI7[0][10][14] + sp[27] * PI8[0][10][14] + sp[31] * PI3[0][14][10] + sp[32] * PI6[0][14][10] + sp[27] * PI8[0][14][10] + sp[30] * PI9[0][10][14];
    A[165] = sp[33] * PI0[0][11][0] + sp[34] * PI1[0][11][0] + sp[28] * PI2[0][11][0] + sp[31] * PI3[0][11][0] + sp[34] * PI1[0][0][11] + sp[35] * PI4[0][11][0] + sp[29] * PI5[0][11][0] + sp[32] * PI6[0][11][0] + sp[28] * PI2[0][0][11] + sp[29] * PI5[0][0][11] + sp[26] * PI7[0][11][0] + sp[27] * PI8[0][11][0] + sp[31] * PI3[0][0][11] + sp[32] * PI6[0][0][11] + sp[27] * PI8[0][0][11] + sp[30] * PI9[0][11][0];
    A[166] = sp[33] * PI0[0][11][1] + sp[34] * PI1[0][11][1] + sp[28] * PI2[0][11][1] + sp[31] * PI3[0][11][1] + sp[34] * PI1[0][1][11] + sp[35] * PI4[0][11][1] + sp[29] * PI5[0][11][1] + sp[32] * PI6[0][11][1] + sp[28] * PI2[0][1][11] + sp[29] * PI5[0][1][11] + sp[26] * PI7[0][11][1] + sp[27] * PI8[0][11][1] + sp[31] * PI3[0][1][11] + sp[32] * PI6[0][1][11] + sp[27] * PI8[0][1][11] + sp[30] * PI9[0][11][1];
    A[167] = sp[33] * PI0[0][11][2] + sp[34] * PI1[0][11][2] + sp[28] * PI2[0][11][2] + sp[31] * PI3[0][11][2] + sp[34] * PI1[0][2][11] + sp[35] * PI4[0][11][2] + sp[29] * PI5[0][11][2] + sp[32] * PI6[0][11][2] + sp[28] * PI2[0][2][11] + sp[29] * PI5[0][2][11] + sp[26] * PI7[0][11][2] + sp[27] * PI8[0][11][2] + sp[31] * PI3[0][2][11] + sp[32] * PI6[0][2][11] + sp[27] * PI8[0][2][11] + sp[30] * PI9[0][11][2];
    A[168] = sp[33] * PI0[0][11][3] + sp[34] * PI1[0][11][3] + sp[28] * PI2[0][11][3] + sp[31] * PI3[0][11][3] + sp[34] * PI1[0][3][11] + sp[35] * PI4[0][11][3] + sp[29] * PI5[0][11][3] + sp[32] * PI6[0][11][3] + sp[28] * PI2[0][3][11] + sp[29] * PI5[0][3][11] + sp[26] * PI7[0][11][3] + sp[27] * PI8[0][11][3] + sp[31] * PI3[0][3][11] + sp[32] * PI6[0][3][11] + sp[27] * PI8[0][3][11] + sp[30] * PI9[0][11][3];
    A[169] = sp[33] * PI0[0][11][4] + sp[34] * PI1[0][11][4] + sp[28] * PI2[0][11][4] + sp[31] * PI3[0][11][4] + sp[34] * PI1[0][4][11] + sp[35] * PI4[0][11][4] + sp[29] * PI5[0][11][4] + sp[32] * PI6[0][11][4] + sp[28] * PI2[0][4][11] + sp[29] * PI5[0][4][11] + sp[26] * PI7[0][11][4] + sp[27] * PI8[0][11][4] + sp[31] * PI3[0][4][11] + sp[32] * PI6[0][4][11] + sp[27] * PI8[0][4][11] + sp[30] * PI9[0][11][4];
    A[170] = sp[33] * PI0[0][11][5] + sp[34] * PI1[0][11][5] + sp[28] * PI2[0][11][5] + sp[31] * PI3[0][11][5] + sp[34] * PI1[0][5][11] + sp[35] * PI4[0][11][5] + sp[29] * PI5[0][11][5] + sp[32] * PI6[0][11][5] + sp[28] * PI2[0][5][11] + sp[29] * PI5[0][5][11] + sp[26] * PI7[0][11][5] + sp[27] * PI8[0][11][5] + sp[31] * PI3[0][5][11] + sp[32] * PI6[0][5][11] + sp[27] * PI8[0][5][11] + sp[30] * PI9[0][11][5];
    A[171] = sp[33] * PI0[0][11][6] + sp[34] * PI1[0][11][6] + sp[28] * PI2[0][11][6] + sp[31] * PI3[0][11][6] + sp[34] * PI1[0][6][11] + sp[35] * PI4[0][11][6] + sp[29] * PI5[0][11][6] + sp[32] * PI6[0][11][6] + sp[28] * PI2[0][6][11] + sp[29] * PI5[0][6][11] + sp[26] * PI7[0][11][6] + sp[27] * PI8[0][11][6] + sp[31] * PI3[0][6][11] + sp[32] * PI6[0][6][11] + sp[27] * PI8[0][6][11] + sp[30] * PI9[0][11][6];
    A[172] = sp[33] * PI0[0][11][7] + sp[34] * PI1[0][11][7] + sp[28] * PI2[0][11][7] + sp[31] * PI3[0][11][7] + sp[34] * PI1[0][7][11] + sp[35] * PI4[0][11][7] + sp[29] * PI5[0][11][7] + sp[32] * PI6[0][11][7] + sp[28] * PI2[0][7][11] + sp[29] * PI5[0][7][11] + sp[26] * PI7[0][11][7] + sp[27] * PI8[0][11][7] + sp[31] * PI3[0][7][11] + sp[32] * PI6[0][7][11] + sp[27] * PI8[0][7][11] + sp[30] * PI9[0][11][7];
    A[173] = sp[33] * PI0[0][11][8] + sp[34] * PI1[0][11][8] + sp[28] * PI2[0][11][8] + sp[31] * PI3[0][11][8] + sp[34] * PI1[0][8][11] + sp[35] * PI4[0][11][8] + sp[29] * PI5[0][11][8] + sp[32] * PI6[0][11][8] + sp[28] * PI2[0][8][11] + sp[29] * PI5[0][8][11] + sp[26] * PI7[0][11][8] + sp[27] * PI8[0][11][8] + sp[31] * PI3[0][8][11] + sp[32] * PI6[0][8][11] + sp[27] * PI8[0][8][11] + sp[30] * PI9[0][11][8];
    A[174] = sp[33] * PI0[0][11][9] + sp[34] * PI1[0][11][9] + sp[28] * PI2[0][11][9] + sp[31] * PI3[0][11][9] + sp[34] * PI1[0][9][11] + sp[35] * PI4[0][11][9] + sp[29] * PI5[0][11][9] + sp[32] * PI6[0][11][9] + sp[28] * PI2[0][9][11] + sp[29] * PI5[0][9][11] + sp[26] * PI7[0][11][9] + sp[27] * PI8[0][11][9] + sp[31] * PI3[0][9][11] + sp[32] * PI6[0][9][11] + sp[27] * PI8[0][9][11] + sp[30] * PI9[0][11][9];
    A[175] = sp[33] * PI0[0][11][10] + sp[34] * PI1[0][11][10] + sp[28] * PI2[0][11][10] + sp[31] * PI3[0][11][10] + sp[34] * PI1[0][10][11] + sp[35] * PI4[0][11][10] + sp[29] * PI5[0][11][10] + sp[32] * PI6[0][11][10] + sp[28] * PI2[0][10][11] + sp[29] * PI5[0][10][11] + sp[26] * PI7[0][11][10] + sp[27] * PI8[0][11][10] + sp[31] * PI3[0][10][11] + sp[32] * PI6[0][10][11] + sp[27] * PI8[0][10][11] + sp[30] * PI9[0][11][10];
    A[176] = sp[33] * PI0[0][11][11] + sp[34] * PI1[0][11][11] + sp[28] * PI2[0][11][11] + sp[31] * PI3[0][11][11] + sp[34] * PI1[0][11][11] + sp[35] * PI4[0][11][11] + sp[29] * PI5[0][11][11] + sp[32] * PI6[0][11][11] + sp[28] * PI2[0][11][11] + sp[29] * PI5[0][11][11] + sp[26] * PI7[0][11][11] + sp[27] * PI8[0][11][11] + sp[31] * PI3[0][11][11] + sp[32] * PI6[0][11][11] + sp[27] * PI8[0][11][11] + sp[30] * PI9[0][11][11];
    A[177] = sp[33] * PI0[0][11][12] + sp[34] * PI1[0][11][12] + sp[28] * PI2[0][11][12] + sp[31] * PI3[0][11][12] + sp[34] * PI1[0][12][11] + sp[35] * PI4[0][11][12] + sp[29] * PI5[0][11][12] + sp[32] * PI6[0][11][12] + sp[28] * PI2[0][12][11] + sp[29] * PI5[0][12][11] + sp[26] * PI7[0][11][12] + sp[27] * PI8[0][11][12] + sp[31] * PI3[0][12][11] + sp[32] * PI6[0][12][11] + sp[27] * PI8[0][12][11] + sp[30] * PI9[0][11][12];
    A[178] = sp[33] * PI0[0][11][13] + sp[34] * PI1[0][11][13] + sp[28] * PI2[0][11][13] + sp[31] * PI3[0][11][13] + sp[34] * PI1[0][13][11] + sp[35] * PI4[0][11][13] + sp[29] * PI5[0][11][13] + sp[32] * PI6[0][11][13] + sp[28] * PI2[0][13][11] + sp[29] * PI5[0][13][11] + sp[26] * PI7[0][11][13] + sp[27] * PI8[0][11][13] + sp[31] * PI3[0][13][11] + sp[32] * PI6[0][13][11] + sp[27] * PI8[0][13][11] + sp[30] * PI9[0][11][13];
    A[179] = sp[33] * PI0[0][11][14] + sp[34] * PI1[0][11][14] + sp[28] * PI2[0][11][14] + sp[31] * PI3[0][11][14] + sp[34] * PI1[0][14][11] + sp[35] * PI4[0][11][14] + sp[29] * PI5[0][11][14] + sp[32] * PI6[0][11][14] + sp[28] * PI2[0][14][11] + sp[29] * PI5[0][14][11] + sp[26] * PI7[0][11][14] + sp[27] * PI8[0][11][14] + sp[31] * PI3[0][14][11] + sp[32] * PI6[0][14][11] + sp[27] * PI8[0][14][11] + sp[30] * PI9[0][11][14];
    A[180] = sp[33] * PI0[0][12][0] + sp[34] * PI1[0][12][0] + sp[28] * PI2[0][12][0] + sp[31] * PI3[0][12][0] + sp[34] * PI1[0][0][12] + sp[35] * PI4[0][12][0] + sp[29] * PI5[0][12][0] + sp[32] * PI6[0][12][0] + sp[28] * PI2[0][0][12] + sp[29] * PI5[0][0][12] + sp[26] * PI7[0][12][0] + sp[27] * PI8[0][12][0] + sp[31] * PI3[0][0][12] + sp[32] * PI6[0][0][12] + sp[27] * PI8[0][0][12] + sp[30] * PI9[0][12][0];
    A[181] = sp[33] * PI0[0][12][1] + sp[34] * PI1[0][12][1] + sp[28] * PI2[0][12][1] + sp[31] * PI3[0][12][1] + sp[34] * PI1[0][1][12] + sp[35] * PI4[0][12][1] + sp[29] * PI5[0][12][1] + sp[32] * PI6[0][12][1] + sp[28] * PI2[0][1][12] + sp[29] * PI5[0][1][12] + sp[26] * PI7[0][12][1] + sp[27] * PI8[0][12][1] + sp[31] * PI3[0][1][12] + sp[32] * PI6[0][1][12] + sp[27] * PI8[0][1][12] + sp[30] * PI9[0][12][1];
    A[182] = sp[33] * PI0[0][12][2] + sp[34] * PI1[0][12][2] + sp[28] * PI2[0][12][2] + sp[31] * PI3[0][12][2] + sp[34] * PI1[0][2][12] + sp[35] * PI4[0][12][2] + sp[29] * PI5[0][12][2] + sp[32] * PI6[0][12][2] + sp[28] * PI2[0][2][12] + sp[29] * PI5[0][2][12] + sp[26] * PI7[0][12][2] + sp[27] * PI8[0][12][2] + sp[31] * PI3[0][2][12] + sp[32] * PI6[0][2][12] + sp[27] * PI8[0][2][12] + sp[30] * PI9[0][12][2];
    A[183] = sp[33] * PI0[0][12][3] + sp[34] * PI1[0][12][3] + sp[28] * PI2[0][12][3] + sp[31] * PI3[0][12][3] + sp[34] * PI1[0][3][12] + sp[35] * PI4[0][12][3] + sp[29] * PI5[0][12][3] + sp[32] * PI6[0][12][3] + sp[28] * PI2[0][3][12] + sp[29] * PI5[0][3][12] + sp[26] * PI7[0][12][3] + sp[27] * PI8[0][12][3] + sp[31] * PI3[0][3][12] + sp[32] * PI6[0][3][12] + sp[27] * PI8[0][3][12] + sp[30] * PI9[0][12][3];
    A[184] = sp[33] * PI0[0][12][4] + sp[34] * PI1[0][12][4] + sp[28] * PI2[0][12][4] + sp[31] * PI3[0][12][4] + sp[34] * PI1[0][4][12] + sp[35] * PI4[0][12][4] + sp[29] * PI5[0][12][4] + sp[32] * PI6[0][12][4] + sp[28] * PI2[0][4][12] + sp[29] * PI5[0][4][12] + sp[26] * PI7[0][12][4] + sp[27] * PI8[0][12][4] + sp[31] * PI3[0][4][12] + sp[32] * PI6[0][4][12] + sp[27] * PI8[0][4][12] + sp[30] * PI9[0][12][4];
    A[185] = sp[33] * PI0[0][12][5] + sp[34] * PI1[0][12][5] + sp[28] * PI2[0][12][5] + sp[31] * PI3[0][12][5] + sp[34] * PI1[0][5][12] + sp[35] * PI4[0][12][5] + sp[29] * PI5[0][12][5] + sp[32] * PI6[0][12][5] + sp[28] * PI2[0][5][12] + sp[29] * PI5[0][5][12] + sp[26] * PI7[0][12][5] + sp[27] * PI8[0][12][5] + sp[31] * PI3[0][5][12] + sp[32] * PI6[0][5][12] + sp[27] * PI8[0][5][12] + sp[30] * PI9[0][12][5];
    A[186] = sp[33] * PI0[0][12][6] + sp[34] * PI1[0][12][6] + sp[28] * PI2[0][12][6] + sp[31] * PI3[0][12][6] + sp[34] * PI1[0][6][12] + sp[35] * PI4[0][12][6] + sp[29] * PI5[0][12][6] + sp[32] * PI6[0][12][6] + sp[28] * PI2[0][6][12] + sp[29] * PI5[0][6][12] + sp[26] * PI7[0][12][6] + sp[27] * PI8[0][12][6] + sp[31] * PI3[0][6][12] + sp[32] * PI6[0][6][12] + sp[27] * PI8[0][6][12] + sp[30] * PI9[0][12][6];
    A[187] = sp[33] * PI0[0][12][7] + sp[34] * PI1[0][12][7] + sp[28] * PI2[0][12][7] + sp[31] * PI3[0][12][7] + sp[34] * PI1[0][7][12] + sp[35] * PI4[0][12][7] + sp[29] * PI5[0][12][7] + sp[32] * PI6[0][12][7] + sp[28] * PI2[0][7][12] + sp[29] * PI5[0][7][12] + sp[26] * PI7[0][12][7] + sp[27] * PI8[0][12][7] + sp[31] * PI3[0][7][12] + sp[32] * PI6[0][7][12] + sp[27] * PI8[0][7][12] + sp[30] * PI9[0][12][7];
    A[188] = sp[33] * PI0[0][12][8] + sp[34] * PI1[0][12][8] + sp[28] * PI2[0][12][8] + sp[31] * PI3[0][12][8] + sp[34] * PI1[0][8][12] + sp[35] * PI4[0][12][8] + sp[29] * PI5[0][12][8] + sp[32] * PI6[0][12][8] + sp[28] * PI2[0][8][12] + sp[29] * PI5[0][8][12] + sp[26] * PI7[0][12][8] + sp[27] * PI8[0][12][8] + sp[31] * PI3[0][8][12] + sp[32] * PI6[0][8][12] + sp[27] * PI8[0][8][12] + sp[30] * PI9[0][12][8];
    A[189] = sp[33] * PI0[0][12][9] + sp[34] * PI1[0][12][9] + sp[28] * PI2[0][12][9] + sp[31] * PI3[0][12][9] + sp[34] * PI1[0][9][12] + sp[35] * PI4[0][12][9] + sp[29] * PI5[0][12][9] + sp[32] * PI6[0][12][9] + sp[28] * PI2[0][9][12] + sp[29] * PI5[0][9][12] + sp[26] * PI7[0][12][9] + sp[27] * PI8[0][12][9] + sp[31] * PI3[0][9][12] + sp[32] * PI6[0][9][12] + sp[27] * PI8[0][9][12] + sp[30] * PI9[0][12][9];
    A[190] = sp[33] * PI0[0][12][10] + sp[34] * PI1[0][12][10] + sp[28] * PI2[0][12][10] + sp[31] * PI3[0][12][10] + sp[34] * PI1[0][10][12] + sp[35] * PI4[0][12][10] + sp[29] * PI5[0][12][10] + sp[32] * PI6[0][12][10] + sp[28] * PI2[0][10][12] + sp[29] * PI5[0][10][12] + sp[26] * PI7[0][12][10] + sp[27] * PI8[0][12][10] + sp[31] * PI3[0][10][12] + sp[32] * PI6[0][10][12] + sp[27] * PI8[0][10][12] + sp[30] * PI9[0][12][10];
    A[191] = sp[33] * PI0[0][12][11] + sp[34] * PI1[0][12][11] + sp[28] * PI2[0][12][11] + sp[31] * PI3[0][12][11] + sp[34] * PI1[0][11][12] + sp[35] * PI4[0][12][11] + sp[29] * PI5[0][12][11] + sp[32] * PI6[0][12][11] + sp[28] * PI2[0][11][12] + sp[29] * PI5[0][11][12] + sp[26] * PI7[0][12][11] + sp[27] * PI8[0][12][11] + sp[31] * PI3[0][11][12] + sp[32] * PI6[0][11][12] + sp[27] * PI8[0][11][12] + sp[30] * PI9[0][12][11];
    A[192] = sp[33] * PI0[0][12][12] + sp[34] * PI1[0][12][12] + sp[28] * PI2[0][12][12] + sp[31] * PI3[0][12][12] + sp[34] * PI1[0][12][12] + sp[35] * PI4[0][12][12] + sp[29] * PI5[0][12][12] + sp[32] * PI6[0][12][12] + sp[28] * PI2[0][12][12] + sp[29] * PI5[0][12][12] + sp[26] * PI7[0][12][12] + sp[27] * PI8[0][12][12] + sp[31] * PI3[0][12][12] + sp[32] * PI6[0][12][12] + sp[27] * PI8[0][12][12] + sp[30] * PI9[0][12][12];
    A[193] = sp[33] * PI0[0][12][13] + sp[34] * PI1[0][12][13] + sp[28] * PI2[0][12][13] + sp[31] * PI3[0][12][13] + sp[34] * PI1[0][13][12] + sp[35] * PI4[0][12][13] + sp[29] * PI5[0][12][13] + sp[32] * PI6[0][12][13] + sp[28] * PI2[0][13][12] + sp[29] * PI5[0][13][12] + sp[26] * PI7[0][12][13] + sp[27] * PI8[0][12][13] + sp[31] * PI3[0][13][12] + sp[32] * PI6[0][13][12] + sp[27] * PI8[0][13][12] + sp[30] * PI9[0][12][13];
    A[194] = sp[33] * PI0[0][12][14] + sp[34] * PI1[0][12][14] + sp[28] * PI2[0][12][14] + sp[31] * PI3[0][12][14] + sp[34] * PI1[0][14][12] + sp[35] * PI4[0][12][14] + sp[29] * PI5[0][12][14] + sp[32] * PI6[0][12][14] + sp[28] * PI2[0][14][12] + sp[29] * PI5[0][14][12] + sp[26] * PI7[0][12][14] + sp[27] * PI8[0][12][14] + sp[31] * PI3[0][14][12] + sp[32] * PI6[0][14][12] + sp[27] * PI8[0][14][12] + sp[30] * PI9[0][12][14];
    A[195] = sp[33] * PI0[0][13][0] + sp[34] * PI1[0][13][0] + sp[28] * PI2[0][13][0] + sp[31] * PI3[0][13][0] + sp[34] * PI1[0][0][13] + sp[35] * PI4[0][13][0] + sp[29] * PI5[0][13][0] + sp[32] * PI6[0][13][0] + sp[28] * PI2[0][0][13] + sp[29] * PI5[0][0][13] + sp[26] * PI7[0][13][0] + sp[27] * PI8[0][13][0] + sp[31] * PI3[0][0][13] + sp[32] * PI6[0][0][13] + sp[27] * PI8[0][0][13] + sp[30] * PI9[0][13][0];
    A[196] = sp[33] * PI0[0][13][1] + sp[34] * PI1[0][13][1] + sp[28] * PI2[0][13][1] + sp[31] * PI3[0][13][1] + sp[34] * PI1[0][1][13] + sp[35] * PI4[0][13][1] + sp[29] * PI5[0][13][1] + sp[32] * PI6[0][13][1] + sp[28] * PI2[0][1][13] + sp[29] * PI5[0][1][13] + sp[26] * PI7[0][13][1] + sp[27] * PI8[0][13][1] + sp[31] * PI3[0][1][13] + sp[32] * PI6[0][1][13] + sp[27] * PI8[0][1][13] + sp[30] * PI9[0][13][1];
    A[197] = sp[33] * PI0[0][13][2] + sp[34] * PI1[0][13][2] + sp[28] * PI2[0][13][2] + sp[31] * PI3[0][13][2] + sp[34] * PI1[0][2][13] + sp[35] * PI4[0][13][2] + sp[29] * PI5[0][13][2] + sp[32] * PI6[0][13][2] + sp[28] * PI2[0][2][13] + sp[29] * PI5[0][2][13] + sp[26] * PI7[0][13][2] + sp[27] * PI8[0][13][2] + sp[31] * PI3[0][2][13] + sp[32] * PI6[0][2][13] + sp[27] * PI8[0][2][13] + sp[30] * PI9[0][13][2];
    A[198] = sp[33] * PI0[0][13][3] + sp[34] * PI1[0][13][3] + sp[28] * PI2[0][13][3] + sp[31] * PI3[0][13][3] + sp[34] * PI1[0][3][13] + sp[35] * PI4[0][13][3] + sp[29] * PI5[0][13][3] + sp[32] * PI6[0][13][3] + sp[28] * PI2[0][3][13] + sp[29] * PI5[0][3][13] + sp[26] * PI7[0][13][3] + sp[27] * PI8[0][13][3] + sp[31] * PI3[0][3][13] + sp[32] * PI6[0][3][13] + sp[27] * PI8[0][3][13] + sp[30] * PI9[0][13][3];
    A[199] = sp[33] * PI0[0][13][4] + sp[34] * PI1[0][13][4] + sp[28] * PI2[0][13][4] + sp[31] * PI3[0][13][4] + sp[34] * PI1[0][4][13] + sp[35] * PI4[0][13][4] + sp[29] * PI5[0][13][4] + sp[32] * PI6[0][13][4] + sp[28] * PI2[0][4][13] + sp[29] * PI5[0][4][13] + sp[26] * PI7[0][13][4] + sp[27] * PI8[0][13][4] + sp[31] * PI3[0][4][13] + sp[32] * PI6[0][4][13] + sp[27] * PI8[0][4][13] + sp[30] * PI9[0][13][4];
    A[200] = sp[33] * PI0[0][13][5] + sp[34] * PI1[0][13][5] + sp[28] * PI2[0][13][5] + sp[31] * PI3[0][13][5] + sp[34] * PI1[0][5][13] + sp[35] * PI4[0][13][5] + sp[29] * PI5[0][13][5] + sp[32] * PI6[0][13][5] + sp[28] * PI2[0][5][13] + sp[29] * PI5[0][5][13] + sp[26] * PI7[0][13][5] + sp[27] * PI8[0][13][5] + sp[31] * PI3[0][5][13] + sp[32] * PI6[0][5][13] + sp[27] * PI8[0][5][13] + sp[30] * PI9[0][13][5];
    A[201] = sp[33] * PI0[0][13][6] + sp[34] * PI1[0][13][6] + sp[28] * PI2[0][13][6] + sp[31] * PI3[0][13][6] + sp[34] * PI1[0][6][13] + sp[35] * PI4[0][13][6] + sp[29] * PI5[0][13][6] + sp[32] * PI6[0][13][6] + sp[28] * PI2[0][6][13] + sp[29] * PI5[0][6][13] + sp[26] * PI7[0][13][6] + sp[27] * PI8[0][13][6] + sp[31] * PI3[0][6][13] + sp[32] * PI6[0][6][13] + sp[27] * PI8[0][6][13] + sp[30] * PI9[0][13][6];
    A[202] = sp[33] * PI0[0][13][7] + sp[34] * PI1[0][13][7] + sp[28] * PI2[0][13][7] + sp[31] * PI3[0][13][7] + sp[34] * PI1[0][7][13] + sp[35] * PI4[0][13][7] + sp[29] * PI5[0][13][7] + sp[32] * PI6[0][13][7] + sp[28] * PI2[0][7][13] + sp[29] * PI5[0][7][13] + sp[26] * PI7[0][13][7] + sp[27] * PI8[0][13][7] + sp[31] * PI3[0][7][13] + sp[32] * PI6[0][7][13] + sp[27] * PI8[0][7][13] + sp[30] * PI9[0][13][7];
    A[203] = sp[33] * PI0[0][13][8] + sp[34] * PI1[0][13][8] + sp[28] * PI2[0][13][8] + sp[31] * PI3[0][13][8] + sp[34] * PI1[0][8][13] + sp[35] * PI4[0][13][8] + sp[29] * PI5[0][13][8] + sp[32] * PI6[0][13][8] + sp[28] * PI2[0][8][13] + sp[29] * PI5[0][8][13] + sp[26] * PI7[0][13][8] + sp[27] * PI8[0][13][8] + sp[31] * PI3[0][8][13] + sp[32] * PI6[0][8][13] + sp[27] * PI8[0][8][13] + sp[30] * PI9[0][13][8];
    A[204] = sp[33] * PI0[0][13][9] + sp[34] * PI1[0][13][9] + sp[28] * PI2[0][13][9] + sp[31] * PI3[0][13][9] + sp[34] * PI1[0][9][13] + sp[35] * PI4[0][13][9] + sp[29] * PI5[0][13][9] + sp[32] * PI6[0][13][9] + sp[28] * PI2[0][9][13] + sp[29] * PI5[0][9][13] + sp[26] * PI7[0][13][9] + sp[27] * PI8[0][13][9] + sp[31] * PI3[0][9][13] + sp[32] * PI6[0][9][13] + sp[27] * PI8[0][9][13] + sp[30] * PI9[0][13][9];
    A[205] = sp[33] * PI0[0][13][10] + sp[34] * PI1[0][13][10] + sp[28] * PI2[0][13][10] + sp[31] * PI3[0][13][10] + sp[34] * PI1[0][10][13] + sp[35] * PI4[0][13][10] + sp[29] * PI5[0][13][10] + sp[32] * PI6[0][13][10] + sp[28] * PI2[0][10][13] + sp[29] * PI5[0][10][13] + sp[26] * PI7[0][13][10] + sp[27] * PI8[0][13][10] + sp[31] * PI3[0][10][13] + sp[32] * PI6[0][10][13] + sp[27] * PI8[0][10][13] + sp[30] * PI9[0][13][10];
    A[206] = sp[33] * PI0[0][13][11] + sp[34] * PI1[0][13][11] + sp[28] * PI2[0][13][11] + sp[31] * PI3[0][13][11] + sp[34] * PI1[0][11][13] + sp[35] * PI4[0][13][11] + sp[29] * PI5[0][13][11] + sp[32] * PI6[0][13][11] + sp[28] * PI2[0][11][13] + sp[29] * PI5[0][11][13] + sp[26] * PI7[0][13][11] + sp[27] * PI8[0][13][11] + sp[31] * PI3[0][11][13] + sp[32] * PI6[0][11][13] + sp[27] * PI8[0][11][13] + sp[30] * PI9[0][13][11];
    A[207] = sp[33] * PI0[0][13][12] + sp[34] * PI1[0][13][12] + sp[28] * PI2[0][13][12] + sp[31] * PI3[0][13][12] + sp[34] * PI1[0][12][13] + sp[35] * PI4[0][13][12] + sp[29] * PI5[0][13][12] + sp[32] * PI6[0][13][12] + sp[28] * PI2[0][12][13] + sp[29] * PI5[0][12][13] + sp[26] * PI7[0][13][12] + sp[27] * PI8[0][13][12] + sp[31] * PI3[0][12][13] + sp[32] * PI6[0][12][13] + sp[27] * PI8[0][12][13] + sp[30] * PI9[0][13][12];
    A[208] = sp[33] * PI0[0][13][13] + sp[34] * PI1[0][13][13] + sp[28] * PI2[0][13][13] + sp[31] * PI3[0][13][13] + sp[34] * PI1[0][13][13] + sp[35] * PI4[0][13][13] + sp[29] * PI5[0][13][13] + sp[32] * PI6[0][13][13] + sp[28] * PI2[0][13][13] + sp[29] * PI5[0][13][13] + sp[26] * PI7[0][13][13] + sp[27] * PI8[0][13][13] + sp[31] * PI3[0][13][13] + sp[32] * PI6[0][13][13] + sp[27] * PI8[0][13][13] + sp[30] * PI9[0][13][13];
    A[209] = sp[33] * PI0[0][13][14] + sp[34] * PI1[0][13][14] + sp[28] * PI2[0][13][14] + sp[31] * PI3[0][13][14] + sp[34] * PI1[0][14][13] + sp[35] * PI4[0][13][14] + sp[29] * PI5[0][13][14] + sp[32] * PI6[0][13][14] + sp[28] * PI2[0][14][13] + sp[29] * PI5[0][14][13] + sp[26] * PI7[0][13][14] + sp[27] * PI8[0][13][14] + sp[31] * PI3[0][14][13] + sp[32] * PI6[0][14][13] + sp[27] * PI8[0][14][13] + sp[30] * PI9[0][13][14];
    A[210] = sp[33] * PI0[0][14][0] + sp[34] * PI1[0][14][0] + sp[28] * PI2[0][14][0] + sp[31] * PI3[0][14][0] + sp[34] * PI1[0][0][14] + sp[35] * PI4[0][14][0] + sp[29] * PI5[0][14][0] + sp[32] * PI6[0][14][0] + sp[28] * PI2[0][0][14] + sp[29] * PI5[0][0][14] + sp[26] * PI7[0][14][0] + sp[27] * PI8[0][14][0] + sp[31] * PI3[0][0][14] + sp[32] * PI6[0][0][14] + sp[27] * PI8[0][0][14] + sp[30] * PI9[0][14][0];
    A[211] = sp[33] * PI0[0][14][1] + sp[34] * PI1[0][14][1] + sp[28] * PI2[0][14][1] + sp[31] * PI3[0][14][1] + sp[34] * PI1[0][1][14] + sp[35] * PI4[0][14][1] + sp[29] * PI5[0][14][1] + sp[32] * PI6[0][14][1] + sp[28] * PI2[0][1][14] + sp[29] * PI5[0][1][14] + sp[26] * PI7[0][14][1] + sp[27] * PI8[0][14][1] + sp[31] * PI3[0][1][14] + sp[32] * PI6[0][1][14] + sp[27] * PI8[0][1][14] + sp[30] * PI9[0][14][1];
    A[212] = sp[33] * PI0[0][14][2] + sp[34] * PI1[0][14][2] + sp[28] * PI2[0][14][2] + sp[31] * PI3[0][14][2] + sp[34] * PI1[0][2][14] + sp[35] * PI4[0][14][2] + sp[29] * PI5[0][14][2] + sp[32] * PI6[0][14][2] + sp[28] * PI2[0][2][14] + sp[29] * PI5[0][2][14] + sp[26] * PI7[0][14][2] + sp[27] * PI8[0][14][2] + sp[31] * PI3[0][2][14] + sp[32] * PI6[0][2][14] + sp[27] * PI8[0][2][14] + sp[30] * PI9[0][14][2];
    A[213] = sp[33] * PI0[0][14][3] + sp[34] * PI1[0][14][3] + sp[28] * PI2[0][14][3] + sp[31] * PI3[0][14][3] + sp[34] * PI1[0][3][14] + sp[35] * PI4[0][14][3] + sp[29] * PI5[0][14][3] + sp[32] * PI6[0][14][3] + sp[28] * PI2[0][3][14] + sp[29] * PI5[0][3][14] + sp[26] * PI7[0][14][3] + sp[27] * PI8[0][14][3] + sp[31] * PI3[0][3][14] + sp[32] * PI6[0][3][14] + sp[27] * PI8[0][3][14] + sp[30] * PI9[0][14][3];
    A[214] = sp[33] * PI0[0][14][4] + sp[34] * PI1[0][14][4] + sp[28] * PI2[0][14][4] + sp[31] * PI3[0][14][4] + sp[34] * PI1[0][4][14] + sp[35] * PI4[0][14][4] + sp[29] * PI5[0][14][4] + sp[32] * PI6[0][14][4] + sp[28] * PI2[0][4][14] + sp[29] * PI5[0][4][14] + sp[26] * PI7[0][14][4] + sp[27] * PI8[0][14][4] + sp[31] * PI3[0][4][14] + sp[32] * PI6[0][4][14] + sp[27] * PI8[0][4][14] + sp[30] * PI9[0][14][4];
    A[215] = sp[33] * PI0[0][14][5] + sp[34] * PI1[0][14][5] + sp[28] * PI2[0][14][5] + sp[31] * PI3[0][14][5] + sp[34] * PI1[0][5][14] + sp[35] * PI4[0][14][5] + sp[29] * PI5[0][14][5] + sp[32] * PI6[0][14][5] + sp[28] * PI2[0][5][14] + sp[29] * PI5[0][5][14] + sp[26] * PI7[0][14][5] + sp[27] * PI8[0][14][5] + sp[31] * PI3[0][5][14] + sp[32] * PI6[0][5][14] + sp[27] * PI8[0][5][14] + sp[30] * PI9[0][14][5];
    A[216] = sp[33] * PI0[0][14][6] + sp[34] * PI1[0][14][6] + sp[28] * PI2[0][14][6] + sp[31] * PI3[0][14][6] + sp[34] * PI1[0][6][14] + sp[35] * PI4[0][14][6] + sp[29] * PI5[0][14][6] + sp[32] * PI6[0][14][6] + sp[28] * PI2[0][6][14] + sp[29] * PI5[0][6][14] + sp[26] * PI7[0][14][6] + sp[27] * PI8[0][14][6] + sp[31] * PI3[0][6][14] + sp[32] * PI6[0][6][14] + sp[27] * PI8[0][6][14] + sp[30] * PI9[0][14][6];
    A[217] = sp[33] * PI0[0][14][7] + sp[34] * PI1[0][14][7] + sp[28] * PI2[0][14][7] + sp[31] * PI3[0][14][7] + sp[34] * PI1[0][7][14] + sp[35] * PI4[0][14][7] + sp[29] * PI5[0][14][7] + sp[32] * PI6[0][14][7] + sp[28] * PI2[0][7][14] + sp[29] * PI5[0][7][14] + sp[26] * PI7[0][14][7] + sp[27] * PI8[0][14][7] + sp[31] * PI3[0][7][14] + sp[32] * PI6[0][7][14] + sp[27] * PI8[0][7][14] + sp[30] * PI9[0][14][7];
    A[218] = sp[33] * PI0[0][14][8] + sp[34] * PI1[0][14][8] + sp[28] * PI2[0][14][8] + sp[31] * PI3[0][14][8] + sp[34] * PI1[0][8][14] + sp[35] * PI4[0][14][8] + sp[29] * PI5[0][14][8] + sp[32] * PI6[0][14][8] + sp[28] * PI2[0][8][14] + sp[29] * PI5[0][8][14] + sp[26] * PI7[0][14][8] + sp[27] * PI8[0][14][8] + sp[31] * PI3[0][8][14] + sp[32] * PI6[0][8][14] + sp[27] * PI8[0][8][14] + sp[30] * PI9[0][14][8];
    A[219] = sp[33] * PI0[0][14][9] + sp[34] * PI1[0][14][9] + sp[28] * PI2[0][14][9] + sp[31] * PI3[0][14][9] + sp[34] * PI1[0][9][14] + sp[35] * PI4[0][14][9] + sp[29] * PI5[0][14][9] + sp[32] * PI6[0][14][9] + sp[28] * PI2[0][9][14] + sp[29] * PI5[0][9][14] + sp[26] * PI7[0][14][9] + sp[27] * PI8[0][14][9] + sp[31] * PI3[0][9][14] + sp[32] * PI6[0][9][14] + sp[27] * PI8[0][9][14] + sp[30] * PI9[0][14][9];
    A[220] = sp[33] * PI0[0][14][10] + sp[34] * PI1[0][14][10] + sp[28] * PI2[0][14][10] + sp[31] * PI3[0][14][10] + sp[34] * PI1[0][10][14] + sp[35] * PI4[0][14][10] + sp[29] * PI5[0][14][10] + sp[32] * PI6[0][14][10] + sp[28] * PI2[0][10][14] + sp[29] * PI5[0][10][14] + sp[26] * PI7[0][14][10] + sp[27] * PI8[0][14][10] + sp[31] * PI3[0][10][14] + sp[32] * PI6[0][10][14] + sp[27] * PI8[0][10][14] + sp[30] * PI9[0][14][10];
    A[221] = sp[33] * PI0[0][14][11] + sp[34] * PI1[0][14][11] + sp[28] * PI2[0][14][11] + sp[31] * PI3[0][14][11] + sp[34] * PI1[0][11][14] + sp[35] * PI4[0][14][11] + sp[29] * PI5[0][14][11] + sp[32] * PI6[0][14][11] + sp[28] * PI2[0][11][14] + sp[29] * PI5[0][11][14] + sp[26] * PI7[0][14][11] + sp[27] * PI8[0][14][11] + sp[31] * PI3[0][11][14] + sp[32] * PI6[0][11][14] + sp[27] * PI8[0][11][14] + sp[30] * PI9[0][14][11];
    A[222] = sp[33] * PI0[0][14][12] + sp[34] * PI1[0][14][12] + sp[28] * PI2[0][14][12] + sp[31] * PI3[0][14][12] + sp[34] * PI1[0][12][14] + sp[35] * PI4[0][14][12] + sp[29] * PI5[0][14][12] + sp[32] * PI6[0][14][12] + sp[28] * PI2[0][12][14] + sp[29] * PI5[0][12][14] + sp[26] * PI7[0][14][12] + sp[27] * PI8[0][14][12] + sp[31] * PI3[0][12][14] + sp[32] * PI6[0][12][14] + sp[27] * PI8[0][12][14] + sp[30] * PI9[0][14][12];
    A[223] = sp[33] * PI0[0][14][13] + sp[34] * PI1[0][14][13] + sp[28] * PI2[0][14][13] + sp[31] * PI3[0][14][13] + sp[34] * PI1[0][13][14] + sp[35] * PI4[0][14][13] + sp[29] * PI5[0][14][13] + sp[32] * PI6[0][14][13] + sp[28] * PI2[0][13][14] + sp[29] * PI5[0][13][14] + sp[26] * PI7[0][14][13] + sp[27] * PI8[0][14][13] + sp[31] * PI3[0][13][14] + sp[32] * PI6[0][13][14] + sp[27] * PI8[0][13][14] + sp[30] * PI9[0][14][13];
    A[224] = sp[33] * PI0[0][14][14] + sp[34] * PI1[0][14][14] + sp[28] * PI2[0][14][14] + sp[31] * PI3[0][14][14] + sp[34] * PI1[0][14][14] + sp[35] * PI4[0][14][14] + sp[29] * PI5[0][14][14] + sp[32] * PI6[0][14][14] + sp[28] * PI2[0][14][14] + sp[29] * PI5[0][14][14] + sp[26] * PI7[0][14][14] + sp[27] * PI8[0][14][14] + sp[31] * PI3[0][14][14] + sp[32] * PI6[0][14][14] + sp[27] * PI8[0][14][14] + sp[30] * PI9[0][14][14];
  }

};


class forms_cell_integral_1_otherwise: public ufc::cell_integral
{
public:

  forms_cell_integral_1_otherwise() : ufc::cell_integral()
  {

  }

  ~forms_cell_integral_1_otherwise() override
  {

  }

  const std::vector<bool> & enabled_coefficients() const final override
  {
static const std::vector<bool> enabled({});
return enabled;
  }

  void tabulate_tensor(double * A,
                       const double * const * w,
                       const double * coordinate_dofs,
                       int cell_orientation,
                       std::size_t local_facet) const final override
  {
    // This function was generated using 'uflacs' representation
    // with the following integrals metadata:
    // 
    // num_cells:         None
    // optimize:          True
    // precision:         16
    // quadrature_degree: 6
    // quadrature_rule:   'default'
    // representation:    'uflacs'
    // 
    // and the following integral 0 metadata:
    // 
    // estimated_polynomial_degree: 6
    // optimize:                    True
    // precision:                   16
    // quadrature_degree:           6
    // quadrature_rule:             'default'
    // representation:              'uflacs'
    // Precomputed values of basis functions and precomputations
    // FE* dimensions: [entities][points][dofs]
    // PI* dimensions: [entities][dofs][dofs] or [entities][dofs]
    // PM* dimensions: [entities][dofs][dofs]
    alignas(32) static const double FE3_C0_D01_Q12[1][1][2] = { { { -1.0, 1.0 } } };
    alignas(32) static const double PI0[1][15][15] =
        { { { 0.02162698412698431, -0.02986111111111124, 0.01765873015873013, -0.01542658730158738, 0.01746031746031742, -0.02385912698412703, -0.01314484126984123, 0.02777777777777798, -0.02058531746031759, 0.04349267900155088, 0.06529556615835218, -0.01686507936508121, 0.03507474113028568, -0.1005208057964092, 0.06200396825396933 },
            { -0.02986111111111124, 0.06865079365079411, -0.04871031746031768, 0.01746031746031738, -0.04384920634920646, 0.06111111111111152, 0.01041666666666662, -0.017857142857143, 0.02529761904761932, -0.07856742013183707, -0.05326743555023487, -0.004960317460314853, -0.07014948226057147, 0.04639421805988017, -0.1240079365079387 },
            { 0.01765873015873013, -0.04871031746031768, 0.05734126984127029, -0.02385912698412707, 0.06111111111111158, -0.05114087301587335, -0.01860119047619066, 0.01190476190476206, -0.0111607142857144, 0.1248660784238152, -0.003436608745177355, 0.1001984126984121, -0.03507474113028559, -0.02319710902993965, -0.06200396825396913 },
            { -0.01542658730158738, 0.01746031746031738, -0.02385912698412707, 0.02162698412698431, -0.02986111111111128, 0.01765873015873012, 0.02058531746031754, -0.02777777777777795, 0.01314484126984123, -0.07856742013183654, -0.03522523963805746, -0.04513888888888851, 0.03507474113028571, 0.1005208057964092, 0.06200396825396932 },
            { 0.01746031746031742, -0.04384920634920646, 0.06111111111111158, -0.02986111111111128, 0.0686507936507942, -0.04871031746031772, -0.02529761904761927, 0.01785714285714303, -0.0104166666666667, 0.1487169023924089, -0.006873217490354102, 0.128968253968254, -0.07014948226057124, -0.04639421805988033, -0.1240079365079384 },
            { -0.02385912698412703, 0.06111111111111152, -0.05114087301587335, 0.01765873015873012, -0.04871031746031772, 0.05734126984127025, 0.01116071428571429, -0.01190476190476201, 0.01860119047619067, -0.08979133729352907, -0.02663371777511737, -0.03819444444444298, -0.03507474113028574, 0.02319710902993955, -0.06200396825396939 },
            { -0.01314484126984123, 0.01041666666666662, -0.01860119047619066, 0.02058531746031754, -0.02529761904761927, 0.01116071428571429, 0.1012896825396832, -0.09444444444444478, 0.04474206349206337, -0.206239477846075, 0.1314502845029981, 0.1473214285714272, 0.04208968935634295, 0.1030982623552903, 0.07440476190476329 },
            { 0.02777777777777798, -0.017857142857143, 0.01190476190476206, -0.02777777777777795, 0.01785714285714303, -0.01190476190476201, -0.09444444444444478, 0.1630952380952393, -0.09444444444444487, 0.1346870059402922, 0.1030982623552914, -0.1071428571428555, 0.0, -0.2061965247105819, 0.0 },
            { -0.02058531746031759, 0.02529761904761932, -0.0111607142857144, 0.01314484126984123, -0.0104166666666667, 0.01860119047619067, 0.04474206349206337, -0.09444444444444487, 0.1012896825396833, -0.1641497884897317, -0.2345485468582881, 0.2217261904761901, -0.04208968935634277, 0.1030982623552904, -0.07440476190476322 },
            { 0.04349267900155088, -0.07856742013183707, 0.1248660784238152, -0.07856742013183654, 0.1487169023924089, -0.08979133729352907, -0.206239477846075, 0.1346870059402922, -0.1641497884897317, 4.920634920634906, 0.02430049347996666, -0.5191061687282009, -0.1984126984127008, -0.2187044413199079, -0.3507474113028551 },
            { 0.06529556615835218, -0.05326743555023487, -0.003436608745177355, -0.03522523963805746, -0.006873217490354102, -0.02663371777511737, 0.1314502845029981, 0.1030982623552914, -0.2345485468582881, 0.02430049347996666, 5.416666666666705, -0.1890134809847069, 0.1701034543599522, -0.4017857142857207, 0.3007032652029473 },
            { -0.01686507936508121, -0.004960317460314853, 0.1001984126984121, -0.04513888888888851, 0.128968253968254, -0.03819444444444298, 0.1473214285714272, -0.1071428571428555, 0.2217261904761901, -0.5191061687282009, -0.1890134809847069, 5.555555555555567, -0.3507474113028568, 0.07732369676647513, -0.6200396825396934 },
            { 0.03507474113028568, -0.07014948226057147, -0.03507474113028559, 0.03507474113028571, -0.07014948226057124, -0.03507474113028574, 0.04208968935634295, 0.0, -0.04208968935634277, -0.1984126984127008, 0.1701034543599522, -0.3507474113028568, 0.3968253968254035, 0.0, 0.7014948226057137 },
            { -0.1005208057964092, 0.04639421805988017, -0.02319710902993965, 0.1005208057964092, -0.04639421805988033, 0.02319710902993955, 0.1030982623552903, -0.2061965247105819, 0.1030982623552904, -0.2187044413199079, -0.4017857142857207, 0.07732369676647513, 0.0, 0.8035714285714399, 0.0 },
            { 0.06200396825396933, -0.1240079365079387, -0.06200396825396913, 0.06200396825396932, -0.1240079365079384, -0.06200396825396939, 0.07440476190476329, 0.0, -0.07440476190476322, -0.3507474113028551, 0.3007032652029473, -0.6200396825396934, 0.7014948226057137, 0.0, 1.240079365079386 } } };
    alignas(32) static const double PI1[1][15][15] =
        { { { -0.01116071428571436, 0.005952380952380893, -0.004712301587301564, -0.02447916666666679, 0.02167658730158718, -0.03266369047619056, -0.008804563492063527, 0.01413690476190483, -0.00706845238095237, -0.02314932914598857, -0.05154913117764573, -0.007440476190475837, 0.1283735525368423, -0.06314768569261543, 0.09598214285714161 },
            { 0.009920634920635017, -0.01289682539682549, 0.005952380952380899, 0.02316468253968254, -0.05327380952380971, 0.07524801587301638, 0.004216269841269754, -0.009424603174603217, 0.01165674603174617, -0.009820927516479935, -0.008591521862941575, 0.01984126984126919, -0.1360899955855055, 0.04897167461876207, -0.2405753968253962 },
            { -0.004712301587301633, 0.009920634920635014, -0.01116071428571437, -0.03067956349206371, 0.07276785714285776, -0.05820932539682573, -0.009052579365079409, 0.005704365079365117, -0.0068204365079366, 0.01192541198429708, -0.01718304372588153, -0.07192460317460365, 0.06243303921190663, 0.001288728279440908, 0.1460813492063478 },
            { 0.009052579365079378, -0.004216269841269736, 0.008804563492063541, 0.03278769841269866, -0.03581349206349217, 0.02237103174603166, 0.0135168650793652, -0.01364087301587306, 0.004340277777777702, 0.02665680325901711, 0.07947157723220397, 0.04340277777777812, -0.09329881140655656, 0.03737312010379359, -0.03397817460317271 },
            { -0.005704365079365099, 0.009424603174603211, -0.01413690476190487, -0.03978174603174634, 0.08154761904761973, -0.05466269841269863, -0.01364087301587312, 0.008432539682539719, -0.006200396825396861, 0.002805979290422823, -0.04725337024617498, -0.09176587301587383, 0.06594051332493474, 0.00257745655888161, 0.1165674603174584 },
            { 0.006820436507936571, -0.01165674603174613, 0.007068452380952364, 0.02237103174603179, -0.05863095238095272, 0.06850198412698461, 0.004340277777777716, -0.006200396825396848, 0.009548611111111228, -0.01543288609732562, -0.01073940232867676, 0.03596230158730127, -0.09750778034219185, 0.02448583730938072, -0.2080853174603169 },
            { 0.03067956349206363, -0.02316468253968252, 0.02447916666666686, 0.0787946428571432, -0.1005456349206356, 0.04382440476190482, 0.03278769841269869, -0.03978174603174623, 0.02237103174603176, 0.04700015311458267, 0.1576544261849665, 0.1068948412698424, -0.1529258713280404, 0.01546473935329249, 0.01537698412698358 },
            { -0.07276785714285773, 0.05327380952380976, -0.02167658730158727, -0.1005456349206356, 0.07113095238095266, -0.03358134920634909, -0.03581349206349214, 0.08154761904761959, -0.05863095238095276, -0.07997040977705104, -0.1520699369740541, 0.01934523809523991, 0.2946278254943947, -0.1030982623552907, -0.1458333333333371 },
            { 0.05820932539682568, -0.07524801587301644, 0.03266369047619066, 0.04382440476190489, -0.03358134920634911, 0.04308035714285738, 0.02237103174603168, -0.05466269841269848, 0.06850198412698463, -0.05822407027627449, -0.06142938132002938, 0.09945436507936577, -0.1950155606843831, 0.08763352300199813, -0.05902777777777977 },
            { -0.06243303921190627, 0.1360899955855054, -0.1283735525368425, -0.1529258713280407, 0.2946278254943958, -0.1950155606843832, -0.0932988114065568, 0.06594051332493386, -0.09750778034219194, 0.1984126984127024, -0.06075123369997157, -0.8067190459965544, 4.305555555555532, -0.03645074021998873, 0.5401510134063878 },
            { -0.1271545235715236, 0.1838585678669346, -0.05154913117764402, 0.02104922856420374, -0.1778445025628789, -0.007302793583500541, -0.01073940232867382, 0.102239110168994, -0.1679642524204937, 0.2308546880599293, 0.4315476190476341, -0.06873217490352168, 0.44955912937984, 3.593749999999993, 0.176126198190289 },
            { 0.07192460317460238, -0.1626984126984118, 0.1026785714285712, 0.00570436507936428, -0.01636904761904647, 0.1054067460317478, 0.04935515873015887, -0.05605158730158662, 0.1252480158730151, -0.3016427737204521, -0.2749286996141059, 0.5902777777777805, -0.3016427737204421, 0.1675346763273486, 3.395337301587297 },
            { -0.0119254119842971, 0.009820927516479953, 0.02314932914598861, 0.04700015311458289, -0.07997040977705128, -0.05822407027627432, 0.0266568032590172, 0.002805979290422787, -0.01543288609732566, 0.01984126984127009, 0.1579532076199497, 0.2034334985556575, 0.1984126984127025, -0.1458029608799465, 0.3507474113028566 },
            { 0.0708800553692623, -0.01288728279441039, 0.03221820698602827, 0.1714008611656714, -0.05928150085429078, 0.05541531601596766, 0.07732369676646841, -0.1030982623552908, 0.02577456558882195, 0.2551551815399182, 0.5580357142857221, 0.06443641397205639, -0.7290148043997455, 0.4017857142857197, -0.05154913117763481 },
            { -0.02108134920634958, 0.01736111111111142, 0.0409226190476198, 0.08308531746031889, -0.1413690476190498, -0.1029265873015892, 0.04712301587301677, 0.0049603174603175, -0.02728174603174652, 0.03507474113028559, 0.2792244605455827, 0.3596230158730228, 0.3507474113028584, -0.2577456558882171, 0.6200396825396925 } } };
    alignas(32) static const double PI2[1][15][15] =
        { { { 0.0573412698412703, -0.0487103174603177, 0.01765873015873014, 0.01860119047619063, -0.01190476190476194, 0.01116071428571423, 0.02385912698412704, -0.06111111111111153, 0.05114087301587334, 0.03507474113028576, 0.06529556615835107, -0.01091269841269979, -0.1248660784238149, -0.08505606644311393, 0.05307539682539841 },
            { -0.0487103174603177, 0.06865079365079423, -0.0298611111111113, -0.01041666666666665, 0.01785714285714289, -0.02529761904761916, -0.01746031746031742, 0.04384920634920645, -0.06111111111111159, 0.07014948226057137, 0.08419691425682248, -0.1021825396825405, 0.07856742013183703, 0.03092947870658573, 0.0436507936507955 },
            { 0.01765873015873014, -0.0298611111111113, 0.02162698412698439, 0.01314484126984132, -0.02777777777777799, 0.02058531746031757, 0.01542658730158744, -0.01746031746031742, 0.02385912698412709, -0.03507474113028577, -0.003436608745176606, 0.1180555555555575, -0.04349267900155104, -0.01804219591217461, -0.06498015873016103 },
            { 0.01860119047619063, -0.01041666666666665, 0.01314484126984132, 0.1012896825396833, -0.0944444444444449, 0.04474206349206342, 0.0205853174603176, -0.02529761904761922, 0.01116071428571433, 0.0420896893563427, 0.1159855451497025, 0.05208333333333336, -0.2062394778460749, 0.1933092419161695, 0.04017857142857453 },
            { -0.01190476190476194, 0.01785714285714289, -0.02777777777777799, -0.0944444444444449, 0.1630952380952393, -0.09444444444444484, -0.027777777777778, 0.01785714285714294, -0.01190476190476194, 0.0, -0.1030982623552912, -0.1785714285714301, 0.1346870059402932, -0.04123930494211493, 0.1428571428571423 },
            { 0.01116071428571423, -0.02529761904761916, 0.02058531746031757, 0.04474206349206342, -0.09444444444444484, 0.1012896825396832, 0.01314484126984125, -0.01041666666666656, 0.01860119047619057, -0.04208968935634271, -0.0128872827944122, 0.1264880952380961, -0.1641497884897319, 0.07474624020758441, -0.3139880952380973 },
            { 0.02385912698412704, -0.01746031746031742, 0.01542658730158744, 0.0205853174603176, -0.027777777777778, 0.01314484126984125, 0.02162698412698432, -0.0298611111111112, 0.01765873015873012, 0.0350747411302855, 0.1039574145415857, 0.05605158730158822, -0.07856742013183649, -0.05670404429540882, -0.007936507936508005 },
            { -0.06111111111111153, 0.04384920634920645, -0.01746031746031742, -0.02529761904761922, 0.01785714285714294, -0.01041666666666656, -0.0298611111111112, 0.06865079365079406, -0.04871031746031766, -0.07014948226057122, -0.1305911323167023, 0.02182539682539824, 0.1487169023924078, 0.108253175473054, -0.07043650793651013 },
            { 0.05114087301587334, -0.06111111111111159, 0.02385912698412709, 0.01116071428571433, -0.01190476190476194, 0.01860119047619057, 0.01765873015873012, -0.04871031746031766, 0.05734126984127029, -0.03507474113028576, -0.04209845712841166, 0.05109126984126978, -0.08979133729352916, -0.04639421805987937, -0.003968253968254665 },
            { 0.03507474113028576, 0.07014948226057137, -0.03507474113028577, 0.0420896893563427, 0.0, -0.04208968935634271, 0.0350747411302855, -0.07014948226057122, -0.03507474113028576, 0.3968253968254032, 0.6075123369998057, -0.3507474113028575, -0.1984126984127003, -0.2187044413199281, 0.3226876183986339 },
            { 0.06529556615835107, 0.08419691425682248, -0.003436608745176606, 0.1159855451497025, -0.1030982623552912, -0.0128872827944122, 0.1039574145415857, -0.1305911323167023, -0.04209845712841166, 0.6075123369998057, 1.130952380952398, -0.1890134809847021, -0.4131083891598573, -0.4017857142857154, 0.3007032652029421 },
            { -0.01091269841269979, -0.1021825396825405, 0.1180555555555575, 0.05208333333333336, -0.1785714285714301, 0.1264880952380961, 0.05605158730158822, 0.02182539682539824, 0.05109126984126978, -0.3507474113028575, -0.1890134809847021, 0.9126984126984312, -0.01402989645209706, 0.07732369676647466, -0.6200396825397014 },
            { -0.1248660784238149, 0.07856742013183703, -0.04349267900155104, -0.2062394778460749, 0.1346870059402932, -0.1641497884897319, -0.07856742013183649, 0.1487169023924078, -0.08979133729352916, -0.1984126984127003, -0.4131083891598573, -0.01402989645209706, 4.920634920634909, -0.4374088826398539, 0.28059792904226 },
            { -0.08505606644311393, 0.03092947870658573, -0.01804219591217461, 0.1933092419161695, -0.04123930494211493, 0.07474624020758441, -0.05670404429540882, 0.108253175473054, -0.04639421805987937, -0.2187044413199281, -0.4017857142857154, 0.07732369676647466, -0.4374088826398539, 5.357142857142867, -0.1546473935329298 },
            { 0.05307539682539841, 0.0436507936507955, -0.06498015873016103, 0.04017857142857453, 0.1428571428571423, -0.3139880952380973, -0.007936507936508005, -0.07043650793651013, -0.003968253968254665, 0.3226876183986339, 0.3007032652029421, -0.6200396825397014, 0.28059792904226, -0.1546473935329298, 5.615079365079415 } } };
    // Unstructured piecewise computations
    const double J_c0 = coordinate_dofs[0] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[2] * FE3_C0_D01_Q12[0][0][1];
    const double J_c3 = coordinate_dofs[1] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[5] * FE3_C0_D01_Q12[0][0][1];
    const double J_c1 = coordinate_dofs[0] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[4] * FE3_C0_D01_Q12[0][0][1];
    const double J_c2 = coordinate_dofs[1] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[3] * FE3_C0_D01_Q12[0][0][1];
    alignas(32) double sp[20];
    sp[0] = J_c0 * J_c3;
    sp[1] = J_c1 * J_c2;
    sp[2] = sp[0] + -1 * sp[1];
    sp[3] = J_c0 / sp[2];
    sp[4] = -1 * J_c1 / sp[2];
    sp[5] = sp[3] * sp[3];
    sp[6] = sp[3] * sp[4];
    sp[7] = sp[4] * sp[4];
    sp[8] = J_c3 / sp[2];
    sp[9] = -1 * J_c2 / sp[2];
    sp[10] = sp[9] * sp[9];
    sp[11] = sp[8] * sp[9];
    sp[12] = sp[8] * sp[8];
    sp[13] = sp[5] + sp[10];
    sp[14] = sp[6] + sp[11];
    sp[15] = sp[12] + sp[7];
    sp[16] = std::abs(sp[2]);
    sp[17] = sp[13] * sp[16];
    sp[18] = sp[14] * sp[16];
    sp[19] = sp[15] * sp[16];
    A[0] = sp[19] * PI0[0][0][0] + sp[18] * PI1[0][0][0] + sp[18] * PI1[0][0][0] + sp[17] * PI2[0][0][0];
    A[1] = sp[19] * PI0[0][0][1] + sp[18] * PI1[0][0][1] + sp[18] * PI1[0][1][0] + sp[17] * PI2[0][0][1];
    A[2] = sp[19] * PI0[0][0][2] + sp[18] * PI1[0][0][2] + sp[18] * PI1[0][2][0] + sp[17] * PI2[0][0][2];
    A[3] = sp[19] * PI0[0][0][3] + sp[18] * PI1[0][0][3] + sp[18] * PI1[0][3][0] + sp[17] * PI2[0][0][3];
    A[4] = sp[19] * PI0[0][0][4] + sp[18] * PI1[0][0][4] + sp[18] * PI1[0][4][0] + sp[17] * PI2[0][0][4];
    A[5] = sp[19] * PI0[0][0][5] + sp[18] * PI1[0][0][5] + sp[18] * PI1[0][5][0] + sp[17] * PI2[0][0][5];
    A[6] = sp[19] * PI0[0][0][6] + sp[18] * PI1[0][0][6] + sp[18] * PI1[0][6][0] + sp[17] * PI2[0][0][6];
    A[7] = sp[19] * PI0[0][0][7] + sp[18] * PI1[0][0][7] + sp[18] * PI1[0][7][0] + sp[17] * PI2[0][0][7];
    A[8] = sp[19] * PI0[0][0][8] + sp[18] * PI1[0][0][8] + sp[18] * PI1[0][8][0] + sp[17] * PI2[0][0][8];
    A[9] = sp[19] * PI0[0][0][9] + sp[18] * PI1[0][0][9] + sp[18] * PI1[0][9][0] + sp[17] * PI2[0][0][9];
    A[10] = sp[19] * PI0[0][0][10] + sp[18] * PI1[0][0][10] + sp[18] * PI1[0][10][0] + sp[17] * PI2[0][0][10];
    A[11] = sp[19] * PI0[0][0][11] + sp[18] * PI1[0][0][11] + sp[18] * PI1[0][11][0] + sp[17] * PI2[0][0][11];
    A[12] = sp[19] * PI0[0][0][12] + sp[18] * PI1[0][0][12] + sp[18] * PI1[0][12][0] + sp[17] * PI2[0][0][12];
    A[13] = sp[19] * PI0[0][0][13] + sp[18] * PI1[0][0][13] + sp[18] * PI1[0][13][0] + sp[17] * PI2[0][0][13];
    A[14] = sp[19] * PI0[0][0][14] + sp[18] * PI1[0][0][14] + sp[18] * PI1[0][14][0] + sp[17] * PI2[0][0][14];
    A[15] = sp[19] * PI0[0][1][0] + sp[18] * PI1[0][1][0] + sp[18] * PI1[0][0][1] + sp[17] * PI2[0][1][0];
    A[16] = sp[19] * PI0[0][1][1] + sp[18] * PI1[0][1][1] + sp[18] * PI1[0][1][1] + sp[17] * PI2[0][1][1];
    A[17] = sp[19] * PI0[0][1][2] + sp[18] * PI1[0][1][2] + sp[18] * PI1[0][2][1] + sp[17] * PI2[0][1][2];
    A[18] = sp[19] * PI0[0][1][3] + sp[18] * PI1[0][1][3] + sp[18] * PI1[0][3][1] + sp[17] * PI2[0][1][3];
    A[19] = sp[19] * PI0[0][1][4] + sp[18] * PI1[0][1][4] + sp[18] * PI1[0][4][1] + sp[17] * PI2[0][1][4];
    A[20] = sp[19] * PI0[0][1][5] + sp[18] * PI1[0][1][5] + sp[18] * PI1[0][5][1] + sp[17] * PI2[0][1][5];
    A[21] = sp[19] * PI0[0][1][6] + sp[18] * PI1[0][1][6] + sp[18] * PI1[0][6][1] + sp[17] * PI2[0][1][6];
    A[22] = sp[19] * PI0[0][1][7] + sp[18] * PI1[0][1][7] + sp[18] * PI1[0][7][1] + sp[17] * PI2[0][1][7];
    A[23] = sp[19] * PI0[0][1][8] + sp[18] * PI1[0][1][8] + sp[18] * PI1[0][8][1] + sp[17] * PI2[0][1][8];
    A[24] = sp[19] * PI0[0][1][9] + sp[18] * PI1[0][1][9] + sp[18] * PI1[0][9][1] + sp[17] * PI2[0][1][9];
    A[25] = sp[19] * PI0[0][1][10] + sp[18] * PI1[0][1][10] + sp[18] * PI1[0][10][1] + sp[17] * PI2[0][1][10];
    A[26] = sp[19] * PI0[0][1][11] + sp[18] * PI1[0][1][11] + sp[18] * PI1[0][11][1] + sp[17] * PI2[0][1][11];
    A[27] = sp[19] * PI0[0][1][12] + sp[18] * PI1[0][1][12] + sp[18] * PI1[0][12][1] + sp[17] * PI2[0][1][12];
    A[28] = sp[19] * PI0[0][1][13] + sp[18] * PI1[0][1][13] + sp[18] * PI1[0][13][1] + sp[17] * PI2[0][1][13];
    A[29] = sp[19] * PI0[0][1][14] + sp[18] * PI1[0][1][14] + sp[18] * PI1[0][14][1] + sp[17] * PI2[0][1][14];
    A[30] = sp[19] * PI0[0][2][0] + sp[18] * PI1[0][2][0] + sp[18] * PI1[0][0][2] + sp[17] * PI2[0][2][0];
    A[31] = sp[19] * PI0[0][2][1] + sp[18] * PI1[0][2][1] + sp[18] * PI1[0][1][2] + sp[17] * PI2[0][2][1];
    A[32] = sp[19] * PI0[0][2][2] + sp[18] * PI1[0][2][2] + sp[18] * PI1[0][2][2] + sp[17] * PI2[0][2][2];
    A[33] = sp[19] * PI0[0][2][3] + sp[18] * PI1[0][2][3] + sp[18] * PI1[0][3][2] + sp[17] * PI2[0][2][3];
    A[34] = sp[19] * PI0[0][2][4] + sp[18] * PI1[0][2][4] + sp[18] * PI1[0][4][2] + sp[17] * PI2[0][2][4];
    A[35] = sp[19] * PI0[0][2][5] + sp[18] * PI1[0][2][5] + sp[18] * PI1[0][5][2] + sp[17] * PI2[0][2][5];
    A[36] = sp[19] * PI0[0][2][6] + sp[18] * PI1[0][2][6] + sp[18] * PI1[0][6][2] + sp[17] * PI2[0][2][6];
    A[37] = sp[19] * PI0[0][2][7] + sp[18] * PI1[0][2][7] + sp[18] * PI1[0][7][2] + sp[17] * PI2[0][2][7];
    A[38] = sp[19] * PI0[0][2][8] + sp[18] * PI1[0][2][8] + sp[18] * PI1[0][8][2] + sp[17] * PI2[0][2][8];
    A[39] = sp[19] * PI0[0][2][9] + sp[18] * PI1[0][2][9] + sp[18] * PI1[0][9][2] + sp[17] * PI2[0][2][9];
    A[40] = sp[19] * PI0[0][2][10] + sp[18] * PI1[0][2][10] + sp[18] * PI1[0][10][2] + sp[17] * PI2[0][2][10];
    A[41] = sp[19] * PI0[0][2][11] + sp[18] * PI1[0][2][11] + sp[18] * PI1[0][11][2] + sp[17] * PI2[0][2][11];
    A[42] = sp[19] * PI0[0][2][12] + sp[18] * PI1[0][2][12] + sp[18] * PI1[0][12][2] + sp[17] * PI2[0][2][12];
    A[43] = sp[19] * PI0[0][2][13] + sp[18] * PI1[0][2][13] + sp[18] * PI1[0][13][2] + sp[17] * PI2[0][2][13];
    A[44] = sp[19] * PI0[0][2][14] + sp[18] * PI1[0][2][14] + sp[18] * PI1[0][14][2] + sp[17] * PI2[0][2][14];
    A[45] = sp[19] * PI0[0][3][0] + sp[18] * PI1[0][3][0] + sp[18] * PI1[0][0][3] + sp[17] * PI2[0][3][0];
    A[46] = sp[19] * PI0[0][3][1] + sp[18] * PI1[0][3][1] + sp[18] * PI1[0][1][3] + sp[17] * PI2[0][3][1];
    A[47] = sp[19] * PI0[0][3][2] + sp[18] * PI1[0][3][2] + sp[18] * PI1[0][2][3] + sp[17] * PI2[0][3][2];
    A[48] = sp[19] * PI0[0][3][3] + sp[18] * PI1[0][3][3] + sp[18] * PI1[0][3][3] + sp[17] * PI2[0][3][3];
    A[49] = sp[19] * PI0[0][3][4] + sp[18] * PI1[0][3][4] + sp[18] * PI1[0][4][3] + sp[17] * PI2[0][3][4];
    A[50] = sp[19] * PI0[0][3][5] + sp[18] * PI1[0][3][5] + sp[18] * PI1[0][5][3] + sp[17] * PI2[0][3][5];
    A[51] = sp[19] * PI0[0][3][6] + sp[18] * PI1[0][3][6] + sp[18] * PI1[0][6][3] + sp[17] * PI2[0][3][6];
    A[52] = sp[19] * PI0[0][3][7] + sp[18] * PI1[0][3][7] + sp[18] * PI1[0][7][3] + sp[17] * PI2[0][3][7];
    A[53] = sp[19] * PI0[0][3][8] + sp[18] * PI1[0][3][8] + sp[18] * PI1[0][8][3] + sp[17] * PI2[0][3][8];
    A[54] = sp[19] * PI0[0][3][9] + sp[18] * PI1[0][3][9] + sp[18] * PI1[0][9][3] + sp[17] * PI2[0][3][9];
    A[55] = sp[19] * PI0[0][3][10] + sp[18] * PI1[0][3][10] + sp[18] * PI1[0][10][3] + sp[17] * PI2[0][3][10];
    A[56] = sp[19] * PI0[0][3][11] + sp[18] * PI1[0][3][11] + sp[18] * PI1[0][11][3] + sp[17] * PI2[0][3][11];
    A[57] = sp[19] * PI0[0][3][12] + sp[18] * PI1[0][3][12] + sp[18] * PI1[0][12][3] + sp[17] * PI2[0][3][12];
    A[58] = sp[19] * PI0[0][3][13] + sp[18] * PI1[0][3][13] + sp[18] * PI1[0][13][3] + sp[17] * PI2[0][3][13];
    A[59] = sp[19] * PI0[0][3][14] + sp[18] * PI1[0][3][14] + sp[18] * PI1[0][14][3] + sp[17] * PI2[0][3][14];
    A[60] = sp[19] * PI0[0][4][0] + sp[18] * PI1[0][4][0] + sp[18] * PI1[0][0][4] + sp[17] * PI2[0][4][0];
    A[61] = sp[19] * PI0[0][4][1] + sp[18] * PI1[0][4][1] + sp[18] * PI1[0][1][4] + sp[17] * PI2[0][4][1];
    A[62] = sp[19] * PI0[0][4][2] + sp[18] * PI1[0][4][2] + sp[18] * PI1[0][2][4] + sp[17] * PI2[0][4][2];
    A[63] = sp[19] * PI0[0][4][3] + sp[18] * PI1[0][4][3] + sp[18] * PI1[0][3][4] + sp[17] * PI2[0][4][3];
    A[64] = sp[19] * PI0[0][4][4] + sp[18] * PI1[0][4][4] + sp[18] * PI1[0][4][4] + sp[17] * PI2[0][4][4];
    A[65] = sp[19] * PI0[0][4][5] + sp[18] * PI1[0][4][5] + sp[18] * PI1[0][5][4] + sp[17] * PI2[0][4][5];
    A[66] = sp[19] * PI0[0][4][6] + sp[18] * PI1[0][4][6] + sp[18] * PI1[0][6][4] + sp[17] * PI2[0][4][6];
    A[67] = sp[19] * PI0[0][4][7] + sp[18] * PI1[0][4][7] + sp[18] * PI1[0][7][4] + sp[17] * PI2[0][4][7];
    A[68] = sp[19] * PI0[0][4][8] + sp[18] * PI1[0][4][8] + sp[18] * PI1[0][8][4] + sp[17] * PI2[0][4][8];
    A[69] = sp[19] * PI0[0][4][9] + sp[18] * PI1[0][4][9] + sp[18] * PI1[0][9][4] + sp[17] * PI2[0][4][9];
    A[70] = sp[19] * PI0[0][4][10] + sp[18] * PI1[0][4][10] + sp[18] * PI1[0][10][4] + sp[17] * PI2[0][4][10];
    A[71] = sp[19] * PI0[0][4][11] + sp[18] * PI1[0][4][11] + sp[18] * PI1[0][11][4] + sp[17] * PI2[0][4][11];
    A[72] = sp[19] * PI0[0][4][12] + sp[18] * PI1[0][4][12] + sp[18] * PI1[0][12][4] + sp[17] * PI2[0][4][12];
    A[73] = sp[19] * PI0[0][4][13] + sp[18] * PI1[0][4][13] + sp[18] * PI1[0][13][4] + sp[17] * PI2[0][4][13];
    A[74] = sp[19] * PI0[0][4][14] + sp[18] * PI1[0][4][14] + sp[18] * PI1[0][14][4] + sp[17] * PI2[0][4][14];
    A[75] = sp[19] * PI0[0][5][0] + sp[18] * PI1[0][5][0] + sp[18] * PI1[0][0][5] + sp[17] * PI2[0][5][0];
    A[76] = sp[19] * PI0[0][5][1] + sp[18] * PI1[0][5][1] + sp[18] * PI1[0][1][5] + sp[17] * PI2[0][5][1];
    A[77] = sp[19] * PI0[0][5][2] + sp[18] * PI1[0][5][2] + sp[18] * PI1[0][2][5] + sp[17] * PI2[0][5][2];
    A[78] = sp[19] * PI0[0][5][3] + sp[18] * PI1[0][5][3] + sp[18] * PI1[0][3][5] + sp[17] * PI2[0][5][3];
    A[79] = sp[19] * PI0[0][5][4] + sp[18] * PI1[0][5][4] + sp[18] * PI1[0][4][5] + sp[17] * PI2[0][5][4];
    A[80] = sp[19] * PI0[0][5][5] + sp[18] * PI1[0][5][5] + sp[18] * PI1[0][5][5] + sp[17] * PI2[0][5][5];
    A[81] = sp[19] * PI0[0][5][6] + sp[18] * PI1[0][5][6] + sp[18] * PI1[0][6][5] + sp[17] * PI2[0][5][6];
    A[82] = sp[19] * PI0[0][5][7] + sp[18] * PI1[0][5][7] + sp[18] * PI1[0][7][5] + sp[17] * PI2[0][5][7];
    A[83] = sp[19] * PI0[0][5][8] + sp[18] * PI1[0][5][8] + sp[18] * PI1[0][8][5] + sp[17] * PI2[0][5][8];
    A[84] = sp[19] * PI0[0][5][9] + sp[18] * PI1[0][5][9] + sp[18] * PI1[0][9][5] + sp[17] * PI2[0][5][9];
    A[85] = sp[19] * PI0[0][5][10] + sp[18] * PI1[0][5][10] + sp[18] * PI1[0][10][5] + sp[17] * PI2[0][5][10];
    A[86] = sp[19] * PI0[0][5][11] + sp[18] * PI1[0][5][11] + sp[18] * PI1[0][11][5] + sp[17] * PI2[0][5][11];
    A[87] = sp[19] * PI0[0][5][12] + sp[18] * PI1[0][5][12] + sp[18] * PI1[0][12][5] + sp[17] * PI2[0][5][12];
    A[88] = sp[19] * PI0[0][5][13] + sp[18] * PI1[0][5][13] + sp[18] * PI1[0][13][5] + sp[17] * PI2[0][5][13];
    A[89] = sp[19] * PI0[0][5][14] + sp[18] * PI1[0][5][14] + sp[18] * PI1[0][14][5] + sp[17] * PI2[0][5][14];
    A[90] = sp[19] * PI0[0][6][0] + sp[18] * PI1[0][6][0] + sp[18] * PI1[0][0][6] + sp[17] * PI2[0][6][0];
    A[91] = sp[19] * PI0[0][6][1] + sp[18] * PI1[0][6][1] + sp[18] * PI1[0][1][6] + sp[17] * PI2[0][6][1];
    A[92] = sp[19] * PI0[0][6][2] + sp[18] * PI1[0][6][2] + sp[18] * PI1[0][2][6] + sp[17] * PI2[0][6][2];
    A[93] = sp[19] * PI0[0][6][3] + sp[18] * PI1[0][6][3] + sp[18] * PI1[0][3][6] + sp[17] * PI2[0][6][3];
    A[94] = sp[19] * PI0[0][6][4] + sp[18] * PI1[0][6][4] + sp[18] * PI1[0][4][6] + sp[17] * PI2[0][6][4];
    A[95] = sp[19] * PI0[0][6][5] + sp[18] * PI1[0][6][5] + sp[18] * PI1[0][5][6] + sp[17] * PI2[0][6][5];
    A[96] = sp[19] * PI0[0][6][6] + sp[18] * PI1[0][6][6] + sp[18] * PI1[0][6][6] + sp[17] * PI2[0][6][6];
    A[97] = sp[19] * PI0[0][6][7] + sp[18] * PI1[0][6][7] + sp[18] * PI1[0][7][6] + sp[17] * PI2[0][6][7];
    A[98] = sp[19] * PI0[0][6][8] + sp[18] * PI1[0][6][8] + sp[18] * PI1[0][8][6] + sp[17] * PI2[0][6][8];
    A[99] = sp[19] * PI0[0][6][9] + sp[18] * PI1[0][6][9] + sp[18] * PI1[0][9][6] + sp[17] * PI2[0][6][9];
    A[100] = sp[19] * PI0[0][6][10] + sp[18] * PI1[0][6][10] + sp[18] * PI1[0][10][6] + sp[17] * PI2[0][6][10];
    A[101] = sp[19] * PI0[0][6][11] + sp[18] * PI1[0][6][11] + sp[18] * PI1[0][11][6] + sp[17] * PI2[0][6][11];
    A[102] = sp[19] * PI0[0][6][12] + sp[18] * PI1[0][6][12] + sp[18] * PI1[0][12][6] + sp[17] * PI2[0][6][12];
    A[103] = sp[19] * PI0[0][6][13] + sp[18] * PI1[0][6][13] + sp[18] * PI1[0][13][6] + sp[17] * PI2[0][6][13];
    A[104] = sp[19] * PI0[0][6][14] + sp[18] * PI1[0][6][14] + sp[18] * PI1[0][14][6] + sp[17] * PI2[0][6][14];
    A[105] = sp[19] * PI0[0][7][0] + sp[18] * PI1[0][7][0] + sp[18] * PI1[0][0][7] + sp[17] * PI2[0][7][0];
    A[106] = sp[19] * PI0[0][7][1] + sp[18] * PI1[0][7][1] + sp[18] * PI1[0][1][7] + sp[17] * PI2[0][7][1];
    A[107] = sp[19] * PI0[0][7][2] + sp[18] * PI1[0][7][2] + sp[18] * PI1[0][2][7] + sp[17] * PI2[0][7][2];
    A[108] = sp[19] * PI0[0][7][3] + sp[18] * PI1[0][7][3] + sp[18] * PI1[0][3][7] + sp[17] * PI2[0][7][3];
    A[109] = sp[19] * PI0[0][7][4] + sp[18] * PI1[0][7][4] + sp[18] * PI1[0][4][7] + sp[17] * PI2[0][7][4];
    A[110] = sp[19] * PI0[0][7][5] + sp[18] * PI1[0][7][5] + sp[18] * PI1[0][5][7] + sp[17] * PI2[0][7][5];
    A[111] = sp[19] * PI0[0][7][6] + sp[18] * PI1[0][7][6] + sp[18] * PI1[0][6][7] + sp[17] * PI2[0][7][6];
    A[112] = sp[19] * PI0[0][7][7] + sp[18] * PI1[0][7][7] + sp[18] * PI1[0][7][7] + sp[17] * PI2[0][7][7];
    A[113] = sp[19] * PI0[0][7][8] + sp[18] * PI1[0][7][8] + sp[18] * PI1[0][8][7] + sp[17] * PI2[0][7][8];
    A[114] = sp[19] * PI0[0][7][9] + sp[18] * PI1[0][7][9] + sp[18] * PI1[0][9][7] + sp[17] * PI2[0][7][9];
    A[115] = sp[19] * PI0[0][7][10] + sp[18] * PI1[0][7][10] + sp[18] * PI1[0][10][7] + sp[17] * PI2[0][7][10];
    A[116] = sp[19] * PI0[0][7][11] + sp[18] * PI1[0][7][11] + sp[18] * PI1[0][11][7] + sp[17] * PI2[0][7][11];
    A[117] = sp[19] * PI0[0][7][12] + sp[18] * PI1[0][7][12] + sp[18] * PI1[0][12][7] + sp[17] * PI2[0][7][12];
    A[118] = sp[19] * PI0[0][7][13] + sp[18] * PI1[0][7][13] + sp[18] * PI1[0][13][7] + sp[17] * PI2[0][7][13];
    A[119] = sp[19] * PI0[0][7][14] + sp[18] * PI1[0][7][14] + sp[18] * PI1[0][14][7] + sp[17] * PI2[0][7][14];
    A[120] = sp[19] * PI0[0][8][0] + sp[18] * PI1[0][8][0] + sp[18] * PI1[0][0][8] + sp[17] * PI2[0][8][0];
    A[121] = sp[19] * PI0[0][8][1] + sp[18] * PI1[0][8][1] + sp[18] * PI1[0][1][8] + sp[17] * PI2[0][8][1];
    A[122] = sp[19] * PI0[0][8][2] + sp[18] * PI1[0][8][2] + sp[18] * PI1[0][2][8] + sp[17] * PI2[0][8][2];
    A[123] = sp[19] * PI0[0][8][3] + sp[18] * PI1[0][8][3] + sp[18] * PI1[0][3][8] + sp[17] * PI2[0][8][3];
    A[124] = sp[19] * PI0[0][8][4] + sp[18] * PI1[0][8][4] + sp[18] * PI1[0][4][8] + sp[17] * PI2[0][8][4];
    A[125] = sp[19] * PI0[0][8][5] + sp[18] * PI1[0][8][5] + sp[18] * PI1[0][5][8] + sp[17] * PI2[0][8][5];
    A[126] = sp[19] * PI0[0][8][6] + sp[18] * PI1[0][8][6] + sp[18] * PI1[0][6][8] + sp[17] * PI2[0][8][6];
    A[127] = sp[19] * PI0[0][8][7] + sp[18] * PI1[0][8][7] + sp[18] * PI1[0][7][8] + sp[17] * PI2[0][8][7];
    A[128] = sp[19] * PI0[0][8][8] + sp[18] * PI1[0][8][8] + sp[18] * PI1[0][8][8] + sp[17] * PI2[0][8][8];
    A[129] = sp[19] * PI0[0][8][9] + sp[18] * PI1[0][8][9] + sp[18] * PI1[0][9][8] + sp[17] * PI2[0][8][9];
    A[130] = sp[19] * PI0[0][8][10] + sp[18] * PI1[0][8][10] + sp[18] * PI1[0][10][8] + sp[17] * PI2[0][8][10];
    A[131] = sp[19] * PI0[0][8][11] + sp[18] * PI1[0][8][11] + sp[18] * PI1[0][11][8] + sp[17] * PI2[0][8][11];
    A[132] = sp[19] * PI0[0][8][12] + sp[18] * PI1[0][8][12] + sp[18] * PI1[0][12][8] + sp[17] * PI2[0][8][12];
    A[133] = sp[19] * PI0[0][8][13] + sp[18] * PI1[0][8][13] + sp[18] * PI1[0][13][8] + sp[17] * PI2[0][8][13];
    A[134] = sp[19] * PI0[0][8][14] + sp[18] * PI1[0][8][14] + sp[18] * PI1[0][14][8] + sp[17] * PI2[0][8][14];
    A[135] = sp[19] * PI0[0][9][0] + sp[18] * PI1[0][9][0] + sp[18] * PI1[0][0][9] + sp[17] * PI2[0][9][0];
    A[136] = sp[19] * PI0[0][9][1] + sp[18] * PI1[0][9][1] + sp[18] * PI1[0][1][9] + sp[17] * PI2[0][9][1];
    A[137] = sp[19] * PI0[0][9][2] + sp[18] * PI1[0][9][2] + sp[18] * PI1[0][2][9] + sp[17] * PI2[0][9][2];
    A[138] = sp[19] * PI0[0][9][3] + sp[18] * PI1[0][9][3] + sp[18] * PI1[0][3][9] + sp[17] * PI2[0][9][3];
    A[139] = sp[19] * PI0[0][9][4] + sp[18] * PI1[0][9][4] + sp[18] * PI1[0][4][9] + sp[17] * PI2[0][9][4];
    A[140] = sp[19] * PI0[0][9][5] + sp[18] * PI1[0][9][5] + sp[18] * PI1[0][5][9] + sp[17] * PI2[0][9][5];
    A[141] = sp[19] * PI0[0][9][6] + sp[18] * PI1[0][9][6] + sp[18] * PI1[0][6][9] + sp[17] * PI2[0][9][6];
    A[142] = sp[19] * PI0[0][9][7] + sp[18] * PI1[0][9][7] + sp[18] * PI1[0][7][9] + sp[17] * PI2[0][9][7];
    A[143] = sp[19] * PI0[0][9][8] + sp[18] * PI1[0][9][8] + sp[18] * PI1[0][8][9] + sp[17] * PI2[0][9][8];
    A[144] = sp[19] * PI0[0][9][9] + sp[18] * PI1[0][9][9] + sp[18] * PI1[0][9][9] + sp[17] * PI2[0][9][9];
    A[145] = sp[19] * PI0[0][9][10] + sp[18] * PI1[0][9][10] + sp[18] * PI1[0][10][9] + sp[17] * PI2[0][9][10];
    A[146] = sp[19] * PI0[0][9][11] + sp[18] * PI1[0][9][11] + sp[18] * PI1[0][11][9] + sp[17] * PI2[0][9][11];
    A[147] = sp[19] * PI0[0][9][12] + sp[18] * PI1[0][9][12] + sp[18] * PI1[0][12][9] + sp[17] * PI2[0][9][12];
    A[148] = sp[19] * PI0[0][9][13] + sp[18] * PI1[0][9][13] + sp[18] * PI1[0][13][9] + sp[17] * PI2[0][9][13];
    A[149] = sp[19] * PI0[0][9][14] + sp[18] * PI1[0][9][14] + sp[18] * PI1[0][14][9] + sp[17] * PI2[0][9][14];
    A[150] = sp[19] * PI0[0][10][0] + sp[18] * PI1[0][10][0] + sp[18] * PI1[0][0][10] + sp[17] * PI2[0][10][0];
    A[151] = sp[19] * PI0[0][10][1] + sp[18] * PI1[0][10][1] + sp[18] * PI1[0][1][10] + sp[17] * PI2[0][10][1];
    A[152] = sp[19] * PI0[0][10][2] + sp[18] * PI1[0][10][2] + sp[18] * PI1[0][2][10] + sp[17] * PI2[0][10][2];
    A[153] = sp[19] * PI0[0][10][3] + sp[18] * PI1[0][10][3] + sp[18] * PI1[0][3][10] + sp[17] * PI2[0][10][3];
    A[154] = sp[19] * PI0[0][10][4] + sp[18] * PI1[0][10][4] + sp[18] * PI1[0][4][10] + sp[17] * PI2[0][10][4];
    A[155] = sp[19] * PI0[0][10][5] + sp[18] * PI1[0][10][5] + sp[18] * PI1[0][5][10] + sp[17] * PI2[0][10][5];
    A[156] = sp[19] * PI0[0][10][6] + sp[18] * PI1[0][10][6] + sp[18] * PI1[0][6][10] + sp[17] * PI2[0][10][6];
    A[157] = sp[19] * PI0[0][10][7] + sp[18] * PI1[0][10][7] + sp[18] * PI1[0][7][10] + sp[17] * PI2[0][10][7];
    A[158] = sp[19] * PI0[0][10][8] + sp[18] * PI1[0][10][8] + sp[18] * PI1[0][8][10] + sp[17] * PI2[0][10][8];
    A[159] = sp[19] * PI0[0][10][9] + sp[18] * PI1[0][10][9] + sp[18] * PI1[0][9][10] + sp[17] * PI2[0][10][9];
    A[160] = sp[19] * PI0[0][10][10] + sp[18] * PI1[0][10][10] + sp[18] * PI1[0][10][10] + sp[17] * PI2[0][10][10];
    A[161] = sp[19] * PI0[0][10][11] + sp[18] * PI1[0][10][11] + sp[18] * PI1[0][11][10] + sp[17] * PI2[0][10][11];
    A[162] = sp[19] * PI0[0][10][12] + sp[18] * PI1[0][10][12] + sp[18] * PI1[0][12][10] + sp[17] * PI2[0][10][12];
    A[163] = sp[19] * PI0[0][10][13] + sp[18] * PI1[0][10][13] + sp[18] * PI1[0][13][10] + sp[17] * PI2[0][10][13];
    A[164] = sp[19] * PI0[0][10][14] + sp[18] * PI1[0][10][14] + sp[18] * PI1[0][14][10] + sp[17] * PI2[0][10][14];
    A[165] = sp[19] * PI0[0][11][0] + sp[18] * PI1[0][11][0] + sp[18] * PI1[0][0][11] + sp[17] * PI2[0][11][0];
    A[166] = sp[19] * PI0[0][11][1] + sp[18] * PI1[0][11][1] + sp[18] * PI1[0][1][11] + sp[17] * PI2[0][11][1];
    A[167] = sp[19] * PI0[0][11][2] + sp[18] * PI1[0][11][2] + sp[18] * PI1[0][2][11] + sp[17] * PI2[0][11][2];
    A[168] = sp[19] * PI0[0][11][3] + sp[18] * PI1[0][11][3] + sp[18] * PI1[0][3][11] + sp[17] * PI2[0][11][3];
    A[169] = sp[19] * PI0[0][11][4] + sp[18] * PI1[0][11][4] + sp[18] * PI1[0][4][11] + sp[17] * PI2[0][11][4];
    A[170] = sp[19] * PI0[0][11][5] + sp[18] * PI1[0][11][5] + sp[18] * PI1[0][5][11] + sp[17] * PI2[0][11][5];
    A[171] = sp[19] * PI0[0][11][6] + sp[18] * PI1[0][11][6] + sp[18] * PI1[0][6][11] + sp[17] * PI2[0][11][6];
    A[172] = sp[19] * PI0[0][11][7] + sp[18] * PI1[0][11][7] + sp[18] * PI1[0][7][11] + sp[17] * PI2[0][11][7];
    A[173] = sp[19] * PI0[0][11][8] + sp[18] * PI1[0][11][8] + sp[18] * PI1[0][8][11] + sp[17] * PI2[0][11][8];
    A[174] = sp[19] * PI0[0][11][9] + sp[18] * PI1[0][11][9] + sp[18] * PI1[0][9][11] + sp[17] * PI2[0][11][9];
    A[175] = sp[19] * PI0[0][11][10] + sp[18] * PI1[0][11][10] + sp[18] * PI1[0][10][11] + sp[17] * PI2[0][11][10];
    A[176] = sp[19] * PI0[0][11][11] + sp[18] * PI1[0][11][11] + sp[18] * PI1[0][11][11] + sp[17] * PI2[0][11][11];
    A[177] = sp[19] * PI0[0][11][12] + sp[18] * PI1[0][11][12] + sp[18] * PI1[0][12][11] + sp[17] * PI2[0][11][12];
    A[178] = sp[19] * PI0[0][11][13] + sp[18] * PI1[0][11][13] + sp[18] * PI1[0][13][11] + sp[17] * PI2[0][11][13];
    A[179] = sp[19] * PI0[0][11][14] + sp[18] * PI1[0][11][14] + sp[18] * PI1[0][14][11] + sp[17] * PI2[0][11][14];
    A[180] = sp[19] * PI0[0][12][0] + sp[18] * PI1[0][12][0] + sp[18] * PI1[0][0][12] + sp[17] * PI2[0][12][0];
    A[181] = sp[19] * PI0[0][12][1] + sp[18] * PI1[0][12][1] + sp[18] * PI1[0][1][12] + sp[17] * PI2[0][12][1];
    A[182] = sp[19] * PI0[0][12][2] + sp[18] * PI1[0][12][2] + sp[18] * PI1[0][2][12] + sp[17] * PI2[0][12][2];
    A[183] = sp[19] * PI0[0][12][3] + sp[18] * PI1[0][12][3] + sp[18] * PI1[0][3][12] + sp[17] * PI2[0][12][3];
    A[184] = sp[19] * PI0[0][12][4] + sp[18] * PI1[0][12][4] + sp[18] * PI1[0][4][12] + sp[17] * PI2[0][12][4];
    A[185] = sp[19] * PI0[0][12][5] + sp[18] * PI1[0][12][5] + sp[18] * PI1[0][5][12] + sp[17] * PI2[0][12][5];
    A[186] = sp[19] * PI0[0][12][6] + sp[18] * PI1[0][12][6] + sp[18] * PI1[0][6][12] + sp[17] * PI2[0][12][6];
    A[187] = sp[19] * PI0[0][12][7] + sp[18] * PI1[0][12][7] + sp[18] * PI1[0][7][12] + sp[17] * PI2[0][12][7];
    A[188] = sp[19] * PI0[0][12][8] + sp[18] * PI1[0][12][8] + sp[18] * PI1[0][8][12] + sp[17] * PI2[0][12][8];
    A[189] = sp[19] * PI0[0][12][9] + sp[18] * PI1[0][12][9] + sp[18] * PI1[0][9][12] + sp[17] * PI2[0][12][9];
    A[190] = sp[19] * PI0[0][12][10] + sp[18] * PI1[0][12][10] + sp[18] * PI1[0][10][12] + sp[17] * PI2[0][12][10];
    A[191] = sp[19] * PI0[0][12][11] + sp[18] * PI1[0][12][11] + sp[18] * PI1[0][11][12] + sp[17] * PI2[0][12][11];
    A[192] = sp[19] * PI0[0][12][12] + sp[18] * PI1[0][12][12] + sp[18] * PI1[0][12][12] + sp[17] * PI2[0][12][12];
    A[193] = sp[19] * PI0[0][12][13] + sp[18] * PI1[0][12][13] + sp[18] * PI1[0][13][12] + sp[17] * PI2[0][12][13];
    A[194] = sp[19] * PI0[0][12][14] + sp[18] * PI1[0][12][14] + sp[18] * PI1[0][14][12] + sp[17] * PI2[0][12][14];
    A[195] = sp[19] * PI0[0][13][0] + sp[18] * PI1[0][13][0] + sp[18] * PI1[0][0][13] + sp[17] * PI2[0][13][0];
    A[196] = sp[19] * PI0[0][13][1] + sp[18] * PI1[0][13][1] + sp[18] * PI1[0][1][13] + sp[17] * PI2[0][13][1];
    A[197] = sp[19] * PI0[0][13][2] + sp[18] * PI1[0][13][2] + sp[18] * PI1[0][2][13] + sp[17] * PI2[0][13][2];
    A[198] = sp[19] * PI0[0][13][3] + sp[18] * PI1[0][13][3] + sp[18] * PI1[0][3][13] + sp[17] * PI2[0][13][3];
    A[199] = sp[19] * PI0[0][13][4] + sp[18] * PI1[0][13][4] + sp[18] * PI1[0][4][13] + sp[17] * PI2[0][13][4];
    A[200] = sp[19] * PI0[0][13][5] + sp[18] * PI1[0][13][5] + sp[18] * PI1[0][5][13] + sp[17] * PI2[0][13][5];
    A[201] = sp[19] * PI0[0][13][6] + sp[18] * PI1[0][13][6] + sp[18] * PI1[0][6][13] + sp[17] * PI2[0][13][6];
    A[202] = sp[19] * PI0[0][13][7] + sp[18] * PI1[0][13][7] + sp[18] * PI1[0][7][13] + sp[17] * PI2[0][13][7];
    A[203] = sp[19] * PI0[0][13][8] + sp[18] * PI1[0][13][8] + sp[18] * PI1[0][8][13] + sp[17] * PI2[0][13][8];
    A[204] = sp[19] * PI0[0][13][9] + sp[18] * PI1[0][13][9] + sp[18] * PI1[0][9][13] + sp[17] * PI2[0][13][9];
    A[205] = sp[19] * PI0[0][13][10] + sp[18] * PI1[0][13][10] + sp[18] * PI1[0][10][13] + sp[17] * PI2[0][13][10];
    A[206] = sp[19] * PI0[0][13][11] + sp[18] * PI1[0][13][11] + sp[18] * PI1[0][11][13] + sp[17] * PI2[0][13][11];
    A[207] = sp[19] * PI0[0][13][12] + sp[18] * PI1[0][13][12] + sp[18] * PI1[0][12][13] + sp[17] * PI2[0][13][12];
    A[208] = sp[19] * PI0[0][13][13] + sp[18] * PI1[0][13][13] + sp[18] * PI1[0][13][13] + sp[17] * PI2[0][13][13];
    A[209] = sp[19] * PI0[0][13][14] + sp[18] * PI1[0][13][14] + sp[18] * PI1[0][14][13] + sp[17] * PI2[0][13][14];
    A[210] = sp[19] * PI0[0][14][0] + sp[18] * PI1[0][14][0] + sp[18] * PI1[0][0][14] + sp[17] * PI2[0][14][0];
    A[211] = sp[19] * PI0[0][14][1] + sp[18] * PI1[0][14][1] + sp[18] * PI1[0][1][14] + sp[17] * PI2[0][14][1];
    A[212] = sp[19] * PI0[0][14][2] + sp[18] * PI1[0][14][2] + sp[18] * PI1[0][2][14] + sp[17] * PI2[0][14][2];
    A[213] = sp[19] * PI0[0][14][3] + sp[18] * PI1[0][14][3] + sp[18] * PI1[0][3][14] + sp[17] * PI2[0][14][3];
    A[214] = sp[19] * PI0[0][14][4] + sp[18] * PI1[0][14][4] + sp[18] * PI1[0][4][14] + sp[17] * PI2[0][14][4];
    A[215] = sp[19] * PI0[0][14][5] + sp[18] * PI1[0][14][5] + sp[18] * PI1[0][5][14] + sp[17] * PI2[0][14][5];
    A[216] = sp[19] * PI0[0][14][6] + sp[18] * PI1[0][14][6] + sp[18] * PI1[0][6][14] + sp[17] * PI2[0][14][6];
    A[217] = sp[19] * PI0[0][14][7] + sp[18] * PI1[0][14][7] + sp[18] * PI1[0][7][14] + sp[17] * PI2[0][14][7];
    A[218] = sp[19] * PI0[0][14][8] + sp[18] * PI1[0][14][8] + sp[18] * PI1[0][8][14] + sp[17] * PI2[0][14][8];
    A[219] = sp[19] * PI0[0][14][9] + sp[18] * PI1[0][14][9] + sp[18] * PI1[0][9][14] + sp[17] * PI2[0][14][9];
    A[220] = sp[19] * PI0[0][14][10] + sp[18] * PI1[0][14][10] + sp[18] * PI1[0][10][14] + sp[17] * PI2[0][14][10];
    A[221] = sp[19] * PI0[0][14][11] + sp[18] * PI1[0][14][11] + sp[18] * PI1[0][11][14] + sp[17] * PI2[0][14][11];
    A[222] = sp[19] * PI0[0][14][12] + sp[18] * PI1[0][14][12] + sp[18] * PI1[0][12][14] + sp[17] * PI2[0][14][12];
    A[223] = sp[19] * PI0[0][14][13] + sp[18] * PI1[0][14][13] + sp[18] * PI1[0][13][14] + sp[17] * PI2[0][14][13];
    A[224] = sp[19] * PI0[0][14][14] + sp[18] * PI1[0][14][14] + sp[18] * PI1[0][14][14] + sp[17] * PI2[0][14][14];
  }

};


class forms_form_0: public ufc::form
{
public:

  forms_form_0() : ufc::form()
  {
    // Do nothing
  }

  ~forms_form_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "1c9f2722f2f6220661ca872251535a0591b94c8bf328e636d07baddfb70002626dc60b51378046bd622a1ea5d06be457784b36454f010c37a5c3c72c337bbb9b";
  }

  std::size_t rank() const final override
  {
    return 2;
  }

  std::size_t num_coefficients() const final override
  {
    return 0;
  }

  std::size_t original_coefficient_position(std::size_t i) const final override
  {
    throw std::runtime_error("Invalid original coefficient index.");
    return i;
  }

  ufc::finite_element * create_coordinate_finite_element() const final override
  {
    return new forms_finite_element_1();
  }

  ufc::dofmap * create_coordinate_dofmap() const final override
  {
    return new forms_dofmap_1();
   }

  ufc::coordinate_mapping * create_coordinate_mapping() const final override
  {
    return new forms_coordinate_mapping_1();
  }

  ufc::finite_element * create_finite_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_finite_element_2();
    case 1:
        return new forms_finite_element_2();
    default:
        return nullptr;
    }
  }

  ufc::dofmap * create_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_dofmap_2();
    case 1:
        return new forms_dofmap_2();
    default:
        return nullptr;
    }
  }

  std::size_t max_cell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_exterior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_vertex_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_custom_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_cutcell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interface_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_overlap_subdomain_id() const final override
  {
    return 0;
  }

  bool has_cell_integrals() const final override
  {
    return true;
  }

  bool has_exterior_facet_integrals() const final override
  {
    return false;
  }

  bool has_interior_facet_integrals() const final override
  {
    return false;
  }

  bool has_vertex_integrals() const final override
  {
    return false;
  }

  bool has_custom_integrals() const final override
  {
    return false;
  }

  bool has_cutcell_integrals() const final override
  {
    return false;
  }

  bool has_interface_integrals() const final override
  {
    return false;
  }

  bool has_overlap_integrals() const final override
  {
    return false;
  }

  ufc::cell_integral * create_cell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::exterior_facet_integral * create_exterior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_interior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_vertex_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_custom_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_cutcell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_interface_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_overlap_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cell_integral * create_default_cell_integral() const final override
  {
    return new forms_cell_integral_0_otherwise();
  }

  ufc::exterior_facet_integral * create_default_exterior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_default_interior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_default_vertex_integral() const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_default_custom_integral() const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_default_cutcell_integral() const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_default_interface_integral() const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_default_overlap_integral() const final override
  {
    return nullptr;
  }

};


class forms_form_1: public ufc::form
{
public:

  forms_form_1() : ufc::form()
  {
    // Do nothing
  }

  ~forms_form_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "499f292275f354a5c9ba500a5876308055354915a275bd6c468b66ad436ed8f88d82e4d026ada849298959a57aac31fb643a3ed042a61a0d6e7be8c17e801392";
  }

  std::size_t rank() const final override
  {
    return 2;
  }

  std::size_t num_coefficients() const final override
  {
    return 0;
  }

  std::size_t original_coefficient_position(std::size_t i) const final override
  {
    throw std::runtime_error("Invalid original coefficient index.");
    return i;
  }

  ufc::finite_element * create_coordinate_finite_element() const final override
  {
    return new forms_finite_element_1();
  }

  ufc::dofmap * create_coordinate_dofmap() const final override
  {
    return new forms_dofmap_1();
   }

  ufc::coordinate_mapping * create_coordinate_mapping() const final override
  {
    return new forms_coordinate_mapping_1();
  }

  ufc::finite_element * create_finite_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_finite_element_2();
    case 1:
        return new forms_finite_element_2();
    default:
        return nullptr;
    }
  }

  ufc::dofmap * create_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_dofmap_2();
    case 1:
        return new forms_dofmap_2();
    default:
        return nullptr;
    }
  }

  std::size_t max_cell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_exterior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_vertex_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_custom_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_cutcell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interface_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_overlap_subdomain_id() const final override
  {
    return 0;
  }

  bool has_cell_integrals() const final override
  {
    return true;
  }

  bool has_exterior_facet_integrals() const final override
  {
    return false;
  }

  bool has_interior_facet_integrals() const final override
  {
    return false;
  }

  bool has_vertex_integrals() const final override
  {
    return false;
  }

  bool has_custom_integrals() const final override
  {
    return false;
  }

  bool has_cutcell_integrals() const final override
  {
    return false;
  }

  bool has_interface_integrals() const final override
  {
    return false;
  }

  bool has_overlap_integrals() const final override
  {
    return false;
  }

  ufc::cell_integral * create_cell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::exterior_facet_integral * create_exterior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_interior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_vertex_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_custom_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_cutcell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_interface_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_overlap_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cell_integral * create_default_cell_integral() const final override
  {
    return new forms_cell_integral_1_otherwise();
  }

  ufc::exterior_facet_integral * create_default_exterior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_default_interior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_default_vertex_integral() const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_default_custom_integral() const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_default_cutcell_integral() const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_default_interface_integral() const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_default_overlap_integral() const final override
  {
    return nullptr;
  }

};

// DOLFIN wrappers

// Standard library includes
#include <string>

// DOLFIN includes
#include <dolfin/common/NoDeleter.h>
#include <dolfin/mesh/Mesh.h>
#include <dolfin/mesh/MultiMesh.h>
#include <dolfin/fem/FiniteElement.h>
#include <dolfin/fem/DofMap.h>
#include <dolfin/fem/Form.h>
#include <dolfin/fem/MultiMeshForm.h>
#include <dolfin/function/FunctionSpace.h>
#include <dolfin/function/MultiMeshFunctionSpace.h>
#include <dolfin/function/GenericFunction.h>
#include <dolfin/function/CoefficientAssigner.h>
#include <dolfin/function/MultiMeshCoefficientAssigner.h>
#include <dolfin/adaptivity/ErrorControl.h>
#include <dolfin/adaptivity/GoalFunctional.h>
#include <dolfin/la/GenericVector.h>

namespace Forms
{

class Form_a_FunctionSpace_0: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_a_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_a_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_a_FunctionSpace_1: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_a_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_a_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_a_MultiMeshFunctionSpace_0: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_a_MultiMeshFunctionSpace_0(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_a_FunctionSpace_0(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_a_MultiMeshFunctionSpace_1: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_a_MultiMeshFunctionSpace_1(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_a_FunctionSpace_1(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_a: public dolfin::Form
{
public:

  // Constructor
  Form_a(std::shared_ptr<const dolfin::FunctionSpace> V1, std::shared_ptr<const dolfin::FunctionSpace> V0):
    dolfin::Form(2, 0)
  {
    _function_spaces[0] = V0;
    _function_spaces[1] = V1;

    _ufc_form = std::make_shared<const forms_form_0>();
  }

  // Destructor
  ~Form_a()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_a_FunctionSpace_0 TestSpace;
  typedef Form_a_FunctionSpace_1 TrialSpace;
  typedef Form_a_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_a_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class MultiMeshForm_a: public dolfin::MultiMeshForm
{
public:

  // Constructor
  MultiMeshForm_a(std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V1, std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V0):
    dolfin::MultiMeshForm(V1, V0)
  {
    // Create and add standard forms
    std::size_t num_parts = V0->num_parts(); // assume all equal and pick first
    for (std::size_t part = 0; part < num_parts; part++)
    {
      std::shared_ptr<dolfin::Form> a(new Form_a(V1->part(part), V0->part(part)));
    add(a);

    }
    // Build multimesh form
    build();

    /// Assign coefficients

  }

  // Destructor
  ~MultiMeshForm_a()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_a_FunctionSpace_0 TestSpace;
  typedef Form_a_FunctionSpace_1 TrialSpace;
  typedef Form_a_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_a_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class Form_L_FunctionSpace_0: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_L_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_L_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_L_FunctionSpace_1: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_L_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_L_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_L_MultiMeshFunctionSpace_0: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_L_MultiMeshFunctionSpace_0(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_L_FunctionSpace_0(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_L_MultiMeshFunctionSpace_1: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_L_MultiMeshFunctionSpace_1(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_L_FunctionSpace_1(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_L: public dolfin::Form
{
public:

  // Constructor
  Form_L(std::shared_ptr<const dolfin::FunctionSpace> V1, std::shared_ptr<const dolfin::FunctionSpace> V0):
    dolfin::Form(2, 0)
  {
    _function_spaces[0] = V0;
    _function_spaces[1] = V1;

    _ufc_form = std::make_shared<const forms_form_1>();
  }

  // Destructor
  ~Form_L()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_L_FunctionSpace_0 TestSpace;
  typedef Form_L_FunctionSpace_1 TrialSpace;
  typedef Form_L_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_L_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class MultiMeshForm_L: public dolfin::MultiMeshForm
{
public:

  // Constructor
  MultiMeshForm_L(std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V1, std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V0):
    dolfin::MultiMeshForm(V1, V0)
  {
    // Create and add standard forms
    std::size_t num_parts = V0->num_parts(); // assume all equal and pick first
    for (std::size_t part = 0; part < num_parts; part++)
    {
      std::shared_ptr<dolfin::Form> a(new Form_L(V1->part(part), V0->part(part)));
    add(a);

    }
    // Build multimesh form
    build();

    /// Assign coefficients

  }

  // Destructor
  ~MultiMeshForm_L()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_L_FunctionSpace_0 TestSpace;
  typedef Form_L_FunctionSpace_1 TrialSpace;
  typedef Form_L_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_L_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

// Class typedefs
typedef Form_a::TestSpace FunctionSpace;
typedef Form_a::MultiMeshTestSpace MultiMeshFunctionSpace;

}

#endif
